<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

if(preg_match('#/admin/browser/assets/functions.php#i', $_SERVER['REQUEST_URI']))
    exit('no access');

class WebutlerMBrowserClass extends WebutlerAdminClass
{
    //var $config;
    var $jsalert = '';
    var $AllowedExtensions;
    var $AvailableIcons;
    var $AllowedTypes;
    var $MediaDirectory;
    var $type;
    var $urltype;
    var $getthumb;
    
	function __construct() {
        require_once dirname(dirname(dirname(dirname(__FILE__)))).'/admin/browser/config.php';
    }
    
    function sendalert($text) {
    	$this->jsalert = "alert('".$text."');\n";
    	$this->jsalert.= "window.top.location.href = '".$this->config['homepage']."/admin/browser/index.php?".$this->urltype."&currentfolder=".$this->makeurlfolder($this->currentfolder()).$this->getthumb.$this->cke_getvars()."&admintoken=".$_SESSION['admintoken']."';";
    }
    
    function filterzahlen($variablezahlen) {
    	$variablezahlen = preg_replace('/[^0-9]/', '', $variablezahlen);
    	return $variablezahlen;
    }
    
    function filterupload($variableupload) {
    	$extension = strtolower(substr($variableupload, strrpos($variableupload, '.') + 1));
    	$filename = substr($variableupload, 0, strrpos($variableupload, '.'));
        
    	$filename = str_replace(' ', '_', $filename);
    	$filename = strtolower($filename);
    	$filename = preg_replace('/[^a-z0-9_]/', '', $filename);
        
    	return $filename.'.'.$extension;
    }
    
    function cleanpathfromget($path)
    {
    	//$path = utf8_decode($path);
    	$path = rawurldecode($path);
    	$path = strip_tags($path);
    	$path = stripslashes($path);
    	$path = str_replace($this->config['server_path'], '', $path);
    	$path = str_replace($this->config['homepage'], '', $path);
    	$path = str_replace(array('../', '..\\'), array('', ''), $path);
    	//$path = str_replace('\\', '', $path);
    	
    	return $path;
    }
    	
    function cke_getvars()
    {
        $getvars = '';
        $getvars .= isset($_GET['CKEditor']) ? '&CKEditor='.preg_replace('/[^a-z0-9_]/', '', $_GET['CKEditor']) : '';
        $getvars .= isset($_GET['CKEditorFuncNum']) ? '&CKEditorFuncNum='.preg_replace('/[^0-9]/', '', $_GET['CKEditorFuncNum']) : '';
        $getvars .= isset($_GET['langCode']) ? '&langCode='.preg_replace('/[^a-z]/', '', $_GET['langCode']) : '';
        
    	return $getvars;
    }
    	
    function makeurlfolder($urlfolder)
    {
    	//$urlfolder = rawurlencode(utf8_encode($urlfolder));
    	$urlfolder = rawurlencode($urlfolder);
    	return $urlfolder;
    }
    
    function currentfolder()
    {
    	if(isset($_GET['currentfolder']))
    	{
    		$currentfolder = $this->cleanpathfromget($_GET['currentfolder']);
    		if(!preg_match('#/$#', $currentfolder))
    		{
    			$currentfolder .= '/';
    		}
    		if(strpos($currentfolder, '/') !== 0)
    		{
    			$currentfolder = '/'.$currentfolder;
    		}
    		return $currentfolder;
    	}
    	else
    	{
    		return '/';
    	}
    }
    
    function lastfolder()
    {
    	$folderpath = $this->currentfolder();
    	$killlastslash = substr($folderpath, 0, -1);
    	$lastfolder = substr($killlastslash, 0, strrpos($killlastslash, '/'));
    	return $lastfolder.'/';
    }
    
    function seticon($datei)
    {
    	$icon = substr($datei, strrpos($datei, '.') + 1);
    	$icon = strtolower($icon);
    	if(in_array($icon, $this->AvailableIcons))
    	{
    		return $icon;
    	}
    	else
    	{
    		return 'default';
    	}
    }
    
    function fileactionpath()
    {
    	$fileactionpath = $this->MediaDirectory.$this->type.$this->currentfolder();
    
    	return $fileactionpath;
    }
    
    function fileexists($file)
    {
    	$file = $this->cleanpathfromget($file);
    	$file = str_replace( '/', '', $file );
    
    	if(file_exists($this->fileactionpath().$file)) 
    	{
    		return $file;
    	}
    	else
    	{
    	    $this->sendalert(_WBLANGADMIN_BROWSER_FILENOTEXISTS_);
    	}
    }
	
	function is_ani_gif($file)
	{
		if(!($fh = @fopen($file, 'rb')))
			return false;
		
		//an animated gif contains multiple "frames", with each frame having a
		//header made up of:
		// * a static 4-byte sequence (\x00\x21\xF9\x04)
		// * 4 variable bytes
		// * a static 2-byte sequence (\x00\x2C) (some variants may use \x00\x21 ?)
		
		// We read through the file til we reach the end of the file, or we've found
		// at least 2 frame headers
		
		$count = 0;
		$chunk = false;
		while(!feof($fh) && $count < 2)
		{
			//add the last 20 characters from the previous string, to make sure the searched pattern is not split.
			$chunk = ($chunk ? substr($chunk, -20) : '').fread($fh, 1024 * 100); //read 100kb at a time
			$count += preg_match_all('#\x00\x21\xF9\x04.{4}\x00(\x2C|\x21)#s', $chunk, $matches);
		}

		fclose($fh);
		return $count > 1;
	}
	
    
    function renamefileto($oldname, $newname)
    {
        $path = $this->MediaDirectory.$this->type.$this->currentfolder();
        if(strrpos($oldname, '.') == '')
        {
			if(file_exists($path.$newname))
				$newfile = $this->generateautofilename($path, $newname);
            else
				$newfile = $newname;
        }
        else
        {
    		$extension = substr($oldname, strrpos($oldname, '.') + 1);
        	$extension = strtolower($extension);
			
			if(file_exists($path.$newname.'.'.$extension))
				$newfile = $this->generateautofilename($path, $newname.'.'.$extension);
            else
				$newfile = $newname.'.'.$extension;
        }
        rename($path.$oldname, $path.$newfile);
		
		if($this->type == 'image' && file_exists($path.'.box/'.$oldname)) {
			rename($path.'.box/'.$oldname, $path.'.box/'.$newfile);
		}
    }
    
    function copyfilefromto($data, $unlink = false)
    {
        $file = explode('|', $data);
        $filepath = $file[0];
        $filename = $file[1];
        $frompath = $this->MediaDirectory.$this->type.$filepath;
        $topath = $this->MediaDirectory.$this->type.$this->currentfolder();
	    $skipsys = $this->currentfolder() == '/watermarks/' || $this->currentfolder() == '/tpl_icons/' ? true : false;
        
        $filefrom = $frompath.$filename;
		
		if(file_exists($topath.$filename))
			$tofilename = $this->generateautofilename($topath, $filename);
		else
			$tofilename = $filename;
		
		$fileto = $topath.$tofilename;
        
        copy($filefrom, $fileto);
		if($unlink)
            unlink($filefrom);
        
	    if($this->type == 'image' && file_exists($frompath.'.box/'.$filename))
	    {
            $boxfilefrom = $frompath.'.box/'.$filename;
            $boxfolder = $topath.'.box/';
            $boxfileto = $boxfolder.$tofilename;
            
			if(!$skipsys && !file_exists($boxfolder)) 
			{
				$oldumask = umask(0);
				mkdir($boxfolder, $this->config['chmod'][0]);
				umask($oldumask);
			}
            
    		if(file_exists($boxfilefrom)) {
				if(!$skipsys)
					copy($boxfilefrom, $boxfileto);
				
        		if($unlink)
                    unlink($boxfilefrom);
            }
	    }
    }
    
    function delete($file)
    {
		if($this->fileexists($file))
		{
			$datei = $this->fileactionpath().$file;
			$candelete = true;
			$error = false;
				
			if(is_dir($datei.'/'))
			{
				$verzeichnis = opendir($datei);
				while(false !== ($inhalt = readdir($verzeichnis)))
				{
					if ($inhalt != '' && $inhalt != '.' && $inhalt != '..')
					{
						$candelete = false;
					}
				}
				closedir($verzeichnis);
				
				if(!$candelete)
				{
					$error = true;
					$this->sendalert(_WBLANGADMIN_BROWSER_DELONLYEMPTY_);
				}
				else
				{
					if(!rmdir($datei.'/'))
					{
						$error = true;
						$this->sendalert(_WBLANGADMIN_BROWSER_THISFOLDER_.' '.$file.' '._WBLANGADMIN_BROWSER_NOTDELETEABLE_);
					}
				}
			}
			else
			{
				$datei = $this->fileactionpath().$file;
				$format = GetImageSize($datei);
				if($format)
				{
					$boxfile = $this->fileactionpath().'.box/'.$file;
					if(file_exists($boxfile))
					{
						unlink($boxfile);
					}
				}
				
				if(!unlink($datei))
				{
					$error = true;
					$this->sendalert(_WBLANGADMIN_BROWSER_THISFILE_.' '.$file.' '._WBLANGADMIN_BROWSER_NOTDELETEABLE_);
				}
			}
			
			if(!$error) {
				$location = $this->getserverlocation();
				//header('Location: '.$location);
				unset($_GET['delete']);
				$getvars = array();
				foreach($_GET as $key => $val)
				{
					$getvars[] = $key.'='.($key == 'currentfolder' ? $this->makeurlfolder($val) : $val);
				}
				
				header('Location: '.$location.'?'.implode('&', $getvars));
			}
		}
    }
    
    function getserverlocation()
    {
		/*
        $location = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https://' : 'http://');
        $location.= $_SERVER['HTTP_HOST'];
        $location.= $_SERVER['REDIRECT_URL'];
		*/
		$location = $this->config['homepage'].'/admin/browser/index.php';
        
        return $location;
    }
    
    function makefolder($name)
    {
		/*
		$name = strip_tags($name);
		$name = stripslashes($name);
		$name = trim($name);
		$name = str_replace('.', ' ', $name);
		$name = str_replace('-', ' ', $name);
		$name = preg_replace('/( +)/', '_', $name);
		$name = $this->filterupload($name);
		*/
		$name = preg_replace('/[^a-z0-9_]/', '', strtolower($name));
		
		if($name != '') 
		{
			$newfolder = $this->fileactionpath().$name;
			if(!file_exists($newfolder)) 
			{
				$oldumask = umask(0);
				if(mkdir($newfolder, $this->config['chmod'][0]))
				{
					umask($oldumask);
					$this->sendalert(sprintf(_WBLANGADMIN_BROWSER_FOLDERADDED_, $name));
				}
				else
				{
					$this->sendalert(sprintf(_WBLANGADMIN_BROWSER_FOLDERNOTADDED_, $name));
				}
			}
			else
			{ 
				$this->sendalert(sprintf(_WBLANGADMIN_BROWSER_FOLDEREXISTS_, $name));
			}
		}  
		else
		{
			$this->sendalert(_WBLANGADMIN_BROWSER_NOFOLDERNAME_);
		}
    }
    
    function converttowebp($imagefile)
    {
		if($this->config['convert_webp'] == 1)
		{
			list($imgwidth, $imgheight, $type) = getimagesize($imagefile);
			$mode = ord(file_get_contents($imagefile, NULL, NULL, 25, 1));
			
			/*
			if($type == 3 && $mode == 3)
			{
				$temp_img = imagecreatefromstring(file_get_contents($imagefile));
				$temp_name = substr($imagefile, 0, strrpos($imagefile, '.'));
				$imagefile = $temp_name.'.gif';
				imagegif($temp_img, $imagefile);
				imagedestroy($temp_img);
				$type = 1;
			}
			*/
			
			switch($type)
			{
				case 1: $image = imagecreatefromgif($imagefile); break;
				case 2: $image = imagecreatefromjpeg($imagefile); break;
				case 3: $image = imagecreatefrompng($imagefile); break;
			}
			
			if(isset($image))
			{
				if($type == 1 || ($type == 3 && $mode == 3)) // gif || png indiziert
				{
					$newimage = imagecreate($imgwidth, $imgheight);
					$black = imagecolorallocate($newimage, 0x00, 0x00, 0x00);
					$trans = imagecolortransparent($newimage, $black);
					imagefill($newimage, 0, 0, $trans);
					imagepalettetotruecolor($newimage);
				}
				else
				{
					$newimage = imagecreatetruecolor($imgwidth, $imgheight);
				}
				
				if($type == 3 && $mode == 6) // png
				{
					imagecolortransparent($newimage, imagecolorallocatealpha($newimage, 0, 0, 0, 127));
					imagealphablending($newimage, false);
					imagesavealpha($newimage, true);
				}
				
				imagecopyresampled($newimage, $image, 0, 0, 0, 0, $imgwidth, $imgheight, $imgwidth, $imgheight);
					
				$filename = substr($imagefile, 0, strrpos($imagefile, '.'));
				imagewebp($newimage, $filename.'.webp', 100);
				unlink($imagefile);
				
				imagedestroy($image);
				imagedestroy($newimage);
			}
		}
    }
    
    function resizeimage($imagefile, $imgwidth, $imgheight)
    {
	    if($imgwidth > 0 || $imgheight > 0) {
			list($orgwidth, $orgheight, $type) = getimagesize($imagefile);
			$mode = ord(file_get_contents($imagefile, NULL, NULL, 25, 1));
			
			$cropwidth = $imgwidth > 0 && $orgwidth > $imgwidth ? $imgwidth : $orgwidth*($imgheight/$orgheight);
			$cropheight = $imgheight > 0 && $orgheight > $imgheight ? $imgheight : $orgheight*($imgwidth/$orgwidth);
			
			if($cropwidth > 0 && $cropheight > 0 && ($type == 1 || $type == 2 || $type == 3 || $type == 18)) {
				switch($type) {
					case 1: $image = imagecreatefromgif($imagefile); break;
					case 2: $image = imagecreatefromjpeg($imagefile); break;
					case 3: $image = imagecreatefrompng($imagefile); break;
					case 18: $image = imagecreatefromwebp($imagefile); break;
				}
				
				if(isset($image))
				{
					if($imgwidth > 0 && $imgheight > 0) {
						$ratio = max($cropwidth/$orgwidth, $cropheight/$orgheight);
						$pos_x = intval(($orgwidth - $cropwidth / $ratio) / 2);
						$pos_y = intval(($orgheight - $cropheight / $ratio) / 2);
						$orgwidth = intval($cropwidth / $ratio);
						$orgheight = intval($cropheight / $ratio);
					}
					else {
						$pos_x = 0;
						$pos_y = 0;
					}
					
					if($type == 1 || ($type == 3 && $mode == 3)) {
						$newimage = imagecreate($cropwidth, $cropheight);
						$black = imagecolorallocate($newimage, 0x00, 0x00, 0x00);
						$trans = imagecolortransparent($newimage, $black);
						imagefill($newimage, 0, 0, $trans);
						imagepalettetotruecolor($newimage);
					}
					else {
						$newimage = imagecreatetruecolor($cropwidth, $cropheight);
					}
					
					if(($type == 3 && $mode == 6) || $type == 18) {
						imagecolortransparent($newimage, imagecolorallocatealpha($newimage, 0, 0, 0, 127));
						imagealphablending($newimage, false);
						imagesavealpha($newimage, true);
					}
					
					imagecopyresampled($newimage, $image, 0, 0, $pos_x, $pos_y, $cropwidth, $cropheight, $orgwidth, $orgheight);
					
					if($this->config['webp_quality'] == '') $this->config['webp_quality'] = 99;
					if($this->config['jpg_quality'] == '') $this->config['jpg_quality'] = 99;
					if($this->config['png_compress'] == '') $this->config['png_compress'] = 0;
					
					switch($type) {
						case 1: imagegif($newimage, $imagefile); break;
						case 2: imagejpeg($newimage, $imagefile, $this->config['jpg_quality']); break;
						case 3: imagepng($newimage, $imagefile, $this->config['png_compress']); break;
						case 18: imagewebp($newimage, $imagefile, $this->config['webp_quality']); break;
					}
					
					imagedestroy($image);
					imagedestroy($newimage);
				}
			}
		}
    }
    
    function resourcetype($type)
    {
    	if($type == 'file') {
    		$resource = _WBLANGADMIN_BROWSER_RESOURCE_FILE_;
    	}
    	if($type == 'image') {
    		$resource = _WBLANGADMIN_BROWSER_RESOURCE_IMAGE_;
    	}
    	if($type == 'track') {
    		$resource = _WBLANGADMIN_BROWSER_RESOURCE_TRACK_;
    	}
    	return $resource;
    }
    
    function resourcetitle($type)
    {
		if($type == 'file') {
			$title = _WBLANGADMIN_BROWSER_RESOURCE_ALLFORMATS_;
		}
		else {
			$title = _WBLANGADMIN_BROWSER_RESOURCE_FORMATS_.': ';
			$laenge = count($this->AllowedExtensions[$type]);
			
			for($i = 0; $i < $laenge; $i++)
			{
				$title .= $this->AllowedExtensions[$type][$i];
				if($i < ($laenge-1))
				{
					$title .= ', ';
				}
			}
		}
    
    	return $title;
    }
    
    function generateautofilename($path, $file)
    {
		$name = substr($file, 0, strrpos($file, '.'));
		$ext = substr($file, strrpos($file, '.'));
		
		$count = 0;
        $stop = false;
        while(!$stop) {
			$count++;
			$nameneu = $name.'_'.$count.$ext;
			if(!file_exists($path.$nameneu))
				$stop = true;
		}
		
		return $nameneu;
    }
    
	function uploadfile($filename, $overwrite, $imgsmallwidth, $imgsmallheight, $imgboxwidth, $imgboxheight, $lightbox, $live = false)
    {
		if($filename != '')
		{
			$filename = rawurldecode($filename);
			$filename = preg_replace('/\\.(?![^.]*$)/', '_', $filename);
			
			$imgsmallwidth = $this->filterzahlen($imgsmallwidth);
			$imgsmallheight = $this->filterzahlen($imgsmallheight);
			$imgboxwidth = $this->filterzahlen($imgboxwidth);
			$imgboxheight = $this->filterzahlen($imgboxheight);
			
			$extension = substr($filename, strrpos($filename, '.') + 1);
			$extension = strtolower($extension);
			
			$nameneu = $this->filterupload($filename);
			$dateipath = $this->fileactionpath().$nameneu;
			
			if($this->config['convert_webp'] == 1 && ($extension == 'jpg' || $extension == 'jpeg' || $extension == 'png' || $extension == 'gif'))
			//if($this->config['convert_webp'] == 1)
			{
				$namewebp = substr($nameneu, 0, strrpos($nameneu, '.')).'.webp';
				$dateiwebppath = $this->fileactionpath().$namewebp;
				
				if(file_exists($dateipath))
				{
					unlink($dateipath);
					
					$boxfile = $this->fileactionpath().'.box/'.$nameneu;
					if(file_exists($boxfile))
						unlink($boxfile);
				}
				
				if(file_exists($dateiwebppath))
				{
					if($overwrite) {
						unlink($dateiwebppath);
						
						$boxfile = $this->fileactionpath().'.box/'.$namewebp;
						if(file_exists($boxfile))
							unlink($boxfile);
					}
					else {
						$namewebp = $this->generateautofilename($this->fileactionpath(), $namewebp);
						$dateiwebppath = $this->fileactionpath().$namewebp;
					}
				}
			}
			else {
				if(file_exists($dateipath))
				{
					if($overwrite) {
						unlink($dateipath);
						
						$boxfile = $this->fileactionpath().'.box/'.$nameneu;
						if(file_exists($boxfile))
							unlink($boxfile);
					}
					else {
						$nameneu = $this->generateautofilename($this->fileactionpath(), $nameneu);
						$dateipath = $this->fileactionpath().$nameneu;
					}
				}
			}
			
			if(!file_exists($dateipath))
			{
				if($this->type == 'file' || in_array($extension, $this->AllowedExtensions[$this->type]))
				{
					if($this->type == 'image' && $this->currentfolder() != '/watermarks/' && $this->currentfolder() != '/tpl_icons/')
					{
						$boxfolder = $this->fileactionpath().'.box/';
						if(!file_exists($boxfolder)) 
						{
							$oldumask = umask(0);
							mkdir($boxfolder, $this->config['chmod'][0]);
							umask($oldumask);
						}
						$dateiboxpath = $boxfolder.$nameneu;
						
						$dateitemppath = $this->config['server_path'].'/content/media/temp/'.$nameneu;
						$file = fopen($dateitemppath, 'w');
						$upload = fopen('php://input', 'r');
						
						while($data = fread($upload, 4096))
						{
							fwrite($file, $data);
						}
						
						fclose($file);
						fclose($upload);
						
						if($this->is_ani_gif($dateitemppath))
						{
							copy($dateitemppath, $dateipath);
							unlink($dateitemppath);
						}
						else
						{
							if(isset($namewebp) && isset($dateiwebppath)) {
								$this->converttowebp($dateitemppath);
								
								$nameneu = $namewebp;
								$dateipath = $dateiwebppath;
								$dateiboxpath = $boxfolder.$nameneu;
								
								$dateiconvtemppath = substr($dateitemppath, 0, strrpos($dateitemppath, '.')).'.webp';
								copy($dateiconvtemppath, $dateiboxpath);
								unlink($dateiconvtemppath);
							}
							else
							{
								copy($dateitemppath, $dateiboxpath);
								unlink($dateitemppath);
							}
						
							$this->setchmodaftersave($dateiboxpath);
							
							copy($dateiboxpath, $dateipath);
							
							if($lightbox && ($imgboxwidth > 0 || $imgboxheight > 0))
								 $this->resizeimage($dateiboxpath, $imgboxwidth, $imgboxheight);
							
							if($imgsmallwidth > 0 || $imgsmallheight > 0)
								$this->resizeimage($dateipath, $imgsmallwidth, $imgsmallheight);
						}
						
						$this->setchmodaftersave($dateipath);
						
						if(!$lightbox)
							unlink($dateiboxpath);
						
						if(!$live) {
							echo sprintf(_WBLANGADMIN_BROWSER_FILEUPLOADED_, $nameneu);
						}
						else {
							list($smallwidth, $smallheight) = getimagesize($dateipath);
							$jsonresult = array('uploaded' => 1, 'fileName' => $nameneu, 'url' => 'content/media/image'.$this->currentfolder().$nameneu, 'attributes' => array('width' => $smallwidth, 'height' => $smallheight));
							echo json_encode($jsonresult);
						}
					}
					else
					{
						$file = fopen($dateipath, 'w');
						$upload = fopen('php://input', 'r');
						
						while($data = fread($upload, 4096))
						{
							fwrite($file, $data);
						}
						
						fclose($file);
						fclose($upload);
						
						$this->setchmodaftersave($dateipath);
						
						if($this->currentfolder() == '/watermarks/' || $this->currentfolder() == '/tpl_icons/')
						{
							if(isset($namewebp) && isset($dateiwebppath))
							{
								if(file_exists($dateiwebppath))
									unlink($dateiwebppath);
								
								$this->converttowebp($dateipath);
								
								$nameneu = $namewebp;
								$dateipath = $dateiwebppath;
							}
							
							$this->resizeimage($dateipath, 300, 0);
						}
						
						echo sprintf(_WBLANGADMIN_BROWSER_FILEUPLOADED_, $nameneu);
					}
				}
				else
				{
					if(!$live) {
						echo sprintf(_WBLANGADMIN_BROWSER_FILEWRONGFORMAT_, $extension, $this->resourcetype($this->type));
					}
					else {
						echo json_encode(array('uploaded' => 0, 'error' => array('message' => sprintf(_WBLANGADMIN_BROWSER_FILEWRONGFORMAT_, $extension, $this->resourcetype($this->type)))));
					}
				}
			}
		}
		else
		{
			echo _WBLANGADMIN_BROWSER_NOFILE_;
		}
    }
	
	function format_filesize($file)
	{
		$bytes = filesize($file);
		
		if($bytes >= 1073741824)
			$bytes = number_format($bytes/1073741824, 2).' GB';
		elseif($bytes >= 1048576)
			$bytes = number_format($bytes/1048576, 2).' MB';
		elseif($bytes >= 1024)
			$bytes = number_format($bytes/1024).' KB';
		elseif($bytes > 0)
			$bytes = number_format($bytes/1024, 1).' KB';
		else
			$bytes = '0 Bytes';

		return $bytes;
	}
    
    function get_folders($dateien)
    {
        $result = '';
		$firstline = true;
        
        if(is_dir($dateien))
        {
            $verzeichnis = opendir($dateien);
            while(false !== ($inhalt = readdir($verzeichnis)))
            {
            	if($inhalt != '.' && $inhalt != '..' && $inhalt != '.box')
            	{
            		if(is_dir($dateien.'/'.$inhalt.'/'))
            		{
            			if((($inhalt == 'watermarks' || $inhalt == 'tpl_icons') && ($this->config['admin_advanced'] != '1' || (isset($_SESSION['loggedin']['userismaster']) && $_SESSION['loggedin']['userismaster'] == '1'))) || ($inhalt != 'watermarks' && $inhalt != 'tpl_icons'))
            			{
                			$result.= '<tr';
							if($this->type != 'image' && $firstline) {
								$result.= ' class="firstline"';
								$firstline = false;
							}
                			$result.= '>';
                			$result.= '<td width="21"><img alt="" src="images/folder.gif" style="margin-right: 5px" /></td>';
                			$result.= '<td style="word-space: nowrap"><a href="index.php?'.$this->urltype.'&currentfolder='.$this->makeurlfolder($this->currentfolder().$inhalt.'/').$this->getthumb.$this->cke_getvars().'&admintoken='.$_SESSION['admintoken'].'">'.$inhalt.'</a>';
                            $result.= ($inhalt != 'watermarks' && $inhalt != 'tpl_icons') ? '<div class="tooltip tipleft" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_RENAME_.'"><img alt="" src="images/edit.png" onclick="renamepopupopen(\''.$inhalt.'\')" class="renameedit" /></div>' : '';
                            $result.= '</td>';
                			$result.= '<td>&nbsp;</td>';
                			$result.= '<td>&nbsp;</td>';
                			if($this->type == 'image')
                			{
                				$result.= '<td>&nbsp;</td>';
                			}
                			if($inhalt == 'watermarks' || $inhalt == 'tpl_icons')
                			{
                				$result.= '<td>&nbsp;</td>';
                				$result.= '<td>&nbsp;</td>';
                				$result.= '<td>&nbsp;</td>';
                			}
                			else
                            {
                                $result.= '<td width="18">&nbsp;</td>
                                    <td width="18">&nbsp;</td>
                                    <td width="18"><span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_DELETE_.'" onclick="DeleteFile(\''.$inhalt.'\');return false;"><img alt="" src="images/trash.gif" style="margin: 0px 0px 0px 3px" /></span></td>';
                			}
                			$result.= '</tr>';
            			}
            		}
            	}
            }
            closedir($verzeichnis);
        }
        
        return $result;
    }
    
    function get_files($dateien, $first)
    {
        $result = '';
		$firstline = true;
        
        if(is_dir($dateien))
        {
    		if(isset($_GET['vorschau']) && $this->type == 'image') {
    			$result.= '<tr>
    			  <td class="previewimgs" colspan="8">';
    		}
            $verzeichnis = opendir($dateien);
            while(false !== ($inhalt = readdir($verzeichnis)))
            {
            	if($inhalt != '.' && $inhalt != '..' && $inhalt != '.box')
            	{
            		if(is_file($dateien.'/'.$inhalt))
            		{
            			$icon = $this->seticon($inhalt);
            			$filesize = $this->format_filesize($dateien.'/'.$inhalt);
            			if($this->type == 'image') {
							$format = GetImageSize($dateien.'/'.$inhalt);
							$wh = ($format && $format[0] < $format[1]) ? 'height' : 'width';
						}
            			
            			if(isset($_GET['vorschau']) && $this->type == 'image') {
                		  $result.= '<div style="float: left; width: 125px; margin: 5px; border: 1px solid #373737">
                        	<table border="0" cellspacing="5" cellpadding="0">
                        	  <tr>
                        		<td style="width: 115px; height: 115px; background-color: #e9e9e9; text-align: center">';
                                if($this->currentfolder() == '/watermarks/') {
                				    $result.= '<span class="noinsert" style="display:block;line-height:0;"><img title="'.$inhalt.'" alt="" style="'.$wh.': 109px; margin: 3px" src="'.$this->config['homepage'].'/content/media/'.$this->type.$this->currentfolder().$inhalt.'" /></span>';
                                } elseif($this->currentfolder() == '/tpl_icons/') {
                				    $result.= '<span style="display:block;line-height:0;" onclick="setTplIcon(\''.$inhalt.'\');return false;"><img title="'.$inhalt.'" alt="" style="'.$wh.': 109px; margin: 3px" src="'.$this->config['homepage'].'/content/media/'.$this->type.$this->currentfolder().$inhalt.'" /></span>';
                                } else {
                                    $result.= '<span style="display:block;line-height:0;'.(isset($_GET['CKEditor']) ? 'cursor:pointer' : '').'" title="'.$inhalt.' '._WBLANGADMIN_BROWSER_IMAGE_INSERT_.'" onclick="OpenFile(\'content/media/'.$this->type.$this->currentfolder().$inhalt.'\');return false;"><img alt="" style="'.$wh.': 109px; margin: 3px" src="'.$this->config['homepage'].'/content/media/'.$this->type.$this->currentfolder().$inhalt.'" /></span>';
                                }
                                $result.= '</td>
                        	  </tr>
                        	  <tr>
                        		<td style="height: 15px; text-align: right; vertical-align: bottom"><img alt="" src="images/icons/'.$icon.'.gif" style="margin: 0px 3px -2px 0px" /> '.$filesize.' ';
								if($this->is_ani_gif($dateien.'/'.$inhalt))
									$result.= '<span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_ANIGIF_.'"><img alt="" src="images/brush.png" class="isanigif" style="margin: 0px 3px -1px 3px" /></span> ';
								else
									$result.= '<span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_IMGEDIT_.' - '.$this->currentfolder().$inhalt.'" onclick="OpenEditWin(\''.$this->config['homepage'].'\', \''.$this->currentfolder().$inhalt.'\');return false;"><img alt="" src="images/brush.png" style="margin: 0px 3px -1px 3px" /></span> ';
								$result.= '<span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_DELETE_.'" onclick="DeleteFile(\''.$inhalt.'\');return false;"><img alt="" src="images/trash.gif" style="margin-bottom: -2px" /></span></td>
                        	  </tr>
                        	</table>
                		  </div>';
            			}
            			else {
                			$result.= '<tr';
							if($first && $firstline) {
								$result.= ' class="firstline"';
								$firstline = false;
							}
							$result.= '>';
                			if($icon == 'mp3' && (!isset($_GET['types']) || $_GET['types'] == ''))
                			{
                				$result.= '<td style="width: 21px"><img alt="" src="images/icons/'.$icon.'.gif" style="margin-right: 5px" /></td>
                				  <td style="word-space: nowrap"><span '.(isset($_GET['CKEditor']) ? 'style="cursor:pointer" ' : '').'onclick="OpenFile(\'content/media/'.$this->type.$this->currentfolder().$inhalt.'\');return false;">'.$inhalt.'</span><div class="tooltip tipleft" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_RENAME_.'"><img alt="" src="images/edit.png" onclick="renamepopupopen(\''.$inhalt.'\')" class="renameedit" /></div></td>';
                			}
                			else
                			{
                				$result.= '<td style="width: 21px"><img alt="" src="images/icons/'.$icon.'.gif" style="margin-right: 5px" /></td>
                                <td style="word-space: nowrap">';
                                if($this->currentfolder() == '/watermarks/') {
                				    $result.= '<span class="noinsert">'.$inhalt.'</span>';
								}
                                elseif($this->currentfolder() == '/tpl_icons/') {
                				    $result.= '<span onclick="setTplIcon(\''.$inhalt.'\');return false;">'.$inhalt.'</span>';
								}
                                else {
                				    $result.= '<span '.(isset($_GET['CKEditor']) ? 'style="cursor:pointer" ' : '').'onclick="OpenFile(\'content/media/'.$this->type.$this->currentfolder().$inhalt.'\');return false;">'.$inhalt.'</span>';
								}
                                    
                                $result.= '<div class="tooltip tipleft" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_RENAME_.'"><img alt="" src="images/edit.png" onclick="renamepopupopen(\''.$inhalt.'\')" class="renameedit" /></div>';
								if($this->type == 'image' && $this->currentfolder() != '/watermarks/' && $this->currentfolder() != '/tpl_icons/' && !file_exists($dateien.'/.box/'.$inhalt)) {
									$result.= '<div class="tooltip tipleft" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_HASNOBOXIMG_.'"><img alt="" src="images/box.png" class="hasnoboximg" /></div>';
								}
	//$result.= ord(file_get_contents($dateien.'/'.$inhalt, NULL, NULL, 25, 1));
								$result.= '</td>';
                			}
                			$result.= '<td style="text-align: right; word-space: nowrap">'.$filesize.'</td>';
                			$result.= '<td style="width: 21px"><span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_PREVIEW_.'" onclick="OpenWindow(\''.$this->config['homepage'].'/content/media/'.$this->type.$this->currentfolder().$inhalt.'\', \''._WBLANGADMIN_BROWSER_PREVIEW_.'\')"><img alt="" src="images/show.png" style="margin: 0px 3px" /></span></td>';
							
                			if($this->type == 'image')
                			{
								if($this->is_ani_gif($dateien.'/'.$inhalt))
									$result.= '<td style="width: 21px"><span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_ANIGIF_.'"><img alt="" src="images/brush.png" class="isanigif" style="margin: 0px 3px" /></span></td>';
								else
									$result.= '<td style="width: 21px"><span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_IMGEDIT_.'" onclick="OpenEditWin(\''.$this->config['homepage'].'\', \''.$this->currentfolder().$inhalt.'\');return false;"><img alt="" src="images/brush.png" style="margin: 0px 3px" /></span></td>';
                			}
                            $result.= '<td style="width: 21px">';
                            if(isset($_SESSION['copy'.$this->type]) && $_SESSION['copy'.$this->type] == $this->currentfolder().'|'.$inhalt)
                            {
                                $result.= '<img alt="" src="images/copied.png" style="margin: 0px 3px" />';
                            }
                            else
                            {
                                $result.= '<form method="post"><input type="hidden" name="copyfile" value="'.$this->currentfolder().'|'.$inhalt.'" /><div class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_COPY_.'"><input type="image" name="copy" src="images/copy.png" style="margin: 0px 3px" /></div></form>';
                            }
                            $result.= '</td>
                                <td style="width: 21px">';
                            if(isset($_SESSION['cut'.$this->type]) && $_SESSION['cut'.$this->type] == $this->currentfolder().'|'.$inhalt)
                            {
                                $result.= '<img alt="" src="images/cutted.png" style="margin: 0px 3px" />';
                            }
                            else
                            {
                                $result.= '<form method="post"><input type="hidden" name="cutoutfile" value="'.$this->currentfolder().'|'.$inhalt.'" /><div class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_CUT_.'"><input type="image" name="cutout" src="images/cutout.png" style="margin: 0px 3px" /></div></form>';
                            }
                            $result.= '</td>
                                <td style="width: 18px"><span class="tooltip tipright" data-tooltip="'._WBLANGADMIN_BROWSER_ICON_DELETE_.'" onclick="DeleteFile(\''.$inhalt.'\');return false;"><img alt="" src="images/trash.gif" style="margin: 0px 0px 0px 3px" /></span></td>
                			  </tr>';
            			}
            		}
            	}
            }
            closedir($verzeichnis);
    		if(isset($_GET['vorschau']) && $this->type == 'image') {
    			$result.= '</td>
    			  </tr>';
    		}
        }
        
        return $result;
    }
}


