
/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/


CKEDITOR.plugins.addExternal( 'savetemppage', 'wb_ckeplugins/savetemppage/' );
CKEDITOR.plugins.addExternal( 'savepage', 'wb_ckeplugins/savepage/' );
CKEDITOR.plugins.addExternal( 'closeeditor', 'wb_ckeplugins/closeeditor/' );
CKEDITOR.plugins.addExternal( 'uioptselect', 'wb_ckeplugins/uioptselect/' );
CKEDITOR.plugins.addExternal( 'disabletoolbar', 'wb_ckeplugins/disabletoolbar/' );
CKEDITOR.plugins.addExternal( 'columns', 'wb_ckeplugins/columns/' );
CKEDITOR.plugins.addExternal( 'browser', 'wb_ckeplugins/browser/' );
CKEDITOR.plugins.addExternal( 'audio', 'wb_ckeplugins/audio/' );
CKEDITOR.plugins.addExternal( 'video', 'wb_ckeplugins/video/' ); 
CKEDITOR.plugins.addExternal( 'softhyphen', 'wb_ckeplugins/softhyphen/' );
CKEDITOR.plugins.addExternal( 'lazyload', 'wb_ckeplugins/lazyload/' );
CKEDITOR.plugins.addExternal( 'lightbox', 'wb_ckeplugins/lightbox/' );
CKEDITOR.plugins.addExternal( 'formchanges', 'wb_ckeplugins/formchanges/' );
CKEDITOR.plugins.addExternal( 'formfields', 'wb_ckeplugins/formfields/' );
CKEDITOR.plugins.addExternal( 'formsendto', 'wb_ckeplugins/formsendto/' );
CKEDITOR.plugins.addExternal( 'pagelinks', 'wb_ckeplugins/pagelinks/' );
CKEDITOR.plugins.addExternal( 'leafletmap', 'wb_ckeplugins/leafletmap/' );
CKEDITOR.plugins.addExternal( 'imageedit', 'wb_ckeplugins/imageedit/' );
CKEDITOR.plugins.addExternal( 'sortmenu', 'wb_ckeplugins/sortmenu/' );
CKEDITOR.plugins.addExternal( 'pastedupload', 'wb_ckeplugins/pastedupload/' );
CKEDITOR.plugins.addExternal( 'cssclassparser', 'wb_ckeplugins/cssclassparser/' );
CKEDITOR.plugins.addExternal( 'cssclasscombo', 'wb_ckeplugins/cssclasscombo/' );
CKEDITOR.plugins.addExternal( 'docprops', 'wb_ckeplugins/docprops/' );
CKEDITOR.plugins.addExternal( 'showprotected', 'wb_ckeplugins/showprotected/' );
CKEDITOR.plugins.addExternal( 'sourcedialog', 'wb_ckeplugins/sourcedialog/' );
CKEDITOR.plugins.addExternal( 'magicline', 'wb_ckeplugins/magicline/' );
CKEDITOR.plugins.addExternal( 'setdatatabu', 'wb_ckeplugins/setdatatabu/' );


CKEDITOR.editorConfig = function( config )
{
	config.docType = '<!DOCTYPE html>';
	config.skin = 'wbmoono,wb_ckeskin/wbmoono/';
	config.title = false;
	config.disableAutoInline = true;
	config.allowedContent = true;
	config.dialog_noConfirmCancel = true;
	config.toolbarCanCollapse = false;
	config.baseFloatZIndex = 9000;
	config.entities = false;
	config.basicEntities = true;
	config.entities_additional = '#39,quot';
	config.startupShowBorders = true;
	config.emailProtection = 'encode';
	config.stylesSet = [];
	
	config.disableObjectResizing = true;
	config.disableNativeTableHandles = true;
	
	config.fillEmptyBlocks = true;
	config.autoParagraph = true; //false;
	config.ignoreEmptyParagraph = false; //true;
	config.forceEnterMode = true; // p on enter inside div
	
	//config.pasteFromWordRemoveStyles = true;
	//config.pasteFromWordRemoveFontStyles = true;
	config.forcePasteAsPlainText = true;
	
	config.magicline_everywhere = false;
	config.magicline_holdDistance = 1.5;
	config.magicline_triggerOffset = 20;
	config.magicline_tabuList = ['data-cke-tabu-magicline'];
	config.magicline_freeList = ['data-cke-free-magicline'];
	
	config.image_prefillDimensions = false;
	config.templates_replaceContent = false;
	
    config.templates = 'usertemplates';
    config.templates_files = [ 'content/pattern/js/cketemplates.js' ];
	
	config.protectedSource.push( /<\?[\s\S]*?\?>/gi );
	config.protectedSource.push( /<script[\s\S]*?\/script>/gi );
	
	config.justifyClasses = [ 'alignleft', 'aligncenter', 'alignright', 'alignjustify' ];
	config.indentClasses = [ 'indent1', 'indent2', 'indent3', 'indent4', 'indent5', 'indent6', 'indent7', 'indent8', 'indent9', 'indent10' ];
	
	config.format_tags = 'p;div;h1;h2;h3;h4;h5;h6';
	
	config.fontSize_sizes = 'extra small/sizexsmall;smaller/sizesmaller;small/sizesmall;large/sizelarge;larger/sizelarger;extra large/sizexlarge';
	
	config.fontSize_style = {
		element: 'span',
		attributes: { 'class': '#(size)' },
		overrides: [ { element: 'font', attributes: { 'size': null } } ]
	};
	
	config.font_style =
    {
        element : 'span',
        attributes : { 'class': '#(family)' },
        overrides : [ { element: 'font', attributes: { 'face': null } } ]
    };
	
	config.menu_groups = 'clipboard,tablecell,tablecellproperties,tablerow,tablecolumn,table,anchor,link,image,imgedit,editprotected,div,form,formfelder,leafletmap,textfield,textarea,select,checkbox,radio,hiddenfield,button,imagebutton,sendtofield,softhyphen';
	
	config.imageUploadUrl = 'admin/browser/index.php?pasted=newfile&type=image&admintoken=' + adminToken;
    config.filebrowserBrowseUrl = 'admin/browser/index.php?opener=editor&admintoken=' + adminToken;
    config.filebrowserImageBrowseUrl = 'admin/browser/index.php?type=image&currentfolder=' + encodeURIComponent('/') + '&opener=editor&admintoken=' + adminToken;
    config.filebrowserImageBrowseLinkUrl = 'admin/browser/index.php?types=image&currentfolder=' + encodeURIComponent('/') + '&opener=editor&admintoken=' + adminToken;
	config.filebrowserAVBrowseUrl = 'admin/browser/index.php?type=track&av=only&currentfolder=' + encodeURIComponent('/') + '&opener=editor&admintoken=' + adminToken;
	config.filebrowserWindowFeatures = 'directories=no,location=no,menubar=no,status=no,toolbar=no,resizable=yes,scrollbars=no';
    
    config.toolbar_EditPage =
    [
    	{ name: 'document', items: ['Savetemp','Savepage','Closer','DocProps','Columns','Templates'] },
    	{ name: 'clipboard', items: ['Cut','Copy','Paste'] },
    	{ name: 'editing', items: ['Undo','Redo','Find','Replace','SelectAll','RemoveFormat'] },
    	{ name: 'basicstyles', items: ['Bold','Italic','Underline','Strike','SoftHyphen','Subscript','Superscript'] },
    	{ name: 'paragraph', items: ['NumberedList','BulletedList','Outdent','Indent','BidiLtr', 'BidiRtl','Blockquote'] },
    	{ name: 'justify', items: ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'] },
    	{ name: 'colors', items: ['TextColor','BGColor'] },
    	{ name: 'links', items: ['Link','Unlink','Anchor','Iframe'] },
    	{ name: 'medias', items: ['Media','Image','LeafletMap','Video','Audio','Embed'] },
    	{ name: 'insert', items: ['Table','CreateDiv','Form','HorizontalRule','ShowBlocks','SpecialChar'] },
    	{ name: 'styles', items: ['CSSClasses','Format','Font','FontSize'] },
    	{ name: 'source', items: ['Sourcedialog'] }
    ] ;
    
    config.toolbar_EditMenu =
    [
    	{ name: 'document', items: ['Save','Closer'] },
    	{ name: 'menu', items: ['SortMenu'] },
    	{ name: 'clipboard', items: ['Cut','Copy','Paste'] },
    	{ name: 'editing', items: ['Undo','Redo','RemoveFormat'] },
    	{ name: 'basicstyles', items: ['Bold','Italic','Underline','Strike'] },
    	{ name: 'paragraph', items: ['BulletedList','Outdent','Indent','BidiLtr', 'BidiRtl'] },
    	{ name: 'justify', items: ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'] },
    	{ name: 'colors', items: ['TextColor','BGColor'] },
    	{ name: 'links', items: ['Link','Unlink'] },
    	{ name: 'medias', items: ['Image','ShowBlocks','SpecialChar'] },
    	{ name: 'styles', items: ['CSSClasses'] },
    	{ name: 'source', items: ['Sourcedialog'] }
    ] ;
    
    config.toolbar_EditBlock =
    [
    	{ name: 'document', items: ['Save','Closer','Columns','Templates'] },
    	{ name: 'clipboard', items: ['Cut','Copy','Paste'] },
    	{ name: 'editing', items: ['Undo','Redo','Find','Replace','SelectAll','RemoveFormat'] },
    	{ name: 'basicstyles', items: ['Bold','Italic','Underline','Strike','SoftHyphen','Subscript','Superscript'] },
    	{ name: 'paragraph', items: ['NumberedList','BulletedList','Outdent','Indent','BidiLtr', 'BidiRtl','Blockquote'] },
    	{ name: 'justify', items: ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'] },
    	{ name: 'colors', items: ['TextColor','BGColor'] },
    	{ name: 'links', items: ['Link','Unlink','Anchor','Iframe'] },
    	{ name: 'medias', items: ['Media','Image','LeafletMap','Video','Audio','Embed'] },
    	{ name: 'insert', items: ['Table','CreateDiv','Form','HorizontalRule','ShowBlocks','SpecialChar'] },
    	{ name: 'styles', items: ['CSSClasses','Format','Font','FontSize'] },
    	{ name: 'source', items: ['Sourcedialog'] }
    ] ;

    config.toolbar_EditContent =
    [
    	{ name: 'document', items: ['Savetemp','Savepage','Closer','DocProps','Columns','Templates'] },
    	{ name: 'clipboard', items: ['Cut','Copy','Paste'] },
    	{ name: 'editing', items: ['Undo','Redo','Find','Replace','SelectAll','RemoveFormat'] },
    	{ name: 'basicstyles', items: ['Bold','Italic','Underline','Strike','SoftHyphen','Subscript','Superscript'] },
    	{ name: 'paragraph', items: ['NumberedList','BulletedList','Outdent','Indent','BidiLtr', 'BidiRtl','Blockquote'] },
    	{ name: 'justify', items: ['JustifyLeft','JustifyCenter','JustifyRight','JustifyBlock'] },
    	{ name: 'colors', items: ['TextColor','BGColor'] },
    	{ name: 'links', items: ['Link','Unlink','Anchor','Iframe'] },
    	{ name: 'medias', items: ['Media','Image','LeafletMap','Video','Audio','Embed'] },
    	{ name: 'insert', items: ['Table','CreateDiv','Form','HorizontalRule','ShowBlocks','SpecialChar'] },
    	{ name: 'styles', items: ['CSSClasses','Format','Font','FontSize'] },
    	{ name: 'source', items: ['Sourcedialog'] }
    ] ;
};

var tabuClasses = ['wb_frameelement', 'wb_columnselement', 'wb_innercolumns', 'wb_colframe', 'wb_colgroup', 'wb_colrow', 'wb_column'];
var freeClasses = ['wb_framecontent', 'wb_colalign'];

CKEDITOR.on('instanceReady', function( ev )
{
    var editor = ev.editor;
	var writer = editor.dataProcessor.writer;
	
	writer.setRules( 'link', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'script', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'header', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'nav', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'div', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'section', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'article', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	writer.setRules( 'footer', { indent: true, breakAfterOpen : true, breakBeforeClose : true });
	
	var elements = editor.document.getElementsByTag('div');
    var element;
	for(var i = 0; i < elements.count(); i++) {
		element = elements.getItem(i);
		for(var k = 0; k < tabuClasses.length; k++) {
			if(!element.hasAttribute('data-cke-tabu-magicline') && element.hasClass(tabuClasses[k])) {
				element.data('cke-tabu-magicline', '1');
			}
		}
		for(var m = 0; m < freeClasses.length; m++) {
			if(!element.hasAttribute('data-cke-free-magicline') && element.hasClass(freeClasses[m])) {
				element.data('cke-free-magicline', '1');
			}
		}
	}
});

CKEDITOR.on('dialogDefinition', function( ev )
{
    var dialogName = ev.data.name;
    var dialogDefinition = ev.data.definition;
    var editor = ev.editor;
    
	dialogDefinition.resizable = CKEDITOR.DIALOG_RESIZE_NONE;
    
    if(dialogName === 'table')
    {
        var infoTab = dialogDefinition.getContents('info');
        var cellSpacing = infoTab.get('txtCellSpace');
        cellSpacing['default'] = "0";
        var cellPadding = infoTab.get('txtCellPad');
        cellPadding['default'] = "0";
        var border = infoTab.get('txtBorder');
        border['default'] = "0";
    }
    
    if(dialogName === 'image')
    {
        var infoTab = dialogDefinition.getContents('info');
        var browseButton = infoTab.get('browse');
        browseButton['style'] = 'margin-top: 15px;';
		
        var linkTab = dialogDefinition.getContents('Link');
        var browseButton = linkTab.get('browse');
        browseButton['style'] = 'float: right; margin: 10px 0px;';
    }
    
    if(dialogName === 'link')
    {
        var infoTab = dialogDefinition.getContents('info');
        var browseButton = infoTab.get('browse');
        browseButton['style'] = 'float: right;';
        
		var protocolField = infoTab.get('protocol');
        protocolField['default'] = '';
    }
    
    if(dialogName === 'templates')
    {
        var selTplTab = dialogDefinition.getContents('selectTpl');
		var chkInsertOptField = selTplTab.get( 'chkInsertOpt' );
        chkInsertOptField['default'] = false;
        chkInsertOptField['style'] = 'display: none;';
    }
    
    if(dialogName === 'docProps')
    {
		dialogDefinition.removeContents( 'general' );
		dialogDefinition.removeContents( 'design' );
		dialogDefinition.removeContents( 'preview' );
    }
    
    if(dialogName === 'form')
    {
        var url = window.location.href;
        var query = url.substring(url.indexOf('\?'), url.length);
        
        var infoTab = dialogDefinition.getContents('info');
        
		var actionField = infoTab.get( 'action' );
        actionField['default'] = 'index.php' + query;
		var dataField = infoTab.get( 'enctype' );
        dataField['default'] = 'text/plain';
		var methodField = infoTab.get( 'method' );
        methodField['default'] = 'post';
    }
});


