<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

require_once dirname(dirname(dirname(dirname(dirname(dirname(__FILE__)))))).'/includes/loader.php';

$webutlerckplugin = new WebutlerAdminClass;
$webutlerckplugin->config = $webutler_config;

if(!$webutlerckplugin->checkadmin())
    exit('no access');

require_once $webutlerckplugin->config['server_path'].'/admin/system/lang/'.$_SESSION['loggedin']['userlang'].'.php';

header("Pragma:no-cache");
header("Cache-Control:private,no-store,no-cache,must-revalidate");

?>
<!DOCTYPE html>
<html lang="<?PHP echo $_SESSION['loggedin']['userlang']; ?>">
	<head>
		<title>Leaflet Map</title>
		<meta charset="UTF-8" />
        <meta name="viewport" content="initial-scale=1.0, user-scalable=no" />
		<link href="<?PHP echo $webutlerckplugin->config['homepage']; ?>/content/javascript/leafletmap/leaflet.css" rel="stylesheet" type="text/css" />
		<script src="<?PHP echo $webutlerckplugin->config['homepage']; ?>/content/javascript/leafletmap/leaflet.js"></script>
        <script>
        /*<![CDATA[*/
            var CKEDITOR = window.top.CKEDITOR || {};
            var dialog = CKEDITOR.dialog.getCurrent();
            var mymap, lat, lng, zoom, marker, wheelZoom, infowin, textbubble = '';
			
			var getJSON = function(url, callback) {
				var xhr = new XMLHttpRequest();
				xhr.open('GET', url, true);
				xhr.responseType = 'json';
				xhr.onload = function() {
				var status = xhr.status;
					if (status === 200) {
						callback(null, xhr.response);
					} else {
						callback(status, xhr.response);
					}
				};
				xhr.send();
			};
			
            window.onload = function() {
                lat = 50.36406130437471;
                lng = 7.605553868103016;
				zoom = 15;
				wheelZoom = true;
				mymap = L.map('leafletmapcanvas', {
					scrollWheelZoom: wheelZoom
				}).setView([lat, lng], zoom);
				L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png?{foo}', {
					foo: 'bar',
					maxZoom: 18,
					attribution: '&copy; <a href="https://www.openstreetmap.org/copyright">OpenStreetMap</a> contributors'
				}).addTo(mymap);
				
                if(dialog.getValueOf( 'info', 'marker' ) != true) {
					mymap.on('moveend', function() {
						lat = mymap.getCenter().lat;
						lng = mymap.getCenter().lng;
						zoom = mymap.getZoom();
					});
				}
            }
          
            function showAddress(notfound) {
                var address = dialog.getValueOf( 'info', 'adresse' );
				if(address != '') {
					var url = '//nominatim.openstreetmap.org/search?q=' + encodeURIComponent(address) + '&format=geocodejson';
					
					getJSON(url, function(err, data) {
						if (err !== null) {
							alert(notfound + '\n' + err);
						}
						else {
							lng = data.features[0].geometry.coordinates[0];
							lat = data.features[0].geometry.coordinates[1];
							
							reloadMap();
							if(marker) {
								mymap.removeLayer(marker);
								setMarker();
							}
						}
					});
				}
            }
            
            function reloadMap() {
				mymap.panTo(new L.LatLng(lat, lng));
				
				if(marker) {
					marker.setLatLng([lat, lng], {
						draggable: 'true'
					}).bindPopup([lat, lng]).update();
				}
            }
            
            function setMarker() {
                if(dialog.getValueOf( 'info', 'marker' ) == true) {
					marker = new L.marker([lat, lng], {
						draggable: 'true'
					});

					marker.on('dragend', function(event) {
						var position = marker.getLatLng();
						marker.setLatLng(position, {
							draggable: 'true'
						}).bindPopup(position).update();
						
						lng = position.lng;
						lat = position.lat;
					});
					
					mymap.addLayer(marker);
					
					setPopup();
                }
                else {
					mymap.removeLayer(marker);
                }
            }
            
            function setWheelZoom() {
                if(dialog.getValueOf( 'info', 'wheelZoom' ) == true) {
					wheelZoom = true;
					mymap.scrollWheelZoom.enable();
                }
                else {
					wheelZoom = false;
					mymap.scrollWheelZoom.disable();
                }
            }
            
            function setPopup() {
                if(dialog.getValueOf( 'info', 'marker' ) == true && dialog.getValueOf( 'info', 'infowin' ) == true) {
					textbubble = dialog.getValueOf( 'info', 'textbubble' );
					if(textbubble != '') {
						textbubble = textbubble.replace(/(\r\n|\n\r|\r|\n)/g, '<br />');
						marker.bindPopup(textbubble).update().openPopup();
					}
                }
                else {
					marker.closePopup();
                }
            }
        /*]]>*/
        </script>
    </head>
    <body scroll="no" style="overflow: hidden; margin: 0px; padding: 0px">
      <div id="leafletmapcanvas" style="width: 450px; height: 280px"></div>
    </body>
</html>
