<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

require_once dirname(dirname(__FILE__)).'/includes/loader.php';

$webutler = new WebutlerClass;
$webutler->config = $webutler_config;
$webutler->htmlsource = $webutler_htmlsource;
$webutler->moduleslist = $webutler_moduleslist;

$loginlang = ($webutler->config['admin_lang'] != '') ? $webutler->config['admin_lang'] : $webutler->config['defaultlang'];
require_once $webutler->config['server_path'].'/admin/system/lang/'.$loginlang.'.php';

//header("Pragma:no-cache");
//header("Cache-Control:private,no-store,no-cache,must-revalidate");
header('Cache-Control: no-store, no-cache, must-revalidate, post-check=0, pre-check=0');
header('Expires: Sat, 26 Jul 1997 05:00:00 GMT');

if(!isset($_GET['logout'])) {
    if(!isset($_COOKIE[$webutler->config['session_name']])) {
        if(isset($_GET['checkcookie']) && $_GET['checkcookie'] == 1) {
            $meldung = _WBLANGADMIN_LOGIN_ERRORNOCOOKIE_;
            $url = $webutler->config['homepage'].'/admin/index.php';
        }
        else {
            header('Refresh: 1; url='.$webutler->config['homepage'].'/admin/index.php?checkcookie=1');
            exit;
        }
    }
    else {
		$location = 'http'.(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
		
        if($webutler->config['modrewrite'] == '1') {
            if($location != $webutler->config['homepage'].'/login')
                header('Location: '.$webutler->config['homepage'].'/login');
            
            $url = $webutler->config['homepage'].'/login';
        }
        else {
            if($location != $webutler->config['homepage'].'/admin/index.php')
                header('Location: '.$webutler->config['homepage'].'/admin/index.php');
            
            $url = $webutler->config['homepage'].'/admin/index.php';
        }
    }
}

if(isset($_SESSION['history']['logpage']) && isset($_SESSION['history']['thispage']) && $_SESSION['history']['thispage'] != $webutler->config['homepage'].'/') {
    unset($_SESSION['history']['logpage']);
}
if(!isset($_SESSION['history']['logpage'])) {
    if(isset($_GET['logout'])) {
        if($webutler->config['modrewrite'] == '1' && preg_match('#index\.php\?wbpagefile=#', $_SESSION['history']['thispage']))
            $_SESSION['history']['logpage'] = preg_replace('#(.*)(index\.php\?wbpagefile=)([\w\d\_\%]+)(.*)#', '${1}${3}', $_SESSION['history']['thispage']).$webutler->config['urlext'];
        else
            $_SESSION['history']['logpage'] = $_SESSION['history']['thispage'];
    }
    else {
        $_SESSION['history']['logpage'] = (isset($_SESSION['history']['thispage'])) ? $_SESSION['history']['thispage'] : $webutler->config['homepage'].'/';
    }
}

if(isset($_POST['webutler_login'])) 
{
	$webutler->checkantixpost();
	
	if(!$webutler->loginattempts())
	{
		$meldung = str_replace('__TIME__', $webutler->config['logattemptmin'], _WBLANGADMIN_LOGIN_ATTEMPTS_);
	}
	else
	{
		$pass = $webutler->config['salt_key1'].trim($_POST['adminpass']).$webutler->config['salt_key2'];
		$userissub = false;
		
		if(($_POST['adminname'] == $webutler->config['admin_name'] && md5($pass) == $webutler->config['admin_pass']) || 
		  ($webutler->config['master_name'] != '' && $webutler->config['master_pass'] != '' && $_POST['adminname'] == $webutler->config['master_name'] && md5($pass) == $webutler->config['master_pass']) ||
		  ($userissub = $webutler->userissubadmin($_POST['adminname'], md5($pass))))
		{
			$lastpage = $_SESSION['history']['logpage'];
			
			session_regenerate_id();
			
			$_SESSION['loggedin']['username'] = $_POST['adminname'];
			$_SESSION['loggedin']['userpass'] = md5($pass);
			$_SESSION['loggedin']['editboxstate'] = 'show';
			if($_SESSION['loggedin']['username'] == $webutler->config['master_name'] && 
			  $_SESSION['loggedin']['userpass'] == $webutler->config['master_pass']) {
				$_SESSION['loggedin']['userlang'] = $webutler->config['master_lang'];
				$_SESSION['loggedin']['userismaster'] = '1';
			}
			else {
				if($userissub && is_array($userissub)) {
					$_SESSION['loggedin']['userlang'] = $userissub['lang'];
					$_SESSION['loggedin']['userissub'] = '1';
				}
				else {
					$_SESSION['loggedin']['userlang'] = $webutler->config['admin_lang'];
					$_SESSION['loggedin']['userisadmin'] = '1';
				}
			}
			$_SESSION['admintoken'] = $webutler->tokenizer();
			
			header('Location: '.$lastpage);
			exit;
		}
		else
		{
			$meldung = _WBLANGADMIN_LOGIN_ERRORWRONGDATA_;
		}
	}
}
    
if(isset($_GET['logout']) && $_GET['logout'] == 'yes') {
    if($webutler->checkadmin()) {
        $lastpage = $_SESSION['history']['logpage'];
		
		setcookie($webutler->config['session_name'], '', time()-100000, '/');
		session_destroy();
        
        header('Location: '.$lastpage);
    }
    else {
    	header('Location: '.$webutler->config['homepage'].'/');
    }
	exit;
}

$login_antixpostcode = $webutler->antixpostcode();

?>
<!DOCTYPE html>
<html lang="<?PHP echo $loginlang; ?>">
<head>
	<title>WEBUTLER - <?PHP echo _WBLANGADMIN_LOGIN_TITLE_; ?></title>
	<meta charset="utf-8" />
	<meta http-equiv="imagetoolbar" content="no" />
	<meta name="robots" content="noindex,nofollow" />
	<link href="<?PHP echo $webutler->config['homepage']; ?>/admin/system/css/admin.css" rel="stylesheet" type="text/css" />
    <script>
    /* <![CDATA[ */
        window.onload = function() {
            document.login.adminname.focus();
        }
    /* ]]> */
    </script>
</head>
<body>
	<div id="webutler_loginpage">
		<table border="0" cellspacing="20" cellpadding="0">
			<tr> 
			  <td class="webutler_loginlogo">
        	    <img src="<?PHP echo $webutler->config['homepage']; ?>/admin/system/images/webutler.svg" width="217" height="46" alt="Webutler" />
              </td>
			</tr>
			<tr> 
			  <td class="webutler_loginborder">
        		<form name="login" method="post" action="<?PHP echo $url; ?>" style="margin: 0; padding: 0">
        		  <table border="0" cellspacing="5" cellpadding="0">
        			<tr> 
        			  <td colspan="2">
        				<strong><?PHP echo _WBLANGADMIN_LOGIN_TITLE_; ?></strong><?PHP if(isset($meldung)) echo ' - <span style="color: #9E2627">'.$meldung.'</span>'; ?>
        			  </td>
        			</tr>
        			<tr> 
        			  <td><?PHP echo _WBLANGADMIN_LOGIN_USER_; ?>:</td>
        			  <td><input type="text" name="adminname" class="webutler_input webutler_loginput" /></td>
        			</tr>
        			<tr> 
        			  <td><?PHP echo _WBLANGADMIN_LOGIN_PASS_; ?>:</td>
        			  <td><input type="password" name="adminpass" class="webutler_input webutler_loginput" /></td>
        			</tr>
        			<tr> 
        			  <td>&nbsp;</td>
        			  <td><input type="submit" name="webutler_login" value="<?PHP echo _WBLANGADMIN_LOGIN_LOGIN_; ?>" class="webutler_button webutler_logbutton" /></td>
        			</tr>
        		  </table>
        		  <input type="hidden" name="webutler_autokill" value="<?PHP echo md5($login_antixpostcode); ?>" />
        		</form>
              </td>
			</tr>
            <?PHP
                if(($webutler->config['modsonlog'] == 1 || $webutler->config['modsonlog'] == 3) && is_array($webutler->moduleslist) && count($webutler->moduleslist) >= 1) {
                    $loadmodules = 'false';
                	foreach($webutler->moduleslist as $module) {
                        if(!isset($module[2]) || (isset($module[2]) && $module[2] != '-')) {
                    		$loadmodules = 'true';
							break;
						}
            		}
                    if($loadmodules == 'true') {
            ?>
			<tr> 
			  <td class="webutler_loginborder">
                <table border="0" cellspacing="5" cellpadding="0">
                  <tr>
                    <td><strong><?PHP echo _WBLANGADMIN_WIN_ADMIN_MODULES_; ?></strong></td>
                  </tr>
                  <?PHP
                	foreach($webutler->moduleslist as $module) {
                        if(!isset($module[2]) || (isset($module[2]) && $module[2] != '-')) {
							$modpath = $module[1];
							if(substr($modpath, 0, 1) != '/') $modpath = '/'.$modpath;
                    		echo '<tr>'."\n".
                    		'<td style="padding-left: 20px">&raquo; <a href="'.$webutler->config['homepage'].'/modules'.$modpath.'">'.$module[0].'</a></td>'."\n".
                    		'</tr>'."\n";
                		}
            		}
                  ?>
                </table>
              </td>
            </tr>
            <?PHP
                    }
                }
            ?>
        </table>
	</div>
</body>
</html>
