<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

if(preg_match('#/admin/system/admin.php#i', $_SERVER['REQUEST_URI']))
    exit('no access');

$useformsendto = ($webutler_config['forms_modul'] == '1') ? 'formsendto,' : '';
$usecolumns = ($webutler_config['insertcolumns'] > '0') ? 'columns,' : '';
$useshowprotected = ($webutler_config['codeicon'] == '1') ? 'showprotected,' : '';

$webutleradmin = new WebutlerAdminClass($useformsendto, $usecolumns, $useshowprotected);
$webutleradmin->config = $webutler_config;

if(!$webutleradmin->checkadmin())
    exit('no access');

require_once $webutler_config['server_path'].'/settings/compress.php';

$webutleradmin->compress = $webutler_compress;
//$webutleradmin->cke_cssclasses = ($webutler_config['ckecssclasses'] == '1') ? 1 : 0;
$webutleradmin->htmlsource = $webutler_htmlsource;
$webutleradmin->consents = $webutler_consents;
$webutleradmin->offlinepages = $webutler_offlinepages;
$webutleradmin->mailaddresses = $webutler_mailaddresses;
$webutleradmin->langconf = $webutler_langconf;
$webutleradmin->directories = $webutler_directories;
$webutleradmin->linkhighlite = $webutler_linkhighlite;
$webutleradmin->moduleslist = $webutler_moduleslist;
if(count($webutler_autoheaderdata) > 0)
    $webutleradmin->autoheaderdata = $webutler_autoheaderdata;
if(count($webutler_autofooterdata) > 0)
    $webutleradmin->autofooterdata = $webutler_autofooterdata;


$webutleradmin->uritoget();
$webutleradmin->verifygetpage();

require_once $webutleradmin->config['server_path'].'/admin/system/lang/'.$_SESSION['loggedin']['userlang'].'.php';
require_once $webutleradmin->setlangdefines();

$webutleradmin->checkconsents();
$webutleradmin->compressonload();

if(isset($_POST['edit']))
{
    $webutleradmin->adminpageedit();
    echo $webutleradmin->adminpage;
}
elseif(isset($_POST['block']))
{
    $webutleradmin->adminpageblock();
    echo $webutleradmin->adminpage;
}
elseif(isset($_POST['menu']))
{
    $webutleradmin->adminpagemenu();
    echo $webutleradmin->adminpage;
}
elseif(isset($_POST['content']))
{
    $webutleradmin->adminpagecontent();
    echo $webutleradmin->adminpage;
}
elseif(isset($_POST['editnewlayout']) || isset($_POST['editnewstyles']) || isset($_POST['editnewscripts']))
{
    $webutleradmin->adminsourceedit();
    echo $webutleradmin->adminpage;
}
elseif(isset($_POST['editpattern']))
{
    $webutleradmin->admineditpattern();
    echo $webutleradmin->adminpage;
}
elseif(isset($_GET['tplfile']))
{
    $webutleradmin->adminpreviewtpl();
    echo $webutleradmin->loadcontentpage;
}
elseif(isset($_GET['pagefile']))
{
    $webutleradmin->adminpreviewpage();
    echo $webutleradmin->loadcontentpage;
}
elseif(isset($_GET['blockfile']))
{
    $webutleradmin->adminpreviewblock();
    echo $webutleradmin->loadcontentpage;
}
elseif(isset($_GET['menufile']))
{
    $webutleradmin->adminpreviewmenu();
    echo $webutleradmin->loadcontentpage;
}
else
{
    $webutleradmin->adminpageview();
    echo $webutleradmin->loadcontentpage;
}


