<?PHP

  /* space between columns */
  $spacer_vertical_small = 30;            /* small */
  $spacer_vertical_medium = 45;            /* medium */
  $spacer_vertical_large = 60;            /* large */
  
  /* space between rows */
  $spacer_horizontal_small = 22.5;        /* small */
  $spacer_horizontal_medium = 33.75;    /* medium */
  $spacer_horizontal_large = 45;        /* large */
  
  /* break from small to medium */
  $break_small_medium = 650;
  
  /* break from medium to large */
  $break_medium_large = 900;
  
  /* max large width */
  $max_large_width = 1200;

?>
.wb_frameelement {
    padding: <?PHP echo $spacer_horizontal_small; ?>px <?PHP echo $spacer_vertical_small; ?>px;
}

@media screen and (min-width: <?PHP echo ($break_small_medium+1); ?>px) {
    .wb_frameelement {
        padding: <?PHP echo $spacer_horizontal_medium; ?>px <?PHP echo $spacer_vertical_medium; ?>px;
    }
}

@media screen and (min-width: <?PHP echo ($break_medium_large+1); ?>px) {
    .wb_frameelement {
        padding: <?PHP echo $spacer_horizontal_large; ?>px <?PHP echo $spacer_vertical_large; ?>px;
    }
}

.wb_frameelement.wb_topnull {
    padding-top: <?PHP echo $spacer_horizontal_small/2; ?>px;
}

.wb_frameelement.wb_bottomnull {
    padding-bottom: <?PHP echo $spacer_horizontal_small/2; ?>px;
}

@media screen and (min-width: <?PHP echo ($break_small_medium+1); ?>px) {
    .wb_frameelement.wb_topnull {
        padding-top: <?PHP echo $spacer_horizontal_medium/2; ?>px;
    }
    
    .wb_frameelement.wb_bottomnull {
        padding-bottom: <?PHP echo $spacer_horizontal_medium/2; ?>px;
    }
}

@media screen and (min-width: <?PHP echo ($break_medium_large+1); ?>px) {
    .wb_frameelement.wb_topnull {
        padding-top: <?PHP echo $spacer_horizontal_large/2; ?>px;
    }
    
    .wb_frameelement.wb_bottomnull {
        padding-bottom: <?PHP echo $spacer_horizontal_large/2; ?>px;
    }
}

.wb_framecontent {
    max-width: <?PHP echo $max_large_width; ?>px;
}

.wb_colgroup {
    max-width: <?PHP echo ($max_large_width + 2 * $spacer_vertical_large); ?>px;
}

.wb_framecontent, .wb_colgroup {
    margin: 0px auto;
    box-sizing: border-box;
}

.wb_columnselement.wb_topnull > .wb_colgroup > .wb_colrow {
    padding-top: 0px;
}

.wb_columnselement.wb_bottomnull > .wb_colgroup > .wb_colrow {
    padding-bottom: 0px;
}

.wb_framecontent .wb_innercolumns,
.wb_colalign .wb_innercolumns {
    overflow: hidden;
}

.wb_colrow {
    display: -webkit-flex;
    display: -ms-flexbox;
    display: flex;
    -webkit-flex: 0 1 auto;
    -ms-flex: 0 1 auto;
    flex: 0 1 auto;
    -webkit-flex-direction: row;
    -ms-flex-direction: row;
    flex-direction: row;
    -webkit-flex-wrap: wrap;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
}

.wb_column {
    display: -webkit-flex;
    display: -ms-flexbox;
    display: flex;
    -webkit-flex: 0 1 auto;
    -ms-flex: 0 1 auto;
    flex: 0 1 auto;
    -webkit-flex-direction: row;
    -ms-flex-direction: row;
    -webkit-box-orient: horizontal;
    -webkit-box-direction: normal;
    flex-direction: row;
    -webkit-flex-wrap: wrap;
    -ms-flex-wrap: wrap;
    flex-wrap: wrap;
    box-sizing: border-box;
}

.wb_colalign {
    -webkit-flex: 0 0 auto;
    -ms-flex: 0 0 auto;
    -webkit-box-flex: 0;
    flex: 0 0 auto;
    width: 100%;
}

.wb_colalign_top {
    -webkit-align-self: flex-start;
    -ms-align-self: flex-start;
    align-self: flex-start;
}

.wb_colalign_middle {
    -webkit-align-self: center;
    -ms-align-self: center;
    align-self: center;
}

.wb_colalign_bottom {
    -webkit-align-self: flex-end;
    -ms-align-self: flex-end;
    align-self: flex-end;
}

.wb_colalign_full, .wb_colalign_stretch {
    -webkit-align-self: stretch;
    -ms-align-self: stretch;
    align-self: stretch;
}

@media screen and (min-width: <?PHP echo ($break_small_medium+1); ?>px) {
    .wb_colalign_stretch {
        display: -webkit-flex;
        display: -ms-flexbox;
        display: flex;
        -webkit-flex: 0 1 auto;
        -ms-flex: 0 1 auto;
        flex: 0 1 auto;
        -webkit-flex-direction: column;
        -ms-flex-direction: column;
        -webkit-box-orient: vertical;
        -webkit-box-direction: normal;
        flex-direction: column;
        -webkit-flex-wrap: wrap;
        -ms-flex-wrap: wrap;
        flex-wrap: wrap;
        -webkit-align-items: flex-start;
        -ms-align-items: flex-start;
        align-items: flex-start;
        box-sizing: border-box;
        width: 100%;
    }
    
    .wb_colalign_stretch > * {
        -webkit-align-self: flex-end;
        -ms-align-self: flex-end;
        align-self: flex-end;
        margin: auto 0px;
        box-sizing: border-box;
        width: 100%;
    }
    
    .wb_colalign_stretch > *:first-child {
        margin-top: 0px;
    }
    
    .wb_colalign_stretch > *:last-child {
        margin-bottom: 0px;
    }
}

@media screen and (max-width: <?PHP echo $break_small_medium; ?>px) {
    .wb_colrow {
        padding: <?PHP echo $spacer_horizontal_small/2; ?>px <?PHP echo $spacer_vertical_small/2; ?>px;
    }
    
    .wb_framecontent .wb_innercolumns > .wb_colgroup > .wb_colrow,
    .wb_colalign .wb_innercolumns > .wb_colgroup > .wb_colrow {
        margin: -<?PHP echo $spacer_horizontal_small/2; ?>px -<?PHP echo $spacer_vertical_small/2; ?>px;
        padding: 0px;
    }
    
    .wb_colsmall_1, .wb_colsmall_2, .wb_colsmall_3, .wb_colsmall_4, .wb_colsmall_5, .wb_colsmall_6,
    .wb_colsmall_7, .wb_colsmall_8, .wb_colsmall_9, .wb_colsmall_10, .wb_colsmall_11, .wb_colsmall_12 {
        padding: <?PHP echo $spacer_horizontal_small/2; ?>px <?PHP echo $spacer_vertical_small/2; ?>px;
    }
    
    .wb_colsmall_hide {
        display: none;
    }
    
    .wb_colsmall_1 {
        -webkit-flex-basis: 8.333%;
        -ms-flex-preferred-size: 8.333%;
        flex-basis: 8.333%;
        max-width: 8.333%;
    }
    
    .wb_colsmall_2 {
        -webkit-flex-basis: 16.667%;
        -ms-flex-preferred-size: 16.667%;
        flex-basis: 16.667%;
        max-width: 16.667%;
    }
    
    .wb_colsmall_3 {
        -webkit-flex-basis: 25%;
        -ms-flex-preferred-size: 25%;
        flex-basis: 25%;
        max-width: 25%;
    }
    
    .wb_colsmall_4 {
        -webkit-flex-basis: 33.333%;
        -ms-flex-preferred-size: 33.333%;
        flex-basis: 33.333%;
        max-width: 33.333%;
    }
    
    .wb_colsmall_5 {
        -webkit-flex-basis: 41.667%;
        -ms-flex-preferred-size: 41.667%;
        flex-basis: 41.667%;
        max-width: 41.667%;
    }
    
    .wb_colsmall_6 {
        -webkit-flex-basis: 50%;
        -ms-flex-preferred-size: 50%;
        flex-basis: 50%;
        max-width: 50%;
    }
    
    .wb_colsmall_7 {
        -webkit-flex-basis: 58.333%;
        -ms-flex-preferred-size: 58.333%;
        flex-basis: 58.333%;
        max-width: 58.333%;
    }
    
    .wb_colsmall_8 {
        -webkit-flex-basis: 66.667%;
        -ms-flex-preferred-size: 66.667%;
        flex-basis: 66.667%;
        max-width: 66.667%;
    }
    
    .wb_colsmall_9 {
        -webkit-flex-basis: 75%;
        -ms-flex-preferred-size: 75%;
        flex-basis: 75%;
        max-width: 75%;
    }
    
    .wb_colsmall_10 {
        -webkit-flex-basis: 83.333%;
        -ms-flex-preferred-size: 83.333%;
        flex-basis: 83.333%;
        max-width: 83.333%;
    }
    
    .wb_colsmall_11 {
        -webkit-flex-basis: 91.667%;
        -ms-flex-preferred-size: 91.667%;
        flex-basis: 91.667%;
        max-width: 91.667%;
    }
    
    .wb_colsmall_12 {
        -webkit-flex-basis: 100%;
        -ms-flex-preferred-size: 100%;
        flex-basis: 100%;
        max-width: 100%;
    }
    
    .wb_colorder_s1 {
        -webkit-order: 1;
        -ms-flex-order: 1;
        order: 1;
    }
    
    .wb_colorder_s2 {
        -webkit-order: 2;
        -ms-flex-order: 2;
        order: 2;
    }
    
    .wb_colorder_s3 {
        -webkit-order: 3;
        -ms-flex-order: 3;
        order: 3;
    }
    
    .wb_colorder_s4 {
        -webkit-order: 4;
        -ms-flex-order: 4;
        order: 4;
    }
    
    .wb_colorder_s5 {
        -webkit-order: 5;
        -ms-flex-order: 5;
        order: 5;
    }
    
    .wb_colorder_s6 {
        -webkit-order: 6;
        -ms-flex-order: 6;
        order: 6;
    }
    
    .wb_colorder_s7 {
        -webkit-order: 7;
        -ms-flex-order: 7;
        order: 7;
    }
    
    .wb_colorder_s8 {
        -webkit-order: 8;
        -ms-flex-order: 8;
        order: 8;
    }
    
    .wb_colorder_s9 {
        -webkit-order: 9;
        -ms-flex-order: 9;
        order: 9;
    }
    
    .wb_colorder_s10 {
        -webkit-order: 10;
        -ms-flex-order: 10;
        order: 10;
    }
    
    .wb_colorder_s11 {
        -webkit-order: 11;
        -ms-flex-order: 11;
        order: 11;
    }
    
    .wb_colorder_s12 {
        -webkit-order: 12;
        -ms-flex-order: 12;
        order: 12;
    }
}

@media screen and (min-width: <?PHP echo ($break_small_medium+1); ?>px) and (max-width: <?PHP echo $break_medium_large; ?>px) {
    .wb_colrow {
        padding: <?PHP echo $spacer_horizontal_medium/2; ?>px <?PHP echo $spacer_vertical_medium/2; ?>px;
    }
    
    .wb_framecontent .wb_innercolumns > .wb_colgroup > .wb_colrow,
    .wb_colalign .wb_innercolumns > .wb_colgroup > .wb_colrow {
        margin: -<?PHP echo $spacer_horizontal_medium/2; ?>px -<?PHP echo $spacer_vertical_medium/2; ?>px;
        padding: 0px;
    }

    .wb_colmedium_1, .wb_colmedium_2, .wb_colmedium_3, .wb_colmedium_4, .wb_colmedium_5, .wb_colmedium_6,
    .wb_colmedium_7, .wb_colmedium_8, .wb_colmedium_9, .wb_colmedium_10, .wb_colmedium_11, .wb_colmedium_12 {
        padding: <?PHP echo $spacer_horizontal_medium/2; ?>px <?PHP echo $spacer_vertical_medium/2; ?>px;
    }

    .wb_colmedium_hide {
        display: none;
    }
    
    .wb_colmedium_1 {
        -webkit-flex-basis: 8.333%;
        -ms-flex-preferred-size: 8.333%;
        flex-basis: 8.333%;
        max-width: 8.333%;
    }
    
    .wb_colmedium_2 {
        -webkit-flex-basis: 16.667%;
        -ms-flex-preferred-size: 16.667%;
        flex-basis: 16.667%;
        max-width: 16.667%;
    }
    
    .wb_colmedium_3 {
        -webkit-flex-basis: 25%;
        -ms-flex-preferred-size: 25%;
        flex-basis: 25%;
        max-width: 25%;
    }
    
    .wb_colmedium_4 {
        -webkit-flex-basis: 33.333%;
        -ms-flex-preferred-size: 33.333%;
        flex-basis: 33.333%;
        max-width: 33.333%;
    }
    
    .wb_colmedium_5 {
        -webkit-flex-basis: 41.667%;
        -ms-flex-preferred-size: 41.667%;
        flex-basis: 41.667%;
        max-width: 41.667%;
    }
    
    .wb_colmedium_6 {
        -webkit-flex-basis: 50%;
        -ms-flex-preferred-size: 50%;
        flex-basis: 50%;
        max-width: 50%;
    }
    
    .wb_colmedium_7 {
        -webkit-flex-basis: 58.333%;
        -ms-flex-preferred-size: 58.333%;
        flex-basis: 58.333%;
        max-width: 58.333%;
    }
    
    .wb_colmedium_8 {
        -webkit-flex-basis: 66.667%;
        -ms-flex-preferred-size: 66.667%;
        flex-basis: 66.667%;
        max-width: 66.667%;
    }
    
    .wb_colmedium_9 {
        -webkit-flex-basis: 75%;
        -ms-flex-preferred-size: 75%;
        flex-basis: 75%;
        max-width: 75%;
    }
    
    .wb_colmedium_10 {
        -webkit-flex-basis: 83.333%;
        -ms-flex-preferred-size: 83.333%;
        flex-basis: 83.333%;
        max-width: 83.333%;
    }
    
    .wb_colmedium_11 {
        -webkit-flex-basis: 91.667%;
        -ms-flex-preferred-size: 91.667%;
        flex-basis: 91.667%;
        max-width: 91.667%;
    }
    
    .wb_colmedium_12 {
        -webkit-flex-basis: 100%;
        -ms-flex-preferred-size: 100%;
        flex-basis: 100%;
        max-width: 100%;
    }
    
    .wb_colorder_m1 {
        -webkit-order: 1;
        -ms-flex-order: 1;
        order: 1;
    }
    
    .wb_colorder_m2 {
        -webkit-order: 2;
        -ms-flex-order: 2;
        order: 2;
    }
    
    .wb_colorder_m3 {
        -webkit-order: 3;
        -ms-flex-order: 3;
        order: 3;
    }
    
    .wb_colorder_m4 {
        -webkit-order: 4;
        -ms-flex-order: 4;
        order: 4;
    }
    
    .wb_colorder_m5 {
        -webkit-order: 5;
        -ms-flex-order: 5;
        order: 5;
    }
    
    .wb_colorder_m6 {
        -webkit-order: 6;
        -ms-flex-order: 6;
        order: 6;
    }
    
    .wb_colorder_m7 {
        -webkit-order: 7;
        -ms-flex-order: 7;
        order: 7;
    }
    
    .wb_colorder_m8 {
        -webkit-order: 8;
        -ms-flex-order: 8;
        order: 8;
    }
    
    .wb_colorder_m9 {
        -webkit-order: 9;
        -ms-flex-order: 9;
        order: 9;
    }
    
    .wb_colorder_m10 {
        -webkit-order: 10;
        -ms-flex-order: 10;
        order: 10;
    }
    
    .wb_colorder_m11 {
        -webkit-order: 11;
        -ms-flex-order: 11;
        order: 11;
    }
    
    .wb_colorder_m12 {
        -webkit-order: 12;
        -ms-flex-order: 12;
        order: 12;
    }
}

@media print, screen and (min-width: <?PHP echo ($break_medium_large+1); ?>px) {
    .wb_colrow {
        padding: <?PHP echo $spacer_horizontal_large/2; ?>px <?PHP echo $spacer_vertical_large/2; ?>px;
    }
    
    .wb_framecontent .wb_innercolumns > .wb_colgroup > .wb_colrow,
    .wb_colalign .wb_innercolumns > .wb_colgroup > .wb_colrow {
        margin: -<?PHP echo $spacer_horizontal_large/2; ?>px -<?PHP echo $spacer_vertical_large/2; ?>px;
        padding: 0px;
    }

    .wb_collarge_1, .wb_collarge_2, .wb_collarge_3, .wb_collarge_4, .wb_collarge_5, .wb_collarge_6,
    .wb_collarge_7, .wb_collarge_8, .wb_collarge_9, .wb_collarge_10, .wb_collarge_11, .wb_collarge_12 {
        padding: <?PHP echo $spacer_horizontal_large/2; ?>px <?PHP echo $spacer_vertical_large/2; ?>px;
    }

    .wb_collarge_hide {
        display: none;
    }
    
    .wb_collarge_1 {
        -webkit-flex-basis: 8.333%;
        -ms-flex-preferred-size: 8.333%;
        flex-basis: 8.333%;
        max-width: 8.333%;
    }
    
    .wb_collarge_2 {
        -webkit-flex-basis: 16.667%;
        -ms-flex-preferred-size: 16.667%;
        flex-basis: 16.667%;
        max-width: 16.667%;
    }
    
    .wb_collarge_3 {
        -webkit-flex-basis: 25%;
        -ms-flex-preferred-size: 25%;
        flex-basis: 25%;
        max-width: 25%;
    }
    
    .wb_collarge_4 {
        -webkit-flex-basis: 33.333%;
        -ms-flex-preferred-size: 33.333%;
        flex-basis: 33.333%;
        max-width: 33.333%;
    }
    
    .wb_collarge_5 {
        -webkit-flex-basis: 41.667%;
        -ms-flex-preferred-size: 41.667%;
        flex-basis: 41.667%;
        max-width: 41.667%;
    }
    
    .wb_collarge_6 {
        -webkit-flex-basis: 50%;
        -ms-flex-preferred-size: 50%;
        flex-basis: 50%;
        max-width: 50%;
    }
    
    .wb_collarge_7 {
        -webkit-flex-basis: 58.333%;
        -ms-flex-preferred-size: 58.333%;
        flex-basis: 58.333%;
        max-width: 58.333%;
    }
    
    .wb_collarge_8 {
        -webkit-flex-basis: 66.667%;
        -ms-flex-preferred-size: 66.667%;
        flex-basis: 66.667%;
        max-width: 66.667%;
    }
    
    .wb_collarge_9 {
        -webkit-flex-basis: 75%;
        -ms-flex-preferred-size: 75%;
        flex-basis: 75%;
        max-width: 75%;
    }
    
    .wb_collarge_10 {
        -webkit-flex-basis: 83.333%;
        -ms-flex-preferred-size: 83.333%;
        flex-basis: 83.333%;
        max-width: 83.333%;
    }
    
    .wb_collarge_11 {
        -webkit-flex-basis: 91.667%;
        -ms-flex-preferred-size: 91.667%;
        flex-basis: 91.667%;
        max-width: 91.667%;
    }
    
    .wb_collarge_12 {
        -webkit-flex-basis: 100%;
        -ms-flex-preferred-size: 100%;
        flex-basis: 100%;
        max-width: 100%;
    }
    
    .wb_colorder_l1 {
        -webkit-order: 1;
        -ms-flex-order: 1;
        order: 1;
    }
    
    .wb_colorder_l2 {
        -webkit-order: 2;
        -ms-flex-order: 2;
        order: 2;
    }
    
    .wb_colorder_l3 {
        -webkit-order: 3;
        -ms-flex-order: 3;
        order: 3;
    }
    
    .wb_colorder_l4 {
        -webkit-order: 4;
        -ms-flex-order: 4;
        order: 4;
    }
    
    .wb_colorder_l5 {
        -webkit-order: 5;
        -ms-flex-order: 5;
        order: 5;
    }
    
    .wb_colorder_l6 {
        -webkit-order: 6;
        -ms-flex-order: 6;
        order: 6;
    }
    
    .wb_colorder_l7 {
        -webkit-order: 7;
        -ms-flex-order: 7;
        order: 7;
    }
    
    .wb_colorder_l8 {
        -webkit-order: 8;
        -ms-flex-order: 8;
        order: 8;
    }
    
    .wb_colorder_l9 {
        -webkit-order: 9;
        -ms-flex-order: 9;
        order: 9;
    }
    
    .wb_colorder_l10 {
        -webkit-order: 10;
        -ms-flex-order: 10;
        order: 10;
    }
    
    .wb_colorder_l11 {
        -webkit-order: 11;
        -ms-flex-order: 11;
        order: 11;
    }
    
    .wb_colorder_l12 {
        -webkit-order: 12;
        -ms-flex-order: 12;
        order: 12;
    }
}

