
/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

/*** Load anchors with attribute rel="lightbox" in SimpleLightbox ***/

(function() {
	var groups = [];
	var anchors = [];
	var links = document.getElementsByTagName('a');
	for(var i = 0; i < links.length; i++) {
		var anchor = links[i];
		var rel = String(anchor.getAttribute('rel')).toLowerCase();
		if(anchor.getAttribute('href') && rel.match(/lightbox/)) {
			var num = rel.length > 8 ? rel.substring(8) : 0;
			if(groups.indexOf(num) == -1) {
				groups.push(num);
				anchors.push(num);
				anchors[num] = [];
			}
			anchors[num].push(anchor);
		}
	}
	
	// https://simplelightbox.com/#options
	
	var lightbox_options = {
		captionsData: 'alt',
		animationSlide: false,
		showCounter: false,
		fadeSpeed: 100,
		scrollZoom: false
	};
	
	if(groups.length > 0) {
		var galleries = [];
		for(var g = 0; g < groups.length; g++) {
			if(groups[g] == 0) {
				var singleimg = [];
				for(var a = 0; a < anchors[0].length; a++) {
					singleimg[a] = new SimpleLightbox(anchors[0][a], lightbox_options);
				}
			}
			else {
				galleries[groups[g]] = new SimpleLightbox(anchors[groups[g]], lightbox_options);
			}
		}
	}
})();
