<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

if(preg_match('#/includes/forms/honeypot/index.php#i', $_SERVER['REQUEST_URI']))
    exit('no access');


if(!function_exists('honeypot_string')) {
	function honeypot_string($length) {
		$letters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
		$letters.= 'abcdefghijklmnopqrstuvwxyz';
		$numbers = '0123456789';
		
		$firstsign = $letters[mt_rand(0, strlen($letters)-1)];
		$signs = $letters.$numbers;
		
		$result = '';
		for($i = 0; $i < $length; $i++) {
			$result.= $signs[mt_rand(0, strlen($signs)-1)];
		}
		
		return $firstsign.$result;
	}
}

if(!isset($honeypot_formid) || $honeypot_formid == '') {
	echo 'var honeypot_formid not set';
}
else {
	if(!array_key_exists('honeypots', $_SESSION))
		$_SESSION['honeypots'] = array();

	require_once($webutlercouple->config['server_path'].'/includes/forms/honeypot/words.php');

	$honeyrand = array_rand($honeypot_words, 13);
	$honeyrequired = mt_rand(0, 2);
	$honeyempty = ($honeyrequired == 2 ? 0 : ($honeyrequired+1));

	$honeypot_session = array(
		'hiddendiv' => honeypot_string(10),
		'settime' => time(),
		'time2send' => (isset($honeypot_time2send) && $honeypot_time2send > 0 ? $honeypot_time2send : 0),
		'required' => $honeyrequired,
		'empty' => $honeyempty,
		'field_key' => array(
			'name' => $honeypot_words[$honeyrand[0]].'_'.$honeypot_words[$honeyrand[1]],
			'value' => $honeypot_formid
		),
		'field_0' => array(
			'name' => $honeypot_words[$honeyrand[2]].'_'.$honeypot_words[$honeyrand[3]],
			'value' => $honeyempty != 0 ? $honeypot_words[$honeyrand[4]].' '.$honeypot_words[$honeyrand[5]] : ''
		),
		'field_1' => array(
			'name' => $honeypot_words[$honeyrand[6]].'_'.$honeypot_words[$honeyrand[7]],
			'value' => $honeyempty != 1 ? $honeypot_words[$honeyrand[8]] : ''
		),
		'field_2' => array(
			'name' => $honeypot_words[$honeyrand[9]].'_'.$honeypot_words[$honeyrand[10]],
			'value' => $honeyempty != 2 ? $honeypot_words[$honeyrand[11]].' '.$honeypot_words[$honeyrand[12]] : ''
		)
	);

/*
echo '<pre>';
print_r($honeypot_session);
echo '</pre>';
*/

	$_SESSION['honeypots'][$honeypot_formid] = $honeypot_session;

	$webutlercouple->autoheaderdata[] = '<link href="forms/style.css?v='.time().'" defer="defer" media="screen" type="text/css" rel="stylesheet" />';
	$webutlercouple->autofooterdata[] = '<script src="forms/script.js?v='.time().'" defer="defer"></script>';

	$honeyfields = array(
		'<div><strong>'.str_replace('_', ' ', $honeypot_session['field_0']['name']).':</strong></div>'."\n".'<div><input type="text" name="'.$honeypot_session['field_0']['name'].'" value=""'.($honeypot_session['required'] == 0 ? ' required="required"' : '').' /></div>',
		'<div><strong>'.str_replace('_', ' ', $honeypot_session['field_1']['name']).':</strong></div>'."\n".'<div><input type="text" name="'.$honeypot_session['field_1']['name'].'" value=""'.($honeypot_session['required'] == 1 ? ' required="required"' : '').' /></div>',
		'<div><strong>'.str_replace('_', ' ', $honeypot_session['field_2']['name']).':</strong></div>'."\n".'<div><input type="text" name="'.$honeypot_session['field_2']['name'].'" value=""'.($honeypot_session['required'] == 2 ? ' required="required"' : '').' /></div>'
	);
	shuffle($honeyfields);
	
	echo '<div class="'.$honeypot_session['hiddendiv'].'">'."\n";
	foreach($honeyfields as $honeyfield) {
		echo '	<label>'."\n";
			echo '		'.$honeyfield."\n";
		echo '	</label>'."\n";
	}
	echo '	<input type="hidden" name="'.$honeypot_session['field_key']['name'].'" value="'.$honeypot_session['field_key']['value'].'" />'."\n";
	echo '</div>'."\n";
}



