<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/


if(preg_match('#/includes/forms/sendform.php#i', $_SERVER['REQUEST_URI']))
    exit('no access');


function reOrganiceFiles(&$file_post) {
    $isMulti = is_array($file_post['name']);
    $file_count = $isMulti ? count($file_post['name']) : 1;
    $file_keys = array_keys($file_post);

    $file_array = [];
    for($i = 0; $i < $file_count; $i++) {
        foreach($file_keys as $key) {
            if($isMulti)
                $file_array[$i][$key] = $file_post[$key][$i];
            else
                $file_array[$i][$key] = $file_post[$key];
		}
	}

    return $file_array;
}


$forms_langpath = $webutlercouple->config['server_path'].'/includes/forms/lang';
$forms_language = isset($_SESSION['language']) && file_exists($forms_langpath.'/'.$_SESSION['language'].'.php') ? $_SESSION['language'] : $webutlercouple->config['defaultlang'];
include $forms_langpath.'/'.$forms_language.'.php';

$forms_infosend = array();
if(count($_POST) > 0 && isset($_POST['sendform']))
{
    require_once($webutlercouple->config['server_path'].'/includes/forms/honeypot/formsent.php');
	
	$forms_sendto = preg_replace('#[^0-9]#', '', $_POST['sendto']);
    if(!isset($forms_sendto) || $forms_sendto == "")
        $forms_sendto = "1";
	
	$postmail = mb_strtolower(trim($_POST['eMail']));
	$search = '#^[a-zA-Z0-9\.\!\#\$\%\&\'\*\+\/\=\?\^_`{|}~-]+@[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)*$#';
	if(!filter_var($postmail, FILTER_VALIDATE_EMAIL)) {
		if(function_exists('idn_to_ascii')) {
			$str = explode('@', $postmail);
			$checked = $str[0].'@'.idn_to_ascii($str[1]);
			if(!filter_var($checked, FILTER_VALIDATE_EMAIL)) {
				$forms_mailfalse = true;
				$forms_infosend[] = _FORMSLANG_VALIDMAIL_;
			}
			elseif(!preg_match($search, $checked)) {
				$forms_mailfalse = true;
				$forms_infosend[] = _FORMSLANG_VALIDMAIL_;
			}
			else {
				$forms_postmail = $checked;
			}
		}
		elseif(!preg_match($search, $postmail)) {
			$forms_mailfalse = true;
			$forms_infosend[] = _FORMSLANG_VALIDMAIL_;
		}
		else {
			$forms_postmail = $postmail;
		}
	}
	elseif(!preg_match($search, $postmail)) {
		$forms_mailfalse = true;
		$forms_infosend[] = _FORMSLANG_VALIDMAIL_;
	}
	else {
		$forms_postmail = $postmail;
	}
	
	unset($_POST['sendform']);
	unset($_POST['sendto']);
	$_post_email = htmlspecialchars($_POST['eMail']);
	unset($_POST['eMail']);
    
    if(!is_array($webutlercouple->mailaddresses) || !array_key_exists('sendto'.$forms_sendto, $webutlercouple->mailaddresses))
    {
        $forms_mailfalse = true;
        $forms_infosend[] = _FORMSLANG_NOADDRESSE_;
    }
    
    if(!isset($forms_mailfalse))
    {
        $forms_docroot = $webutlercouple->config['server_path'].'/includes/forms';
		$forms_usertpl = $forms_docroot.'/tpls/usermail'.(file_exists($forms_docroot.'/tpls/usermail_'.$forms_sendto.'.tpl') ? '_'.$forms_sendto : '').'.tpl';
		$forms_admintpl = $forms_docroot.'/tpls/adminmail'.(file_exists($forms_docroot.'/tpls/adminmail_'.$forms_sendto.'.tpl') ? '_'.$forms_sendto : '').'.tpl';
        require_once $forms_docroot.'/config.php';
        require_once $webutlercouple->config['server_path'].'/settings/smtp.php';
		
		$mailcontent = array();
        
    	$count = 0;
		$mailcontent['text'] = array();
    	
    	foreach($_POST as $name => $value) {
    		if($value != "") {
                $mailcontent['text'][$count]['name'] = htmlentities(str_replace('_', ' ', $name));
    			if(is_array($value)) {
					$postvalue = array();
					$mailvalue = array();
    				foreach($value as $val) {
                        $postvalue[] = htmlspecialchars($val);
                        $mailvalue[] = htmlentities($val);
    				}
					$_POST[$name] = $postvalue;
					unset($postvalue);
					$mailcontent['text'][$count]['value'] = implode('<br>', $mailvalue);
    			}
    			else {
					$_POST[$name] = htmlspecialchars($value);
                    $mailcontent['text'][$count]['value'] = htmlentities($value);
    			}
				$count++;
    		}
    	}
		$_POST['eMail'] = $_post_email;
		unset($_post_email);
    	
		$upload_filenames = array();
		if(isset($_FILES) && count($_FILES) > 0) {
			$forms_upload_dir = $webutlercouple->config['server_path'].'/content/access/formsupload';
			if(!is_dir($forms_upload_dir.'/')) mkdir($forms_upload_dir);
			
			foreach($_FILES as $filekey => $filesource) {
				$upload_filenames[] = $filekey;
			}
			
			foreach($upload_filenames as $upload_filename) {
				$uploadfiles = reOrganiceFiles($_FILES[$upload_filename]);
				
				foreach($uploadfiles as $uploadfile) {
					if($uploadfile['name'] != '') {
						$uploadedfilename = basename($uploadfile['name']);
						
						if(isset($forms_mailattachs[$upload_filename]) && strtolower($uploadfile['type']) != strtolower($forms_mailattachs[$upload_filename])) {
							$forms_infosend[] = str_replace(array('###FILE###', '###TYPE###'), array($uploadedfilename, strtolower($forms_mailattachs[$upload_filename])), _FORMSLANG_WRONGMIME_);
							continue;
						}
						
						if(move_uploaded_file($uploadfile['tmp_name'], $forms_upload_dir.'/'.$uploadedfilename)) {
							$mailcontent['text'][$count]['name'] = htmlentities($upload_filename);
							$mailcontent['text'][$count]['value'] = htmlentities($uploadedfilename);
							$count++;
						}
						else {
							$forms_infosend[] = str_replace('###FILE###', $uploadedfilename, _FORMSLANG_NOTUPLOADED_);
						}
					}
				}
			}
		}
		
		$fileusertpl = file_get_contents($forms_usertpl);
		$fileadmintpl = file_get_contents($forms_admintpl);
		foreach($forms_mailimages as $imgname => $imgvalue) {
			$forms_file = $forms_docroot.'/imgs/'.$imgvalue;
			if(file_exists($forms_file) && (substr_count($fileusertpl, '$mailcontent[\''.$imgname.'\']') > 0 || substr_count($fileadmintpl, '$mailcontent[\''.$imgname.'\']') > 0)) {
				if($fp = fopen($forms_file, 'rb', 0)) {
					$forms_img = fread($fp, filesize($forms_file));
					fclose($fp);
					$forms_size = getimagesize($forms_file);
					if($forms_size[2] == 1 || $forms_size[2] == 2 || $forms_size[2] == 3) {
						$forms_base64img = chunk_split(base64_encode($forms_img));
						$mailcontent[$imgname] = 'data:'.$forms_size['mime'].';base64,'.$forms_base64img;
					}
				}
			}
		}
		unset($fileusertpl);
		unset($fileadmintpl);
		
        $forms_bestaetigungsbetreff = $webutlercouple->mailaddresses['sendto'.$forms_sendto]['bestaetigungsbetreff'];
        $formsbestaetigungsbetreff = (!is_array($forms_bestaetigungsbetreff)) ? $forms_bestaetigungsbetreff : $forms_bestaetigungsbetreff[$forms_language];
		
		$formssentalert = '';
		if(isset($webutlercouple->mailaddresses['sendto'.$forms_sendto]['sentalert'])) {
			$forms_sentalert = $webutlercouple->mailaddresses['sendto'.$forms_sendto]['sentalert'];
			$formssentalert = (!is_array($forms_sentalert)) ? $forms_sentalert : $forms_sentalert[$forms_language];
		}
        
		$mailcontent['adminsubject'] = htmlentities($webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengerbetreff']).' '.date('j.n.y - G:i', time());
		$mailcontent['usersubject'] = htmlentities($formsbestaetigungsbetreff);
		
		$mailcontent['footer'] = '';
        if(_FORMSLANG_MAILFOOTER_ != '') {
            $forms_conf_fusslines = explode('<br>', _FORMSLANG_MAILFOOTER_);
			$forms_mailfoot = array();
            foreach($forms_conf_fusslines as $forms_conf_fussline) {
                $forms_mailfoot[] = htmlentities($forms_conf_fussline);
            }
			$mailcontent['footer'] = implode('<br>', $forms_mailfoot);
        }
        
        require_once $webutlercouple->config['server_path'].'/includes/modexts/phpmailer/mailsmtp.php';
        
		$smtp_mailfrom = isset($webutler_smtpdata) && is_array($webutler_smtpdata) && count($webutler_smtpdata) > 0 ? key($webutler_smtpdata) : false;
		
		ob_start();
		include $forms_admintpl;
		$adminmail = ob_get_contents();
		ob_end_clean();
		
		$mailsmtp_class = new MailSMTP();
		$forms_mailtohome = $mailsmtp_class->load();
		$forms_mailtohome->CharSet = 'UTF-8';
		if($smtp_mailfrom && array_key_exists($smtp_mailfrom, $webutler_smtpdata)) {
			$forms_mailtohome->isSMTP();
			$forms_mailtohome->Host = $webutler_smtpdata[$smtp_mailfrom]['server'];
			$forms_mailtohome->Username = $webutler_smtpdata[$smtp_mailfrom]['username'];
			$forms_mailtohome->Password = $webutler_smtpdata[$smtp_mailfrom]['password'];
			$forms_mailtohome->SMTPAuth = true;
			$forms_mailtohome->SMTPAutoTLS = true; 
			$forms_mailtohome->SMTPSecure = $webutler_smtpdata[$smtp_mailfrom]['ssl'] == 1 ? 'ssl' : 'tls';
			$forms_mailtohome->Port = $webutler_smtpdata[$smtp_mailfrom]['ssl'] == 1 ? 465 : 587;
			if($webutler_smtpdata[$smtp_mailfrom]['ssl'] == 0) {
				$forms_mailtohome->SMTPOptions = array(
					'ssl' => array(
						'verify_peer' => false,
						'verify_peer_name' => false,
						'allow_self_signed' => true
					)
				);
			}
			$forms_mailtohome->setFrom($smtp_mailfrom);
			if($smtp_mailfrom != $forms_postmail)
				$forms_mailtohome->addReplyTo($forms_postmail, $forms_postmail);
		}
		else {
			$forms_mailtohome->IsMail();
			$forms_mailtohome->setFrom($forms_postmail);
		}
        
		$forms_mailtohome->addAddress($webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengermail'], $webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengername']);
        $forms_mailtohome->Subject = $webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengerbetreff'];
        $forms_mailtohome->AltBody = _FORMSLANG_HTMLCOMPATIBLE_;
        $forms_mailtohome->msgHTML($adminmail);
		if(isset($forms_upload_dir)) {
			$handle = opendir($forms_upload_dir);
			while(false !== ($file = readdir($handle))) {
				if($file != '.' && $file != '..' && !is_dir($forms_upload_dir.'/'.$file.'/')) {
					$forms_mailtohome->addAttachment($forms_upload_dir.'/'.$file);
				}
			}
			closedir($handle);
		}
        $forms_mailtohome->isHTML(true);
    
        if(!$forms_mailtohome->send()) {
            $forms_infosend[] = _FORMSLANG_MAILNOTSEND_;
			$forms_mailfalse = true;
			if($forms_mailtohome->ErrorInfo != '')
				$forms_infosend[] = $forms_mailtohome->ErrorInfo;
    	}
        else {
            $forms_infosend[] = $formssentalert != '' ? $formssentalert : _FORMSLANG_SENDINGOK_;
            if($webutlercouple->mailaddresses['sendto'.$forms_sendto]['bestaetigung'] == "1") {
				ob_start();
				include $forms_usertpl;
				$usermail = ob_get_contents();
				ob_end_clean();
		
				$mailsmtp_class = new MailSMTP();
				$forms_mailtouser = $mailsmtp_class->load();
				$forms_mailtouser->CharSet = 'UTF-8';
				if($smtp_mailfrom && array_key_exists($smtp_mailfrom, $webutler_smtpdata)) {
					$forms_mailtouser->isSMTP();
					$forms_mailtouser->Host = $webutler_smtpdata[$smtp_mailfrom]['server'];
					$forms_mailtouser->Username = $webutler_smtpdata[$smtp_mailfrom]['username'];
					$forms_mailtouser->Password = $webutler_smtpdata[$smtp_mailfrom]['password'];
					$forms_mailtouser->SMTPAuth = true;
					$forms_mailtouser->SMTPAutoTLS = true; 
					$forms_mailtouser->SMTPSecure = $webutler_smtpdata[$smtp_mailfrom]['ssl'] == 1 ? 'ssl' : 'tls';
					$forms_mailtouser->Port = $webutler_smtpdata[$smtp_mailfrom]['ssl'] == 1 ? 465 : 587;
					if($webutler_smtpdata[$smtp_mailfrom]['ssl'] == 0) {
						$forms_mailtouser->SMTPOptions = array(
							'ssl' => array(
								'verify_peer' => false,
								'verify_peer_name' => false,
								'allow_self_signed' => true
							)
						);
					}
					$forms_mailtouser->setFrom($smtp_mailfrom);
					if($smtp_mailfrom != $webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengermail'])
						$forms_mailtouser->addReplyTo($webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengermail'], $webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengername']);
				}
				else {
					$forms_mailtouser->IsMail();
					$forms_mailtouser->setFrom($webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengermail'], $webutlercouple->mailaddresses['sendto'.$forms_sendto]['empfaengername']);
				}
				
                $forms_mailtouser->addAddress($forms_postmail, $forms_postmail);
                $forms_mailtouser->Subject = $formsbestaetigungsbetreff;
                $forms_mailtouser->AltBody = _FORMSLANG_HTMLCOMPATIBLE_;
                $forms_mailtouser->msgHTML($usermail);
                $forms_mailtouser->isHTML(true);
				
                if(!$forms_mailtouser->send()) {
					$forms_infosend[] = _FORMSLANG_CONFIRMNOTSEND_;
					if($forms_mailtouser->ErrorInfo != '')
						$forms_infosend[] = $forms_mailtouser->ErrorInfo;
            	}
            }
			unset($_POST);
			if(isset($forms_upload_dir)) {
				unset($_FILES);
				$handle = opendir($forms_upload_dir);
				while(false !== ($file = readdir($handle))) {
					if($file != '.' && $file != '..' && !is_dir($forms_upload_dir.'/'.$file.'/')) {
						unlink($forms_upload_dir.'/'.$file);
					}
				}
				closedir($handle);
				rmdir($forms_upload_dir);
			}
			
			usleep(500000);
        }
    }
    
    if(count($forms_infosend) > 0)
    {
        $forms_footerdata = '<script>
			(function() {
				function forms_infosend() {
					alert(\''.implode('\n', $forms_infosend).'\');'."\n";
		if(!isset($forms_mailfalse)) $forms_footerdata.= 'location.replace(window.location);';
        $forms_footerdata.= "\n".'
				}
				if(window.addEventListener) {
					window.addEventListener(\'load\', forms_infosend, false);    
				} else {
					window.attachEvent(\'onload\', forms_infosend);
				}
			})();
		</script>'."\n";
        $webutlercouple->autofooterdata[] = $forms_footerdata;
    }
}

