<?PHP

/**************************************
    Webutler V3.7 - www.webutler.de
    Copyright (c) 2008 - 2025
    Autor: Sven Zinke
    Free for any use
    Lizenz: GPL
**************************************/

if(preg_match('#includes/wbclass.php#i', $_SERVER['REQUEST_URI']))
    exit('no access');

class WebutlerClass
{
    var $getpage;
    
    var $config;
    var $htmlsource;
    
    var $compress;
    var $consents;
    var $consents_cookie;
    var $consents_window;
    var $offlinepages;
    var $mailaddresses;
    var $langconf;
    var $directories;
    var $linkhighlite;
    var $moduleslist;
    
    var $formnocookie;
    var $setnewtitlefrommod = '';
    var $errorpagetext = '';
    var $autoheaderdata = array();
    var $autofooterdata = array();
    
    var $loadcontentpage;
    
	function __construct() {}

    function WebutlerClass($name) {
        $this->name = $name;
    }
    
    function checkadmin()
    {
		if(isset($_SESSION['loggedin']))
		{
			if(($_SESSION['loggedin']['username'] == $this->config['admin_name'] 
				&& $_SESSION['loggedin']['userpass'] == $this->config['admin_pass']) || 
				($this->config['master_name'] != '' && $this->config['master_pass'] != ''
				&& $_SESSION['loggedin']['username'] == $this->config['master_name'] 
				&& $_SESSION['loggedin']['userpass'] == $this->config['master_pass']))
			{
				return true;
			}
			elseif($userissub = $this->userissubadmin($_SESSION['loggedin']['username'], $_SESSION['loggedin']['userpass']))
			{
				return true;
			}
		}
		
        return false;
    }
    
    function checktoken()
    {
		if(isset($_SESSION['admintoken']) && ((isset($_GET['admintoken']) && $_GET['admintoken'] == $_SESSION['admintoken']) ||
		  (isset($_POST['admintoken']) && $_POST['admintoken'] == $_SESSION['admintoken'])))
			return true;
		
        return false;
    }
    
    function userissubadmin($name, $pass)
    {
		if(is_array($this->config['sub_admins']) && count($this->config['sub_admins']) > 0) {
			foreach($this->config['sub_admins'] as $sub_admin) {
				if($sub_admin['name'] == $name && $sub_admin['pass'] == $pass) {
					return $sub_admin;
				}
			}
		}
		
        return false;
    }
    
    function pagenamesigns($name)
    {
		$name = rawurldecode($name);
		$name = preg_replace('#[\s]+#', ' ', $name);
		$name = trim($name);
		$name = str_replace(array(' ', '-'), array('_', '_'), $name);
		$name = preg_replace('#[^_[:alnum:]]#usi', '', $name);
		$name = mb_strtolower($name, 'UTF-8');
		$name = rawurlencode($name);
        
        return $name;
    }
    
    function filenamesigns($name)
    {
		$name = preg_replace('#[\s]+#', ' ', $name);
		$name = trim($name);
		$name = str_replace(array(' ', '-'), array('_', '_'), $name);
    	$name = strtolower($name);
    	$name = preg_replace("/[^a-z0-9_]/", "", $name);
        
        return $name;
    }
    
    function checkconsents()
	{
		if($this->config['cookie_consents'] == 1) {
			$consentspath = $this->config['server_path'].'/includes/consents';
			$lang = isset($_SESSION['language']) && file_exists($consentspath.'/lang/'.$_SESSION['language'].'.php') ? $_SESSION['language'] : $this->config['defaultlang'];
			require_once $consentspath.'/lang/'.$lang.'.php';
			
			if(isset($_POST['set_consents_cookie']) && $_POST['set_consents_cookie'] == 1) {
				$cookie_vars = array();
				if(isset($_POST['consents_cookie_var']) && count($_POST['consents_cookie_var']) > 0) {
					foreach($_POST['consents_cookie_var'] as $cookie_var) {
						foreach($this->consents as $consent) {
							if($consent['var'] == $cookie_var) {
								$cookie_vars[] = $cookie_var;
								break;
							}
						}
					}
				}
				
				setcookie('consents', json_encode($cookie_vars), [
					'expires' => time()+60*60*24*365*2,
					'path' => '/',
					'domain' => '.'.$_SERVER['HTTP_HOST'],
					'secure' => isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off' ? true : false,
					'httponly' => false,
					'samesite' => 'strict'
				]);
				
				header('location: '.$_SERVER['REQUEST_URI']);
			}
			
			if(isset($_COOKIE['consents'])) {
				$this->consents_cookie = json_decode($_COOKIE['consents'], true);
				if(is_array($this->consents_cookie) && count($this->consents_cookie) > 0) {
					foreach($this->consents as $consent) {
						if(is_array($consent) && in_array($consent['var'], $this->consents_cookie) && $consent['position'] != '' && $consent['source'] != '') {
							if($consent['position'] == 'top') {
								$this->autoheaderdata[] = $consent['source'];
							}
							elseif($consent['position'] == 'bottom') {
								$this->autofooterdata[] = $consent['source'];
							}
						}
					}
				}
			}
			
			ob_start();
			require_once $consentspath.'/tpls/consents.tpl';
			$this->consents_window = ob_get_contents();
			ob_end_clean();
		}
    }
    
    function loadpage()
    {
        $_getpage = $this->config['server_path'].'/content/pages/'.$this->getpage;
		
		if($this->config['modrewrite'] == '1' && $_SERVER['REQUEST_URI'] != '' && !preg_match('#index.php#i', $_SERVER['REQUEST_URI']))
		{
			$request_uri = $_SERVER['REQUEST_URI'];
			
			if($this->config['langfolder'] == '1' || $this->config['directories'] == '1') {
				$language = '';
				$directory = '';
				$uri = '';
				
				if($this->config['langfolder'] == '1') {
					$checklang = $this->setlangasdirectory($this->getpage);
					$lang = $checklang[0];
					$page = $checklang[1];
					
					if($lang != '')
						$language = '/'.$lang;
				}
				else {
					//$page = $this->getpage;
					$page = $this->getpage == $this->config['startpage'] ? '' : $this->getpage;
				}
				
				if(array_key_exists('pages', $this->directories) && count($this->directories['pages']) > 0) {
					foreach($this->directories['pages'] as $dir => $dirpages) {
						if(in_array($this->getpage, $dirpages)) {
							$directory = '/'.$dir;
							break;
						}
					}
				}
				
				if($language == '/'.$this->config['defaultlang'] && $directory == '' && $page == '' && !strpos($request_uri, '-')) {
					$uri = '';
				}
				else {
					$uri = $language.$directory;
				}
				
				$uri = $uri.'/'.$page;
				if(strpos($request_uri, '-')) {
					if($page == '')
						$uri = $uri.'index';
					$uri = $uri.substr($request_uri, strpos($request_uri, '-'));
				}
				if(substr($uri, -1) != '/' && substr($uri, (strlen($this->config['urlext'])*(-1))) != $this->config['urlext'])
					$uri = $uri.$this->config['urlext'];
				
				if(strtolower($uri) != strtolower($request_uri)) {
					header($_SERVER['SERVER_PROTOCOL'].' 301 Moved Permanently', true, 301);
					header('Location: '.$this->config['homepage'].$uri);
				}
			}
			
			if($this->config['urlext'] != '' && substr($request_uri, -1, 1) != '/') {
				$before_extension = substr($request_uri, 0, strpos($request_uri, '.'));
				
				$extension = substr($request_uri, strpos($request_uri, '.'));
				$extension = strtolower($extension);
				
				if($this->getpage != $this->config['startpage'] && $extension != $this->config['urlext']) {
					header($_SERVER['SERVER_PROTOCOL'].' 301 Moved Permanently', true, 301);
					header('Location: '.$this->config['homepage'].$before_extension.$this->config['urlext']);
				}
			}
		}
		
		if(!file_exists($_getpage) || $this->getpage == $this->config['errorpage']) 
    	{
            header($_SERVER['SERVER_PROTOCOL'].' 410 Gone', true, 410);
    		$this->errorpage(_SYSLANG_NOTEXIST_);
    	}
    	elseif($this->formnocookie == true) 
    	{
    		$this->errorpage(_SYSLANG_NOCOOKIES_);
    	}
    	elseif(in_array($this->getpage, $this->offlinepages))
        {
            header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found', true, 404);
            $this->errorpage(_SYSLANG_NOTPUBLISHED_);
        }
    	elseif(!$this->accesspage($this->getpage))
    	{
            header($_SERVER['SERVER_PROTOCOL'].' 403 Forbidden', true, 403);
    		$this->errorpage(_SYSLANG_NOAUTH_);
    	}
        else
        {
            ob_start();
            $webutlercouple = $this;
            $showpartfor = (isset($_SESSION['userauth']['groupid'])) ? $_SESSION['userauth']['groupid'] : array();
    		include_once $_getpage;
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
			
			if($this->consents_window != '')
			{
				$this->loadcontentpage = str_replace('</body>', "\n".$this->consents_window."\n</body>", $this->loadcontentpage);
			}
			
            $this->loadcontainer('block');
    		$this->deleteofflines('page');
            $this->loadcontainer('menu');
            $this->removewbcomments();
            $this->basetohead();
			$this->loadcompressed();
            $this->lookforms();
            $this->autoheaderdata();
            $this->autofooterdata();
			$this->canonicaltag();
    		$this->rewriting();
            if(isset($this->setnewtitlefrommod) && $this->setnewtitlefrommod != '')
            {
                $this->loadcontentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '${1}'.$this->setnewtitlefrommod.'${3}', $this->loadcontentpage);
            }
        }
    }
    
    function removewbcomments()
    {
		$this->loadcontentpage = preg_replace('#<!-- begin_([^ ]+) -->#Usi', '', $this->loadcontentpage);
		$this->loadcontentpage = preg_replace('#<!-- end_([^ ]+) -->#Usi', '', $this->loadcontentpage);
    }
    
    function loadcontainer($container, $isadmin = '', $mode = '')
    {
    	$blocks = $this->config['server_path']."/content/".$container."s";
        
    	$handle = opendir($blocks);
    	while(false !== ($blockfile = readdir($handle)))
        {
    		if($blockfile != "." && $blockfile != ".." && $blockfile != ".htaccess" && preg_match("<!-- ".$container."_".$blockfile." -->", $this->loadcontentpage))
            {
    		    if($isadmin == '1')
                {
        			$block = file_get_contents($blocks."/".$blockfile);
                    if($container == 'menu' && $mode == '')
                        $block = $this->setdefaultlink($block, $blockfile);
    		    }
    		    else
                {
        			ob_start();
                    $webutlercouple = $this;
                    $showpartfor = (isset($_SESSION['userauth']['groupid'])) ? $_SESSION['userauth']['groupid'] : array();
        			include $blocks."/".$blockfile;
        			$block = ob_get_contents();
        			ob_end_clean();
        			if($container == 'menu' && !$this->checkadmin())
                        $block = $this->deleteofflines('menu', $block);
                    if($container == 'menu')
                        $block = $this->setdefaultlink($block, $blockfile);
    			}
    			$this->loadcontentpage = str_replace("<!-- ".$container."_".$blockfile." -->", $block, $this->loadcontentpage);
    		}
    	}
    	closedir($handle);
    }
    
    function getlanguagefromuri()
    {
		$lang = '';
		if($this->config['modrewrite'] == '1' && $this->config['languages'] == '1' && $this->config['langfolder'] == '1' && count($this->langconf) > 0) {
			$request_uri = $_SERVER['REQUEST_URI'];
			if(preg_match('/\?/', $request_uri)) {
				$params = explode('?', $request_uri);
				$request_uri = $params[0];
			}
			$language = array_values(array_filter(array_map('trim', $request_uri), 'strlen'));
			$language = preg_replace("~[^a-z]~", "", $language);
			if(strlen($language) == 2 && in_array($language, $this->langconf['code']))
				$lang = substr($language, 0, 2);
			/*
			$language = substr($_SERVER['REQUEST_URI'], (substr($_SERVER['REQUEST_URI'], 0, 1) == '/' ? 1 : 0), 3);
			$language = preg_replace("~[^a-z\/]~", "", $language);
			if(strlen($language) == 3 && substr($language, 2, 1) == '/' && in_array(substr($language, 0, 2), $this->langconf['code'])) {
				$lang = substr($language, 0, 2);
			}
			*/
		}
		return $lang;
    }
    
    function uritoget()
    {
		if($this->config['modrewrite'] == '1' && !preg_match('#/index.php#i', $_SERVER['REQUEST_URI']))
		{
			$request_uri = $_SERVER['REQUEST_URI'];
			if(preg_match('/\?/', $request_uri)) {
				$params = explode('?', $request_uri);
				$request_uri = $params[0];
			}
			$segments = explode('/', $request_uri);
			$segments = array_values(array_filter(array_map('trim', $segments), 'strlen'));
			$uri = count($segments) > 0 ? $segments[count($segments)-1] : '';
			
			/*
echo $request_uri;
echo '<br>';
print_r($segments);
echo '<br>';
echo $segments[0];
echo '<br>';
echo $uri;
			
			if($this->config['directories'] == '0' && $segments[0] != $uri) {
				header($_SERVER['SERVER_PROTOCOL'].' 301 Moved Permanently', true, 301);
				header('Location: '.$this->config['homepage'].$uri);
			}
			*/
			
			if($uri != '')
			{
				if($this->config['urlext'] != '')
					$uri = substr($uri, 0, (strlen($this->config['urlext'])*(-1)));
				
				$uri = 'wbpagefile-'.$uri;
				
				$getvars = explode('-', $uri);
				for($i = 0; $i < count($getvars); $i += 2) 
				{
					if(isset($getvars[($i+1)]) && $getvars[($i+1)] != '')
						$_GET[$getvars[$i]] = $getvars[($i+1)];
				}
//print_r($_GET);
			}
		}
    }
    
    function verifygetpage()
    {
		$lang = $this->getlanguagefromuri();
        
        if(!isset($_GET['wbpagefile']) || $_GET['wbpagefile'] == '' || $_GET['wbpagefile'] == 'index')
        {
			if($lang != '' || ($this->config['languages'] == '1' && array_key_exists('homes', $this->langconf) && count($this->langconf['homes']) > 0)) {
				if($lang == '') $lang = $this->config['defaultlang'];
				$startfile = array_key_exists($lang, $this->langconf['homes']) ? $this->langconf['homes'][$lang] : $this->config['startpage'];
			}
			else {
				$startfile = $this->config['startpage'];
			}
            
            if($startfile == '' || !file_exists($this->config['server_path'].'/content/pages/'.$startfile) || (!$this->checkadmin() && (in_array($startfile, $this->offlinepages) || !$this->accesspage($startfile))))
        	{
        		$directory = $this->config['server_path'].'/content/pages';				
        		$handle = opendir ($directory);
        		$filearray = array();
        		while(false !== ($file = readdir($handle)))
        		{ 
        			$ext = substr($file, -4);
        			if($file != '.' && $file != '..' && $file != '.htaccess' && $ext != '.bak' && $ext != '.tmp' && $file != $this->config['errorpage'] && !in_array($file, $this->offlinepages) && $this->accesspage($file))
        			{
        				$startfile = $file;
        				break;
        			}
        		}
        		closedir($handle);
        	}
            $_getpage = $startfile;
        }
        else
        {
        	$_getpage = $this->pagenamesigns($_GET['wbpagefile']);
			
			if(!file_exists($this->config['server_path'].'/content/pages/'.$_getpage)) {
				if($lang != '') {
					if(in_array($lang.'_'.$_getpage, $this->langconf['pages'][$lang])) {
						$_getpage = $lang.'_'.$_getpage;
					}
					else {
						foreach($this->langconf['pages'][$lang] as $page) {
							foreach($this->langconf['code'] as $langcode) {
								if($page == $langcode.'_'.$_getpage) {
									$_getpage = $langcode.'_'.$_getpage;
									break;
									break;
								}
							}
						}
					}
				}
				else {
					if($this->config['languages'] == '1' && count($this->langconf) > 0 && isset($this->langconf['code'])) {
						foreach($this->langconf['code'] as $langcode) {
							if(file_exists($this->config['server_path'].'/content/pages/'.$langcode.'_'.$_getpage)) {
								$_getpage = $langcode.'_'.$_getpage;
								break;
							}
						}
					}
				}
			}
    	}
        
        $this->getpage = $_getpage;
    }
    
    function errorpage($errorpagetext)
    {
        if(!$this->checkadmin() && $this->config['errorpage'] != '' && file_exists($this->config['server_path'].'/content/pages/'.$this->config['errorpage']))
        {
    		ob_start();
            $webutlercouple = $this;
            $webutlercouple->errorpagetext = $errorpagetext;
    		include $this->config['server_path'].'/content/pages/'.$this->config['errorpage'];
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
			
            $this->loadcontainer('block');
    		$this->deleteofflines('page');
            $this->loadcontainer('menu');
            $this->removewbcomments();
            $this->basetohead();
			$this->loadcompressed();
            $this->lookforms();
            $this->autoheaderdata();
            $this->autofooterdata();
    		$this->rewriting();
            $this->loadcontentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '${1}'._SYSLANG_ERRORTITLE_.'$3', $this->loadcontentpage);
        }
        else
        {
            if(isset($_SESSION['language']) && array_key_exists('pages', $this->langconf) && !$this->checkadmin())
            {
                $home = $this->langconf['homes'][$_SESSION['language']];
                $link = ($this->config['modrewrite'] == '1') ? $home.$this->config['urlext'] : 'index.php?wbpagefile='.$home;
            }
            else
            {
                //$ext = ($this->config['modrewrite'] == '1') ? $this->config['urlext'] : '.php';
                //$link = 'index'.$ext;
                $link = '';
            }
            
            $lastpage = (isset($_SESSION['history']['lastpage']) && $_SESSION['history']['lastpage'] != '') ? $_SESSION['history']['lastpage'] : $this->config['homepage'].'/';
            
        	$ausgabe = $this->htmlsource['page_header'];
            $ausgabe.= '<title>'._SYSLANG_ERRORTITLE_.'</title>'."\n".
				'<base href="'.$this->config['homepage'].'/" />'."\n".
				'<link href="admin/system/css/admin.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
            $ausgabe.= $this->htmlsource['close_page_header'];
            $ausgabe.= '<div class="webutler_errortext">'."\n".
				'<strong>'.$errorpagetext.'</strong>'."\n".
				'<br /><br /><br />'."\n".
				'<a href="'.$lastpage.'">'._SYSLANG_ERRORBACK_.'</a> | <a href="'.$link.'">'._SYSLANG_ERRORHOME_.'</a>'."\n".
				'</div>'."\n";
            $ausgabe.= $this->htmlsource['page_footer'];
            
            $this->loadcontentpage = $ausgabe;
        }
    }
    
    function sethistory()
    {
		if($this->config['modrewrite'] == '1' && isset($_SERVER['REQUEST_URI']) && strpos($_SERVER['REQUEST_URI'], '?')) {
			$server_request_uri = explode('?', $_SERVER['REQUEST_URI']);
			$_SERVER['REQUEST_URI'] = $server_request_uri[0];
		}
		
		if(!isset($_SERVER['HTTP_X_REQUESTED_WITH']) || strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest') {
			if(isset($_SESSION['history']['thispage']) && $_SESSION['history']['thispage'] != 'http'.(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']) {
				$_SESSION['history']['lastpage'] = $_SESSION['history']['thispage'];
			}
			else {
				$_SESSION['history']['lastpage'] = $this->config['homepage'].'/';
			}

			if((strrpos($_SERVER['REQUEST_URI'], '.') && ($this->config['urlext'] != '' && substr($_SERVER['REQUEST_URI'], strlen($this->config['urlext'])*(-1)) == $this->config['urlext']) || preg_match('#index\.php\?wbpagefile=#', $_SERVER['REQUEST_URI'])) || (!strrpos($_SERVER['REQUEST_URI'], '.') && ($this->config['urlext'] == '' || substr($_SERVER['REQUEST_URI'], -1, 1) == '/'))) {
				$_SESSION['history']['thispage'] = 'http'.(isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on' ? 's' : '').'://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			}
		}
    }
    
    function basetohead()
    {
    	if(!preg_match('#<base href="(.*?)</head>#Usi', $this->loadcontentpage))
        {
            $basetag = "\n\t".'<base href="'.$this->config['homepage'].'/" />';
            
        	$this->loadcontentpage = str_replace('<head>', '<head>'.$basetag, $this->loadcontentpage);
        }
    }
    
    function loadcompressed()
    {
		$compressed = $this->config['server_path'].'/content/compress';
		
		$oldfile = '';
		$handle = opendir($compressed);
		while(false !== ($file = readdir($handle)))
		{
			$ext = substr($file, strrpos($file, '.') + 1);
			if($ext == 'css') {
				$this->autoheaderdata[] = '<link href="content/compress/'.$file.'?v='.filemtime($compressed.'/'.$file).'" defer="defer" media="all" type="text/css" rel="stylesheet" />';
			}
			if($ext == 'js') {
				$this->autofooterdata[] = '<script src="content/compress/'.$file.'?v='.filemtime($compressed.'/'.$file).'" defer="defer"></script>';
			}
		}
    }
    
    function autoheaderdata()
    {
        if(count($this->autoheaderdata) > 0)
        {
			$headerdata = '';
            
            foreach($this->autoheaderdata as $autoheader)
            {
				if($autoheader != '')
					$headerdata.= "\t".$autoheader."\n";
            }
			
        	$this->loadcontentpage = str_replace('</head>', $headerdata.'</head>', $this->loadcontentpage);
        }
    }
    
    function autofooterdata()
    {
        if(count($this->autofooterdata) > 0)
        {
            $footerdata = '';
            
            foreach($this->autofooterdata as $autofooter)
            {
				if($autofooter != '')
					$footerdata.= $autofooter."\n";
            }
			
        	$this->loadcontentpage = str_replace('</body>', $footerdata.'</body>', $this->loadcontentpage);
        }
    }
    
    function canonicaltag()
    {
    	if(!preg_match('#<head>(.*?)rel="canonical"(.*?)</head>#Usi', $this->loadcontentpage))
        {
			$canonicalurl = $this->config['homepage'].($this->getpage == $this->config['startpage'] ? '/' : '/index.php?wbpagefile='.$this->getpage);
			$matetags = '<meta property="og:url" content="'.$canonicalurl.'" />'."\n\t";
			$matetags.= '<meta property="og:type" content="website" />'."\n\t";
			$matetags.= '<link href="'.$canonicalurl.'" rel="canonical" />';
			if(preg_match('#<head>(.*?)property="og:image"(.*?)</head>#Usi', $this->loadcontentpage)) {
				/*
				$dom = new DOMDocument;
				libxml_use_internal_errors(true);
				$dom->loadHTML($this->loadcontentpage);
				libxml_clear_errors();
				foreach($dom->getElementsByTagName('meta') as $tag) {
					if(stripos($tag->getAttribute('property'), 'og:image') !== false) {
						$content = $tag->getAttribute('content');
						if(substr($content, 0, 4) != 'http') {
							if(substr($content, 0, 1) == '/')
								$content = substr($content, 1);
							
							$tag->setAttribute('content', $this->config['homepage'].'/'.$content);
						}
					}
				}
				$this->loadcontentpage = $dom->saveHTML();
				*/
				$dom = new DOMDocument;
				$dom->preserveWhiteSpace = true;
				$dom->formatOutput = false;
				libxml_use_internal_errors(true);
				$dom->loadHTML('<?xml encoding="UTF-8">'.$this->loadcontentpage);
				libxml_use_internal_errors(false);
				libxml_clear_errors();
				$dom->encoding = 'UTF-8';
				$xpath = new DOMXPath($dom);
				foreach($xpath->query('//meta[@property="og:image"]') as $ogimage)
				{
					$content = $ogimage->getAttribute('content');
					if(substr($content, 0, 4) != 'http') {
						if(substr($content, 0, 1) == '/')
							$content = substr($content, 1);
						
						$ogimage->setAttribute('content', $this->config['homepage'].'/'.$content);
					}
				}
				$savedhead = $xpath->query('/html/head');
				$head = preg_replace('#<(?:/?)head[^>]*?'.'>#Usi', '', $dom->saveHTML($savedhead->item(0)));
				//$head = preg_replace('#<(?:/?)head[^>]*?'.'>#Usi', '', $dom->saveXML($savedhead->item(0)));
				$this->loadcontentpage = preg_replace('#(<head>)(.*?)(</head>)#Usi', '${1}'.$head.'$3', $this->loadcontentpage);
			}
            
        	$this->loadcontentpage = str_replace('</head>', "\t".$matetags."\n".'</head>', $this->loadcontentpage);
        }
    }
    
    function lookforms()
    {
    	if(preg_match('#</form>#Usi', $this->loadcontentpage))
    	{
            $antixpostcode = $this->antixpostcode();
            $this->loadcontentpage = str_replace('</form>', '<input type="hidden" name="webutler_autokill" value="'.md5($antixpostcode).'" />'."\n".'</form>', $this->loadcontentpage);
        }
    }
    
    function setdefaultlink($block, $file)
    {
        $defaults = array_key_exists('files', $this->linkhighlite) ? $this->linkhighlite['files'] : '';
        
        if($defaults != '' && count($defaults) > 0)
        {
            foreach($defaults as $default)
            {
                if($file == $default[1])
                {
                    $block = $this->setclasstolink($block, $default[0]);
					
					if(isset($default[2]) && $default[2] == 'yes')
					{
						$block = $this->setclasstoparents($block, $default[0]);
					}
					
					break;
                }
            }
        }
        
        if($this->config['modrewrite'] == '1')
        {
            $folders = array_key_exists('folders', $this->linkhighlite) ? $this->linkhighlite['folders'] : '';
            
            if($folders != '' && count($folders) > 0) 
            {
                $domain = substr($this->config['homepage'], strpos($this->config['homepage'], '//')+2);
                $subfolder = substr($domain, strpos($domain, '/'));
				if($subfolder != $domain && strlen($subfolder) > 0)
					$uri = substr($_SERVER['REQUEST_URI'], strlen($subfolder));
				else
					$uri = $_SERVER['REQUEST_URI'];
				
                $after = '';
                if(preg_match("#\/".($this->getpage.$this->config['urlext'])."#Usi", $uri))
                    $after = $this->config['urlext'];
                elseif(preg_match("#\/".($this->getpage)."(?:([\w\d\-]+))?".($this->config['urlext'])."#Usi", $uri))
                    $after = '-';
                
                $directories = substr($uri, 0, strpos($uri, '/'.$this->getpage.$after));
                if(substr($directories, 0, 1) == '/')
                    $directories = substr($directories, 1, strlen($directories));
                if(substr($directories, -1) == '/')
                    $directories = substr($directories, 0, strlen($directories)-1);
                
                if($after != '' && $directories != '')
                {
                    $dirs = explode('/', $directories);
                    $sub = '';
                    for($i = 0; $i < count($dirs); $i++)
                    {
						if($i == 0 && $this->config['langfolder'] == '1' && strlen($dirs[0]) == 2 && ctype_alpha($dirs[0]) && $this->config['languages'] == '1' && count($this->langconf) > 0 && in_array($dirs[0], $this->langconf['code']))
							continue;
						
						$sub = $sub != '' ? $sub.'/'.$dirs[$i] : $dirs[$i];
						foreach($folders as $folder)
						{
							$return = ($i < count($dirs)-1 || ($folder[3] == 'yes' && $i == count($dirs)-1)) ? 'yes' : 'no';
							if($return == 'yes' && $folder[1] == $sub && $folder[2] == $file)
							{
								$block = $this->setclassoffolder($block, $folder[0], $folder[1]);
							}
						}
                    }
                }
            }
        }
        
        return $block;
    }
    
    function setclasstolink($block, $class)
    {
        //$pattern = '~<li(?:([^>]+))? >(?:([^\/]+))?<a([^>]+)(href=\")(index\.php\?wbpagefile='.$this->getpage.')([\&|\"])(?:([^>]+))?'.'>~Umsi';
        $pattern = '~<li(?:([^>]+))?>(?:([^\/]+))?<a([^>]+)(href=\")(index\.php\?wbpagefile='.$this->getpage.')([\"])(?:([^>]+))?'.'>~Umsi';
        
        $block = preg_replace_callback($pattern, function($match) use ($class)
        {
            if(preg_match('#class=\"#', $match[1]))
            {
				$get_classes = preg_replace('#class=\"([^"]+)\"#Umsi', '$1', $match[1]);
				$classes = explode(' ', $get_classes);
				if(!in_array($class, $classes)) {
					$match[1] = preg_replace('#class=\"([^"]+)\"#Umsi', 'class="$1 '.$class.'"', $match[1]);
				}
            }
            else
            {
                $match[1] = ' class="'.$class.'"'.$match[1];
            }
            
            $result = $match[3].$match[4].$match[5].$match[6];
            if(isset($match[7])) $result.= $match[7];
            
            return '<li'.$match[1].'>'.$match[2].'<a'.$result.'>';
            
        }, $block);
        
        return $block;
    }
	
    function escapescripts($source)
    {
		if(preg_match('#<script#i', $source)) {
			$source = preg_replace_callback(
				'#(<script)(.*?)(</script>)#si',
				function($matches) {
					return '<!-- '.rawurlencode($matches[1].$matches[2].$matches[3]).' -->';
				},
			$source);
		}
		
		if(preg_match('#<\?#i', $source)) {
			$source = preg_replace_callback(
				'#(<\?)(.*?)(\?>)(?:([^<>]+))?(?:(>))?#si',
				function($matches) {
					if(isset($matches[5]))
						return ' data-php="'.rawurlencode($matches[1].$matches[2].$matches[3]).'"'.$matches[4].$matches[5];
					else
						return '<!-- '.rawurlencode($matches[1].$matches[2].$matches[3]).' -->'.(isset($matches[4]) ? $matches[4] : '');
				},
			$source);
		}
		
		return $source;
    }
	
    function unescapescripts($source)
    {
		if(preg_match('#%3Cscript#i', $source)) {
			$source = preg_replace_callback(
				'#(<!-- )(%3Cscript)(.*?)(%3C%2Fscript%3E)( -->)#si',
				function($matches) {
					return rawurldecode($matches[2].$matches[3].$matches[4]);
				},
			$source);
		}
		
		if(preg_match('#%3C%3F#i', $source)) {
			$source = preg_replace_callback(
				'#(<!-- )(%3C%3F)(.*?)(%3F%3E)( -->)#si',
				function($matches) {
					return rawurldecode($matches[2].$matches[3].$matches[4]);
				},
			$source);
			$source = preg_replace_callback(
				'#( data-php=")(%3C%3F)(.*?)(%3F%3E)(")#si',
				function($matches) {
					return rawurldecode($matches[2].$matches[3].$matches[4]);
				},
			$source);
		}
		
		return $source;
    }
	
    function setclasstoparents($block, $class)
    {
		$block = str_replace('&nbsp;', '&amp;nbsp;', $block);
		$block = $this->escapescripts($block);
		
		$dom = new DOMDocument;
		$dom->preserveWhiteSpace = true;
		$dom->formatOutput = false;
		libxml_use_internal_errors(true);
		$dom->loadHTML('<?xml encoding="UTF-8">'.$block);
		libxml_use_internal_errors(false);
		libxml_clear_errors();
		$dom->encoding = 'UTF-8';
		$xpath = new DOMXPath($dom);
		foreach($xpath->query('//li[@class="'.$class.'"]') as $node)
		{
			$nodepath = $node->getNodePath();
			$segment = $dom->getElementsByTagName('body')->item(0);
			$elements = explode('/', $nodepath);
			array_pop($elements);
			foreach($elements as $element)
			{
				$nodename = preg_match('#\[#', $element) ? substr($element, 0, strpos($element, '[')) : $element;
				$key = preg_match('#\[#', $element) ? preg_replace("/[^0-9]/", "", $element)-1 : 0;
				
				if($nodename == 'li') {
					$k = 0;
					foreach($segment->childNodes as $level) {
						if($level->nodeName == 'li') {
							if($k == $key) {
								if($level->hasAttribute('class')) {
									$oldclass = $level->getAttribute('class');
									$classes = explode(' ', $oldclass);
									if(!in_array($class, $classes)) {
										$level->setAttribute('class', $oldclass.' '.$class);
									}
								}
								else {
									$level->setAttribute('class', $class);
								}
								$segment = $level;
								break;
							}
							$k++;
						}
					}
				}
				else {
					$k = 0;
					foreach($segment->childNodes as $level) {
						if($level->nodeName == $nodename) {
							if($k == $key) {
								$segment = $level;
								break;
							}
							$k++;
						}
					}
				}
			}
		}
		
		$body = $xpath->query('/html/body');
		$result = preg_replace('#<(?:/?)body[^>]*?'.'>#Usi', '', $dom->saveHTML($body->item(0)));
		$result = $this->unescapescripts($result);
		$result = str_replace('&amp;nbsp;', '&nbsp;', $result);
        
        return $result;
    }
	
    function setclassoffolder($block, $class, $folder)
    {
        if(array_key_exists('pages', $this->directories) && count($this->directories['pages']) > 0)
        {
            $dirpages = $this->directories['pages'];
            
            foreach($dirpages as $dir => $pages)
            {
				if($folder == $dir)
				{
					foreach($pages as $page)
					{
                        if($page != $this->getpage)
                        {
                            $pattern = '~<li(?:([^>]+))?>(?:([^\/]+))?<a([^>]+)(href=\")(index\.php\?wbpagefile='.$page.')([\&|\"])(?:([^>]+))?'.'>~Umsi';
                            
                            $block = preg_replace_callback($pattern, function($match) use ($class)
                            {
                                if(preg_match('#class=\"#', $match[1]))
                                {
                                    $match[1] = preg_replace('#class=\"([^"]+)\"#Umsi', 'class="$1 '.$class.'"', $match[1]);
                                }
                                else
                                {
                                    $match[1] = ' class="'.$class.'"'.$match[1];
                                }
                                
                                $result = $match[3].$match[4].$match[5].$match[6];
                                if(isset($match[7])) $result.= $match[7];
                                
                                return '<li'.$match[1].'>'.$match[2].'<a'.$result.'>';
                                
                            }, $block);
                        }
                    }
                }
            }
        }
            
        return $block;
    }
	
    function rewriting()
    {
    	$type = '([href|action]=\"(?:'.$this->config['homepage'].'\/)?)';
    	$link = '(index\.php\?wbpagefile=)';
    	
    	if($this->config['modrewrite'] == '1')
        {
			$urlgetvars = 30;
    		$count = ($urlgetvars*2+2);
    		$name = '([\w\d\%\_]+)';
    		$var = '(?:&(?:amp;)?([\w\d\_]+))?';
    		$param = '(?:=([\w\d\%\_\^]+))?';
    		
    		$h = 0;
        	while($h < 2)
            {
            	for($i = 0; $i < ($count+$h); $i++)
                {
                    if($h == 0 || $h == 1)
                        $search = $type.$link.$name;
                    
                    //for($k = (3+$h); $k <= $i; $k++)
                    for($k = (4+$h); $k <= $i; $k++)
                    {
                        $search.= $var.$param;
                        $k = $k+1;
                    }
					
                    $this->loadcontentpage = preg_replace_callback('#'.$search.'\"#Usi', array('WebutlerClass', 'getpagedirectory'), $this->loadcontentpage);
                    $this->loadcontentpage = preg_replace_callback('#'.$search.'(\#)([\w\d\_]+)\"#Usi', array('WebutlerClass', 'getpagedirectory'), $this->loadcontentpage);
            	}
                $h++;
        	}
    	}
    	else
        {
            $search = $type.$link.'('.$this->config['startpage'].')';
            $this->loadcontentpage = preg_replace('#'.$search.'\"#Usi', '${1}index.php"', $this->loadcontentpage);
    		$this->loadcontentpage = preg_replace('#'.$search.'\#([\w\d\_]*)\"#Usi', '${1}index.php#$4"', $this->loadcontentpage);
    		$this->loadcontentpage = preg_replace('#'.$search.'&(amp;)?((?!amp;)[^\"]*)\"#Usi', '${1}index.php?$5"', $this->loadcontentpage);
    	}
    }
    
    function setlangasdirectory($page)
    {
        $lang = '';
		if($this->config['modrewrite'] == '1' && $this->config['languages'] == '1' && count($this->langconf) > 0 && $this->config['langfolder'] == '1') {
        	$language = $this->getlangfrompage($page);
			if($language && $language != '') {
				$lang = $language;
				
				if(isset($this->langconf['homes'][$language]) && $page == $this->langconf['homes'][$language]) {
					$page = '';
				}
				else {
					if(substr($page, 2, 1) == '_') {
						$checklang = substr($page, 0, 2);
						$checklang = preg_replace("~[^a-z]~", "", $checklang);
						
						if(strlen($checklang) == 2 && $checklang == $lang && in_array($page, $this->langconf['pages'][$lang])) {
							$page = substr($page, 3);
						}
					}
				}
			}
		}
		else {
			if($page == $this->config['startpage']) {
				$page = '';
			}
		}
		
		return array($lang, $page);
    }
    
    function getdirectoryforpage($page)
    {
		$frontpages = array();
		if($this->config['languages'] == '1' && $this->config['langfolder'] == '1' && count($this->langconf) > 0) {
            foreach($this->langconf['homes'] as $lang => $frontpage) {
				$frontpages[] = $frontpage;
			}
		}
		else {
			$frontpages[] = $this->config['startpage'];
		}
		
        $pagedir = '';
        if(!in_array($page, $frontpages) && $this->config['directories'] == 1 && is_array($this->directories) && count($this->directories) > 0)
        {
            foreach($this->directories['pages'] as $dir => $pages)
            {
                if(in_array($page, $pages))
                {
                    $pagedir = $dir.'/';
                    break;
                }
            }
        }
        return $pagedir;
    }
    
    function getpagedirectory($match)
    {
		$pagedir = $this->getdirectoryforpage($match[3]);
        $checklang = $this->setlangasdirectory($match[3]);
		$lang = $checklang[0] != '' ? $checklang[0].'/' : '';
		$page = $checklang[1];
        $matches = count($match);
		if($lang == $this->config['defaultlang'].'/' && $pagedir == '' && $page == '' && $matches < 5)
			$result = $match[1];
		else
			$result = $match[1].$lang.$pagedir.$page;
        
        $hasanchor = '';
        if($matches > 3)
        {
			if($page == '' && isset($match[4]))
				$result.= 'index';
			
            for($i = 4; $i < $matches; $i++)
            {
                if($match[$i] == '#')
                {
                    $hasanchor = $match[$i+1];
                    break;
                }
                else
                {
                    $result.= '-'.$match[$i].'-'.$match[$i+1];
                    $i = $i+1;
                }
            }
        }
        
		if($result != $match[1] && substr($result, -1) != '/' && substr($result, -4) != $this->config['urlext']) {
			$result.= $this->config['urlext'];
		}
        
        if($hasanchor != '') $result.= '#'.$hasanchor;
        
        return $result.'"';
    }
    
    function accesspage($page)
    {
        $userdbfile = $this->config['server_path'].'/content/access/users.db';
        
        if(file_exists($userdbfile) && class_exists('SQLite3'))
        {
            $userdb = new SQLite3($userdbfile);
            
            $blocks = $userdb->query("SELECT id, pages FROM blocks WHERE blocks.id = '1' LIMIT 1");
        	if($block = $blocks->fetchArray())
            {
                $blockedfiles = explode(',', $block['pages']);
                if(in_array($page, $blockedfiles))
                {
                    $groups = $userdb->query("SELECT id, pages FROM groups");
                    while($group = $groups->fetchArray())
                    {
                        $id = $group['id'];
                        $pages = explode(',', $group['pages']);
                        if(in_array($page, $pages))
                        {
    	                    if(isset($_SESSION['userauth']['groupid']) && in_array($id, $_SESSION['userauth']['groupid']))
                                return true;
                        }
                    }
                    return false;
                }
            }
            $userdb->close();
        }
        return true;
    }
    
    function deleteofflines($where, $content = '')
    {
        $userdbfile = $this->config['server_path'].'/content/access/users.db';
        
        if(file_exists($userdbfile) && class_exists('SQLite3')) {
            $userdb = new SQLite3($userdbfile);
            
            $blocks = $userdb->query("SELECT id, pages FROM blocks WHERE blocks.id = '1' LIMIT 1");
        	if($block = $blocks->fetchArray())
            {
                $blockedfiles = explode(',', $block['pages']);
            	foreach($blockedfiles as $userpage)
                {
                    if($userpage != '' && !$this->accesspage($userpage))
                        $this->offlinepages[] = $userpage;
                }
            }
            $userdb->close();
        }
    
        if(($this->config['offlinelinks'] == '1' || $this->config['offlinelinks'] == '2') && count($this->offlinepages) >= 1)
        {
            foreach($this->offlinepages as $offlinepage)
            {
                if($where == 'page')
                {
                    $this->loadcontentpage = preg_replace('#<a([^>]+)(href=\"index\.php\?wbpagefile='.$offlinepage.')(?=\"|\&)([^>]+)>([^<]+)</a>#Umsi', '$4', $this->loadcontentpage);
                }
                if($where == 'menu')
                {
                    if($this->config['offlinelinks'] == '1')
                    {
                        $content = preg_replace('#<a([^>]+)(href=\"index\.php\?wbpagefile='.$offlinepage.')(?=\"|\&)([^>]+)>([^<]+)</a>#Umsi', '<span>$4</span>', $content);
                    }
                    elseif($this->config['offlinelinks'] == '2')
                    {
                        $content = $this->deletelistitem($content, $offlinepage);
                    }
                }
            }
        }
        
        if($where == 'menu')
            return $content;
    }
    
    function deletelistitem($content, $item)
    {
		$prepaired = $content;
        $hrefs = preg_match_all('#(href=\"index\.php\?wbpagefile='.$item.')(?!\d|\w|\_)([^\"]*)(\")#Usi', $content, $hrefstrs);
		
        if($hrefs)
        {
			$content = str_replace('&nbsp;', '&amp;nbsp;', $content);
			$content = $this->escapescripts($content);
			
            $dom = new DOMDocument;
			$dom->preserveWhiteSpace = true;
			$dom->formatOutput = false;
			libxml_use_internal_errors(true);
			$dom->loadHTML('<?xml encoding="UTF-8">'.$content);
			libxml_use_internal_errors(false);
			libxml_clear_errors();
			$dom->encoding = 'UTF-8';
            $xpath = new DOMXPath($dom);
            for($i = 0; $i < $hrefs; $i++)
            {
                $hrefquery = '//a[@'.$hrefstrs[0][$i].']';
                foreach($xpath->query($hrefquery) as $result)
                {
                    while($result)
                    {
                        if($result->nodeName == 'li')
                        {
                            $result->parentNode->removeChild($result);
                            break;
                        }
                        $result = $result->parentNode;
                    }
                }
            }
			$savedbody = $xpath->query('/html/body');
			$prepaired = preg_replace('#<(?:/?)body[^>]*?'.'>#Usi', '', $dom->saveHTML($savedbody->item(0)));
			$prepaired = $this->unescapescripts($prepaired);
			$prepaired = str_replace('&amp;nbsp;', '&nbsp;', $prepaired);
        }
    
        return $prepaired;
    }
    
    function setlangdefines()
    {
        if($this->config['languages'] == '1')
        {
        	$lang = $this->getlangfrompage($this->getpage);
            if($lang && $lang != '')
                $_SESSION['language'] = $lang;
			else
                $_SESSION['language'] = $this->config['defaultlang'];
        }
        else {
            if(isset($_SESSION['language']))
                unset($_SESSION['language']);
        }
    	
        $syslangpath = $this->config['server_path'].'/includes/language/lang';
        if(isset($_SESSION['language']) && file_exists($syslangpath.'/'.$_SESSION['language'].'.php'))
        {
            $pagelanguage = $syslangpath.'/'.$_SESSION['language'].'.php';
        }
        else
        {
            $pagelanguage = $syslangpath.'/'.$this->config['defaultlang'].'.php';
        }
        
        return $pagelanguage;
    }
    
    function getlangfrompage($page)
    {
        if($this->config['languages'] == '1' && count($this->langconf) > 0 && array_key_exists('pages', $this->langconf))
        {
            $lang = '';
            foreach($this->langconf['code'] as $code)
            {
                if(in_array($page, $this->langconf['pages'][$code]))
                {
                    $lang = $code;
                    break;
                }
            }
            
            return $lang;
        }
        
        return false;
    }
	
	function getuserip()
	{
		$ipaddress = '';
		
		if(!empty($_SERVER['HTTP_CLIENT_IP']))
			$ipaddress = $_SERVER['HTTP_CLIENT_IP'];
		else if(!empty($_SERVER['HTTP_X_FORWARDED_FOR']))
			$ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
		else if(!empty($_SERVER['HTTP_X_FORWARDED']))
			$ipaddress = $_SERVER['HTTP_X_FORWARDED'];
		else if(!empty($_SERVER['HTTP_FORWARDED_FOR']))
			$ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
		else if(!empty($_SERVER['HTTP_FORWARDED']))
			$ipaddress = $_SERVER['HTTP_FORWARDED'];
		else if(!empty($_SERVER['REMOTE_ADDR']))
			$ipaddress = $_SERVER['REMOTE_ADDR'];
		else
			$ipaddress = 'UNKNOWN';
		
		return $ipaddress;
	}
    
    function loginattempts()
    {
        if($this->config['logattemptmin'] == '')
		{
			return true;
		}
		else
		{
			$userip = $this->getuserip();
			if($userip == 'UNKNOWN')
			{
				return false;
			}
			else
			{
				$loginattemptsfile = $this->config['server_path'].'/content/access/loginblockedips.php';
				if(!file_exists($loginattemptsfile)) {
					$blockedipsarray = "<?PHP\n\n\$webutler_blockedips = array();\n\n";
					file_put_contents($loginattemptsfile, $blockedipsarray);
					$this->setchmodaftersave($loginattemptsfile);
				}
				include $loginattemptsfile;
				
				if(!isset($_SESSION['logattempts']))
					$_SESSION['logattempts'] = 1;
				else
					$_SESSION['logattempts'] = $_SESSION['logattempts']+1;
				
				if(array_key_exists($userip, $webutler_blockedips)) {
					if($webutler_blockedips[$userip] < time()-60*$this->config['logattemptmin']) {
						unset($webutler_blockedips[$userip]);
						unset($_SESSION['logattempts']);
						$this->saveblockedips($loginattemptsfile, $webutler_blockedips);
						return true;
					}
					else {
						return false;
					}
				}
				else {
					if($_SESSION['logattempts'] >= 5) {
						if($_SESSION['logattempts'] == 5) {
							unset($_SESSION['logattempts']);
							$webutler_blockedips[$userip] = time();
							$this->saveblockedips($loginattemptsfile, $webutler_blockedips);
						}
						return false;
					}
					else {
						return true;
					}
				}
			}
		}
    }
    
    function saveblockedips($file, $blockedips)
    {
		$content = "<?PHP\n\n\$webutler_blockedips = array(\n";
		$ips = array();
        foreach($blockedips as $ip => $time) {
			$ips[] = "\t'".$ip."' => '".$time."'";
        }
		$content.= implode(",\n", $ips);
		$content.= "\n);\n\n";
        
        file_put_contents($file, $content);
        $this->setchmodaftersave($file);
    }
    
    function loadsigns($length, $signs)
    {
        $part = '';
        for($i = 0; $i < $length; $i++)
        {
            $part.= $signs[mt_rand(0, strlen($signs)-1)];
        }
        return $part;
    }
    
    function tokenizer()
    {
        $token = $this->loadsigns(5, 'abcdefghijkmnpqrstuvwxyz');
        $token.= $this->loadsigns(5, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
        $token.= $this->loadsigns(4, '1234567890');
        $token.= $this->loadsigns(4, '#+*@%&=!?');
		
		$token = str_shuffle($token);
		
        return md5($token);
    }
    
    function antixpostcode()
    {
        $antixpost = $this->loadsigns(3, 'abcdefghijkmnpqrstuvwxyz');
        $antixpost.= $this->loadsigns(3, 'ABCDEFGHIJKLMNOPQRSTUVWXYZ');
        $antixpost.= $this->loadsigns(2, '1234567890');
        $antixpost.= $this->loadsigns(2, '#+*@%&=!?');
		
		$antixpostcode = str_shuffle($antixpost);
		$_SESSION['antixposts'][time()] = $antixpostcode;
        
        return $antixpostcode;
    }
    
    function checkantixpost()
    {
        if(!$this->checkadmin())
        {
            //if(count($_POST) > 0 && (empty($_SERVER['HTTP_X_REQUESTED_WITH']) || strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) != 'xmlhttprequest'))
            if(count($_POST) > 0)
            {
                $antixnotfound = true;
                if(isset($_SESSION['antixposts']) && isset($_POST['webutler_autokill']))
                {
					foreach($_SESSION['antixposts'] as $timestamp => $antixpost)
					{
						if($timestamp < (time()-60*5))
						{
							unset($_SESSION['antixposts'][$timestamp]);
						}
						elseif($_POST['webutler_autokill'] == md5($antixpost))
						{
							unset($_SESSION['antixposts'][$timestamp]);
							$antixnotfound = false;
							break;
						}
					}
                }
				
                $this->formnocookie = false;
                if(!isset($_SESSION['antixposts']) || !isset($_POST['webutler_autokill']) || $antixnotfound)
                {
                    unset($_POST);
                    $this->formnocookie = true;
                }
                else
                {
                    unset($_POST['webutler_autokill']);
                    
                    array_walk($_POST, array('WebutlerClass', 'stripcode'));
                }
            }
            if(count($_GET) > 0)
            {
                array_walk($_GET, array('WebutlerClass', 'stripcode'));
            }
        }
    }
    
    function stripcode(&$value, $key)
    {
        $key = trim(htmlspecialchars($key, ENT_QUOTES));
        
        $value = preg_replace('#(.*)(<\?.*\?'.'>)(.*)#Usi', '${1}$3', $value);
        $value = str_replace('<?', '', $value);
        $value = str_replace('?'.'>', '', $value);
    }
	
	/*
	function remove_invisible_characters($str, $url_encoded = TRUE)
	{
		$non_displayables = array();

		// every control character except newline (dec 10),
		// carriage return (dec 13) and horizontal tab (dec 09)
		if ($url_encoded)
		{
			$non_displayables[] = '/%0[0-8bcef]/i';	// url encoded 00-08, 11, 12, 14, 15
			$non_displayables[] = '/%1[0-9a-f]/i';	// url encoded 16-31
			$non_displayables[] = '/%7f/i';	// url encoded 127
		}

		$non_displayables[] = '/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]+/S';	// 00-08, 11, 12, 14-31, 127

		do
		{
			$str = preg_replace($non_displayables, '', $str, -1, $count);
		}
		while ($count);

		return $str;
	}
    */
    
    function setchmodaftersave($file)
    {
		$oldumask = umask(0);
		@chmod($file, $this->config['chmod'][1]);
		umask($oldumask);
    }
}


class WebutlerAdminClass extends WebutlerClass
{
    var $adminpage;
    
    var $loading_css;
    var $loading_div;
    
    var $plugins_fulleditor;
    var $plugins_blockeditor;
    var $plugins_menueditor;
    var $plugins_metaseditor;
    var $plugins_contenteditor;
    
    var $cke_cssclasses;
    var $basefonts;
    
	function __construct($useformsendto = '', $usecolumns = '', $useshowprotected = '')
	{
        $this->adminpage = '';
        
        $this->loading_css = '<link href="admin/system/css/loading.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />';
        $this->loading_div = "\n".'<div id="webutler_loadingscreen">&nbsp;</div>'."\n";
        
        $this->plugins_fulleditor = 'savetemppage,savepage,docprops,browser,closeeditor,'.$usecolumns.'cssclassparser,cssclasscombo,'.$useshowprotected.'lazyload,lightbox,video,audio,softhyphen,formchanges,formfields,'.$useformsendto.'pagelinks,imageedit,leafletmap,disabletoolbar,pastedupload,sourcedialog,magicline,setdatatabu';
		
        $this->plugins_blockeditor = 'browser,closeeditor,'.$usecolumns.'cssclassparser,cssclasscombo,'.$useshowprotected.'lazyload,lightbox,video,audio,softhyphen,formchanges,formfields,'.$useformsendto.'pagelinks,imageedit,leafletmap,pastedupload,sourcedialog,magicline,setdatatabu';
		
        $this->plugins_menueditor = 'browser,closeeditor,cssclassparser,cssclasscombo,sortmenu,'.$useshowprotected.'lazyload,lightbox,pagelinks,imageedit,pastedupload,sourcedialog,magicline,setdatatabu';
		
        $this->plugins_metaseditor = 'savetemppage,savepage,docprops,browser,closeeditor,'.$usecolumns.'cssclasscombo,video,audio,softhyphen,leafletmap,disabletoolbar,sourcedialog,magicline';
		
        $this->plugins_contenteditor = 'savetemppage,savepage,autogrow,docprops,browser,closeeditor,'.$usecolumns.'cssclassparser,cssclasscombo,'.$useshowprotected.'lazyload,lightbox,video,audio,softhyphen,leafletmap,formchanges,formfields,'.$useformsendto.'pagelinks,imageedit,disabletoolbar,pastedupload,sourcedialog,magicline,setdatatabu';
		
        $this->basefonts = array('Arial/fontarial', 'Comic/fontcomic', 'Courier/fontcourier', 'Georgia/fontgeorgia', 'Lucida/fontlucida', 'Tahoma/fonttahoma', 'Times/fonttimes', 'Trebuchet/fonttrebuchet', 'Verdana/fontverdana');
    }
    
    function check_temp_fileexists($file)
    {
		return file_exists($file.'.tmp') ? $file.'.tmp' : $file;
    }
    
    
    // Seitenansicht Admin
    function admineditbox()
    {
    	require_once $this->config['server_path'].'/admin/system/editbox.php';
        
        return $boxresult;
    }
    
    function adminpageview()
    {
        $this->sethistory();
        $_getpage = $this->check_temp_fileexists($this->config['server_path'].'/content/pages/'.$this->getpage);
        
    	if(file_exists($_getpage))
    	{
            require_once $this->config['server_path'].'/admin/system/lang/'.$_SESSION['loggedin']['userlang'].'.php';
            
            $logoimg = '<img id="webutler_logo" alt="WEButler" src="admin/system/images/webutler.svg" width="239" height="49" />'."\n";
    		$this->autoheaderdata[] = $this->loading_css;
    		
            $pageisoff = '';
            if(file_exists($this->config['server_path'].'/content/pages/'.$this->getpage.'.tmp'))
                $pageisoff = '<div id="webutler_pageisoff">'._WBLANGADMIN_OFF_PAGEUNPUBLIC_.'</div>'."\n";
            elseif(in_array($this->getpage, $this->offlinepages))
                $pageisoff = '<div id="webutler_pageisoff">'._WBLANGADMIN_OFF_PAGEISOFFLINE_.'</div>'."\n";
            elseif(!$this->accesspage($this->getpage))
                $pageisoff = '<div id="webutler_pageisoff">'._WBLANGADMIN_OFF_PAGEISUSERS_.'</div>'."\n";
            
            $this->loadcontentpage = file_get_contents($_getpage);
			
			$admineditbox = $this->admineditbox();
			
			if($this->consents_window != '')
			{
				$this->loadcontentpage = str_replace('</body>', "\n".$this->consents_window."\n</body>", $this->loadcontentpage);
			}
			
            $this->loadcontainer('menu', 1);
            $this->loadcontainer('block', 1);
            $this->showallparts();
            
            ob_start();
            $webutlercouple = $this;
    		$showpartfor = array('-1');
            echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
    		
    		$this->rewriting();
            $this->basetohead();
			$this->loadcompressed();
            $this->autoheaderdata();
            $this->autofooterdata();
			$this->canonicaltag();
            if(isset($this->setnewtitlefrommod) && $this->setnewtitlefrommod != '') {
                $this->loadcontentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '${1}'.$this->setnewtitlefrommod.'$3', $this->loadcontentpage);
            }
    		$this->loadcontentpage = preg_replace('#(<body[^>]*?'.'>)#Usi', '$1'.$this->loading_div.$pageisoff.$logoimg, $this->loadcontentpage);
    		$this->loadcontentpage = str_replace('</body>', $admineditbox.'</body>', $this->loadcontentpage);
    	}
    	else
    	{
    		$this->errorpage(_WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_);
    	}
    }
    
    
    // Editoren
    
    // WYSIWYG Editor
    function adminheader()
    {
    	$header = $this->htmlsource['page_header'];
    	$header.= '<title>WEBUTLER - Administration</title>'."\n";
        $header.= '<script src="admin/ckeditor/ckeditor.js"></script>'."\n".
			'<script>'."\n".
        	'/* <![CDATA[ */'."\n".
            '   CKEDITOR.on(\'instanceCreated\', function( evt )'."\n".
            '   {'."\n".
                    // Mit maximiced Editor funktioniert $loading_div nicht
            '       var loadingDiv = document.createElement(\'div\');'."\n".
            '       var addLoadDiv = document.body.appendChild(loadingDiv);'."\n".
            '       addLoadDiv.id = \'webutler_loadingscreen\';'."\n".
            '   });'."\n".
            '   CKEDITOR.on(\'instanceReady\', function( evt )'."\n".
            '   {'."\n".
            '       document.getElementById(\'webutler_loadingscreen\').style.display = \'none\';'."\n".
            '       var editor = evt.editor;'."\n".
            '       editor.execCommand( \'maximize\' );'."\n".
            '       editor.addCommand( \'maximize\','."\n".
            '       {'."\n".
            '           exec : function( editor ) {}'."\n".
            '       });'."\n".
			'		editor.filter.addTransformations([[\'img{width,height}: sizeToStyle\']]);'."\n".
            '   });'."\n".
            '   var imageeditorWindowWidth = \''.$this->config['imageeditor_wh'][0].'\';'."\n".
            '   var imageeditorWindowHeight = \''.$this->config['imageeditor_wh'][1].'\';'."\n".
            '   var adminToken = \''.$_SESSION['admintoken'].'\';'."\n".
            '/* ]]> */'."\n".
        	'</script>'."\n";
    	$header.= $this->loading_css."\n";
		$header.= '<link href="admin/system/css/editor.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
    	$header.= $this->htmlsource['close_page_header'];
        
        return $header;
    }
    
    function adminpageedit()
    {
        $post_edit = $this->pagenamesigns($_POST['edit']);
		$contentfile = $this->check_temp_fileexists($this->config['server_path'].'/content/pages/'.$post_edit);
		
		if(file_exists($contentfile))
		{
			$editorcss = '<link href="admin/system/css/editor.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
			
			$stylefile = $this->get_compressed_file('css');
			$stylecss = $stylefile != '' ? '<link href="content/compress/'.$stylefile.'?v='.filemtime($this->config['server_path'].'/content/compress/'.$stylefile).'" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n" : '';
			$topscript = '<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'   var pageIsTemp = '.(substr($contentfile, -4) == '.tmp' ? 'true' : 'false').';'."\n".
				'/* ]]> */'."\n".
				'</script>'."\n";
			
			$combobgcss = '';
			if(isset($this->config['ckecombobg']) && $this->config['ckecombobg'] != '' && strlen($this->config['ckecombobg']) > 2 && strlen($this->config['ckecombobg']) < 7) {
				$combobgcss.= '<style type="text/css">'."\n".
					'/* <![CDATA[ */'."\n".
					'	.cke_combopanel .cke_panel_frame{background-color:#'.$this->config['ckecombobg'].'}'."\n".
					'/* ]]> */'."\n".
					'</style>'."\n";
			}
			
            $this->adminpage = $this->adminheader();
			$this->adminpage = str_replace('</head>', $combobgcss.$stylecss.$topscript.'</head>', $this->adminpage);
    		$this->adminpage.= '<form id="wb_editorsaveform" action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&admintoken='.$_SESSION['admintoken'].'" method="post">'."\n";
            
		    $this->loadcontentpage = file_get_contents($contentfile);
            $this->loadcontainer('menu', 1, 'edit');
            $this->loadcontainer('block', 1, 'edit');
			
			$this->loadcontentpage = str_replace('</head>', $editorcss.$stylecss.'</head>', $this->loadcontentpage);
			
			$this->adminpage.= '<textarea id="fulleditor" name="fulleditor" style="visibility: hidden">'.htmlspecialchars($this->loadcontentpage).'</textarea>'."\n";
			
			$this->adminpage.= '<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'	CKEDITOR.replace( \'fulleditor\', {'."\n".
                '       customConfig : \'wb_ckeconfig.js\','."\n".
				'       language : \''.$_SESSION['loggedin']['userlang'].'\','."\n".
				'       baseHref : \''.$this->config['homepage'].'/\','."\n".
                '       fullPage : true,'."\n";
			if($this->cke_cssclasses == 1) {
				$this->adminpage.= '       justifyClasses : [ \'alignleft\', \'aligncenter\', \'alignright\', \'alignjustify\' ],'."\n".
					'       indentClasses : [ \'indent1\', \'indent2\', \'indent3\', \'indent4\', \'indent5\' ],'."\n";
			}
            $this->adminpage.= '       extraPlugins : \''.$this->plugins_fulleditor.'\','."\n".
                '       removePlugins : \'autogrow'.($this->config['ckeembed'] == '' ? ',embed' : '').'\','."\n".
                '       toolbar : \'EditPage\','."\n";
            $this->adminpage.= $this->config['ckeembed'] != '' ? '       embed_provider : \''.$this->config['ckeembed'].'\','."\n" : '';
            $this->adminpage.= '       font_names : \''.$this->editorfonts().'\','."\n".
				'		colorButton_colors : \''.$this->editorcicolors().'\' + CKEDITOR.config.colorButton_colors,'."\n".
				'       contentsCss : [\''.$this->editorstyles().'\'],'."\n".
                '       filebrowserWindowWidth : \''.$this->config['mediabrowser_wh'][0].'\','."\n".
                '       filebrowserWindowHeight : \''.$this->config['mediabrowser_wh'][1].'\''."\n".
                '   });'."\n".
				'/* ]]> */'."\n".
				'</script>'."\n";
            
    		$this->adminpage.= '</form>'."\n";
            $this->adminpage.= $this->htmlsource['page_footer'];
		}
		else
		{
			$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
		}
	}
    
    function adminpageblock()
    {
        $post_block = $this->filenamesigns($_POST['block']);
		$block = $this->config['server_path'].'/content/blocks/'.$post_block;
		if(file_exists($block))
		{
		    $blockfile = file_get_contents($block);
			
            $adminheader = $this->adminheader();

			if(isset($this->config['ckecombobg']) && $this->config['ckecombobg'] != '' && strlen($this->config['ckecombobg']) > 2 && strlen($this->config['ckecombobg']) < 7) {
				$admincss = '<style type="text/css">'."\n".
					'/* <![CDATA[ */'."\n".
					'	.cke_combopanel .cke_panel_frame{background-color:#'.$this->config['ckecombobg'].'}'."\n".
					'/* ]]> */'."\n".
					'</style>'."\n";
				
				$adminheader = str_replace('</head>', $admincss.'</head>', $adminheader);
			}
			
    		$this->adminpage.= $adminheader;
			
    		$this->adminpage.= '<form action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&block='.$post_block.'&admintoken='.$_SESSION['admintoken'].'" method="post">'."\n";
			$this->adminpage.= '<textarea id="blockeditor" name="blockeditor" style="visibility: hidden">'.htmlspecialchars($blockfile).'</textarea>'."\n";
			
			$this->adminpage.= '<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'	CKEDITOR.replace( \'blockeditor\', {'."\n".
                '       customConfig : \'wb_ckeconfig.js\','."\n".
				'       language : \''.$_SESSION['loggedin']['userlang'].'\','."\n".
				'       baseHref : \''.$this->config['homepage'].'/\','."\n";
			if($this->cke_cssclasses == 1) {
				$this->adminpage.= '       justifyClasses : [ \'alignleft\', \'aligncenter\', \'alignright\', \'alignjustify\' ],'."\n".
					'       indentClasses : [ \'indent1\', \'indent2\', \'indent3\', \'indent4\', \'indent5\' ],'."\n";
			}
            $this->adminpage.= '       extraPlugins : \''.$this->plugins_blockeditor.'\','."\n".
                '       removePlugins : \'autogrow'.($this->config['ckeembed'] == '' ? ',embed' : '').'\','."\n".
                '       toolbar : \'EditBlock\','."\n";
            $this->adminpage.= $this->config['ckeembed'] != '' ? '       embed_provider : \''.$this->config['ckeembed'].'\','."\n" : '';
            $this->adminpage.= '       bodyClass : \'WBeditor_blockframe\','."\n".
                '       font_names : \''.$this->editorfonts().'\','."\n".
				'		colorButton_colors : \''.$this->editorcicolors().'\' + CKEDITOR.config.colorButton_colors,'."\n".
				'       contentsCss : [\''.$this->editorstyles().'\', \''.$this->config['homepage'].'/admin/system/css/editor.css\'],'."\n".
                '       filebrowserWindowWidth : \''.$this->config['mediabrowser_wh'][0].'\','."\n".
                '       filebrowserWindowHeight : \''.$this->config['mediabrowser_wh'][1].'\''."\n".
                '   });'."\n";
			if(isset($this->config['ckeblockbg']) && $this->config['ckeblockbg'] != '' && strlen($this->config['ckeblockbg']) > 2 && strlen($this->config['ckeblockbg']) < 7) {
				$this->adminpage.= '	CKEDITOR.addCss(\'.WBeditor_blockframe{background-color:#'.$this->config['ckeblockbg'].';}\');'."\n";
			}
			$this->adminpage.= '/* ]]> */'."\n".
				'</script>'."\n";
            
    		$this->adminpage.= "</form>";
            $this->adminpage.= $this->htmlsource['page_footer'];
		}
		else
		{
			$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
		}
	}
            	
    function adminpagemenu()
    {
    	$post_menu = $this->filenamesigns($_POST['menu']);
    	$menu = $this->config['server_path'].'/content/menus/'.$post_menu;
    	if(file_exists($menu))
    	{
		    $menufile = file_get_contents($menu);
            $adminheader = $this->adminheader();
			
			if(isset($this->config['ckecombobg']) && $this->config['ckecombobg'] != '' && strlen($this->config['ckecombobg']) > 2 && strlen($this->config['ckecombobg']) < 7) {
				$admincss = '<style type="text/css">'."\n".
					'/* <![CDATA[ */'."\n".
					'	.cke_combopanel .cke_panel_frame{background-color:#'.$this->config['ckecombobg'].'}'."\n".
					'/* ]]> */'."\n".
					'</style>'."\n";
				
				$adminheader = str_replace('</head>', $admincss.'</head>', $adminheader);
			}
			
            $this->adminpage.= $adminheader;
			
        	$this->adminpage.= '<form action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&menu='.$post_menu.'&admintoken='.$_SESSION['admintoken'].'" method="post">'."\n";
			$this->adminpage.= '<textarea id="menueditor" name="menueditor" style="visibility: hidden">'.htmlspecialchars($menufile).'</textarea>'."\n";

			$this->adminpage.= '<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'	CKEDITOR.replace( \'menueditor\', {'."\n".
                '       customConfig : \'wb_ckeconfig.js\','."\n".
				'       language : \''.$_SESSION['loggedin']['userlang'].'\','."\n".
				'       baseHref : \''.$this->config['homepage'].'/\','."\n";
			if($this->cke_cssclasses == 1) {
				$this->adminpage.= '       justifyClasses : [ \'alignleft\', \'aligncenter\', \'alignright\', \'alignjustify\' ],'."\n".
					'       indentClasses : [ \'indent1\', \'indent2\', \'indent3\', \'indent4\', \'indent5\' ],'."\n";
			}
            $this->adminpage.= '       extraPlugins : \''.$this->plugins_menueditor.'\','."\n".
                '       removePlugins : \'autogrow,magicline,setdatatabu'.($this->config['ckeembed'] == '' ? ',embed' : '').'\','."\n".
                '       toolbar : \'EditMenu\','."\n";
            $this->adminpage.= $this->config['ckeembed'] != '' ? '       embed_provider : \''.$this->config['ckeembed'].'\','."\n" : '';
            $this->adminpage.= '       bodyClass : \'WBeditor_menuframe\','."\n".
                '       font_names : \''.$this->editorfonts().'\','."\n".
				'		colorButton_colors : \''.$this->editorcicolors().'\' + CKEDITOR.config.colorButton_colors,'."\n".
				'       contentsCss : [\''.$this->editorstyles().'\', \''.$this->config['homepage'].'/admin/system/css/editor.css\'],'."\n".
                '       filebrowserWindowWidth : \''.$this->config['mediabrowser_wh'][0].'\','."\n".
                '       filebrowserWindowHeight : \''.$this->config['mediabrowser_wh'][1].'\''."\n".
                '   });'."\n";
				if(isset($this->config['ckemenubg']) && $this->config['ckemenubg'] != '' && strlen($this->config['ckemenubg']) > 2 && strlen($this->config['ckemenubg']) < 7) {
					$this->adminpage.= '	CKEDITOR.addCss(\'.WBeditor_menuframe{background-color:#'.$this->config['ckemenubg'].';}\');'."\n";
				}
			$this->adminpage.= '/* ]]> */'."\n".
				'</script>'."\n";
            
        	$this->adminpage.= '</form>';
            $this->adminpage.= $this->htmlsource['page_footer'];
    	}
    	else
    	{
    		$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
    	}
	}
            	
    function adminpagecontent()
    {
		$editcss = '<link href="admin/system/css/editor.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
    	$ckeditor = '<script src="admin/ckeditor/ckeditor.js"></script>'."\n";
    	$cketoolbar = '<div id="WBeditor_toolbar"></div>'."\n";
    	
    	$postcontent = $this->pagenamesigns($_POST['content']);
    	$contentfile = $this->check_temp_fileexists($this->config['server_path'].'/content/pages/'.$postcontent);
		
		$topscript = '<script>'."\n".
			'/* <![CDATA[ */'."\n".
			'   var pageIsTemp = '.(substr($contentfile, -4) == '.tmp' ? 'true' : 'false').';'."\n".
			'/* ]]> */'."\n".
			'</script>'."\n";
		
		$contfuncs = '<script src="admin/system/javascript/wb_jquery.js" defer="defer"></script>'."\n".
			'<script>'."\n".
			'/* <![CDATA[ */'."\n".
			'	var locationPage = \''.$this->getpage.'\';'."\n".
            '   var adminToken = \''.$_SESSION['admintoken'].'\';'."\n".
			'/* ]]> */'."\n".
			'</script>'."\n".
			'<script src="admin/system/javascript/contfunc.js" defer="defer"></script>'."\n";
		
        $openform = '<form id="wb_editorsaveform" action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&admintoken='.$_SESSION['admintoken'].'" method="post">'."\n";
		$closeform = '</form>'."\n";
    	
    	if(file_exists($contentfile))
    	{
    		$loadcontent = file_get_contents($contentfile);
			
			$editcss.= '<style type="text/css">'."\n".
				'/* <![CDATA[ */'."\n".
				'	.wb_blockelement, .wb_menuelement { outline: 0px !important; }'."\n";
			if(isset($this->config['ckecombobg']) && $this->config['ckecombobg'] != '' && strlen($this->config['ckecombobg']) > 2 && strlen($this->config['ckecombobg']) < 7) {
				$editcss.= '	.cke_combopanel .cke_panel_frame{ background-color:#'.$this->config['ckecombobg'].' }'."\n";
			}
			$editcss.= '/* ]]> */'."\n".
				'</style>'."\n";
			
			$stylefile = $this->get_compressed_file('css');
			$stylecss = $stylefile != '' ? '<link href="content/compress/'.$stylefile.'?v='.filemtime($this->config['server_path'].'/content/compress/'.$stylefile).'" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n" : '';
			
			$scriptfile = $this->get_compressed_file('js');
			$footerscript = $scriptfile != '' ? '<script src="content/compress/'.$scriptfile.'?v='.filemtime($this->config['server_path'].'/content/compress/'.$scriptfile).'" defer="defer"></script>'."\n" : '';
    		
    		$pageheader = preg_split('#<body#', $loadcontent);
    		$editmetas = $pageheader[0]."<body>\n<p>&nbsp;</p>\n</body>\n</html>";
    		$hiddenmetas = '<div style="overflow: hidden; position: fixed; width: 0px; height: 0px; left: -1000px">'."\n".
        		'<textarea name="metas" id="metas" style="visibility: hidden">'.htmlspecialchars($editmetas).'</textarea>'."\n".
        		'<script>'."\n".
        		'/* <![CDATA[ */'."\n".
				'	var WBcontvar_PageInstances = new Array();'."\n".
				'	var WBcontvar_ScriptInstances = new Array();'."\n".
				'	var WBcontvar_InstancesLoaded = false;'."\n".
				'	var WBcontvar_IframeIsLoaded = false;'."\n".
				'	var WBcontvar_IframeIntervalId = false;'."\n".
				'	var WBcontvar_PageCount;'."\n".
    			'	CKEDITOR.replace( \'metas\', {'."\n".
                '       customConfig : \'wb_ckeconfig.js\','."\n".
        		'       language : \''.$_SESSION['loggedin']['userlang'].'\','."\n".
    			'       baseHref : \''.$this->config['homepage'].'/\','."\n".
                '       fullPage : true,'."\n".
                '       startupFocus : true,'."\n".
                '       extraPlugins : \''.$this->plugins_metaseditor.'\','."\n".
                '       removePlugins : \'autogrow,maximize,magicline,setdatatabu'.($this->config['ckeembed'] == '' ? ',embed' : '').'\','."\n".
                '       toolbar : \'EditContent\','."\n";
            $hiddenmetas.= $this->config['ckeembed'] != '' ? '       embed_provider : \''.$this->config['ckeembed'].'\','."\n" : '';
            $hiddenmetas.= '       font_names : \''.$this->editorfonts().'\','."\n".
                '       sharedSpaces :'."\n".
        		'		{'."\n".
        		'			top : \'WBeditor_toolbar\''."\n".
        		'		},'."\n".
                '   });'."\n".
                '   CKEDITOR.on(\'instanceReady\', function( evt )'."\n".
                '   {'."\n".
                '       var editor = evt.editor;'."\n".
				'       WBcontvar_ScriptInstances.push(editor.name);'."\n".
                '   });'."\n".
        		'	WBcontvar_PageInstances.push(\'metas\') ;'."\n".
                '   var imageeditorWindowWidth = \''.$this->config['imageeditor_wh'][0].'\';'."\n".
                '   var imageeditorWindowHeight = \''.$this->config['imageeditor_wh'][1].'\';'."\n".
				'/* ]]> */'."\n".
        		'</script>'."\n".
        		'</div>'."\n";
            
            $this->loadcontentpage = $loadcontent;
            $this->loadcontainer('block', 1);
            $this->loadcontainer('menu', 1);
            $this->showallparts();
            
            ob_start();
            $webutlercouple = $this;
    		$showpartfor = array('-1');
            echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
            
    		$this->rewriting();
            $this->autoheaderdata();
            $this->autofooterdata();
            
            $contentpage = $this->loadcontentpage;
    		$contentpage = str_replace("</head>", $ckeditor.$topscript.$editcss.$stylecss.$this->loading_css."\n</head>", $contentpage);
    		//$contentpage = preg_replace("#(<body[^>]*?".">)#Usi", "$1".$this->loading_div.$cketoolbar.$openform.$hiddenmetas, $contentpage);
    		$contentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '$1WEBUTLER - Administration$3', $contentpage);
			
    		$editierbar = substr_count($contentpage, '<!-- begin_content -->');
    		if($editierbar > 0)
    		{
				$startpoint = '<!-- begin_content -->';
				$endpoint = '<!-- end_content -->';
				$htmlsources = preg_split('#'.preg_quote($startpoint).'.*?'.preg_quote($endpoint).'#si', $contentpage);
				preg_match_all('#('.preg_quote($startpoint).')(.*?)('.preg_quote($endpoint).')#si', $loadcontent, $editsources);
				
				foreach($htmlsources as $count => $htmlsource)
				{
					if($count == $editierbar) {
						$this->adminpage.= str_replace('</body>', $closeform.$contfuncs.$footerscript.'</body>', $htmlsource);
						$this->adminpage = preg_replace("#(<body[^>]*?".">)#Usi", "$1".$this->loading_div.$cketoolbar.$openform.$hiddenmetas, $this->adminpage);
					}
					else {
						$this->adminpage.= $this->protectforms($htmlsource);
					}
					
					if($count < $editierbar) {
						$nextid = $count+1;
						
						$this->adminpage.= '<textarea name="content_'.$nextid.'" id="content_'.$nextid.'" style="visibility: hidden">'.htmlspecialchars($editsources[2][$count]).'</textarea>'."\n";
						
						$this->adminpage.= '<script>'."\n".
							'/* <![CDATA[ */'."\n".
							'	CKEDITOR.inline( \'content_'.$nextid.'\', {'."\n".
							'       customConfig : \'wb_ckeconfig.js\','."\n".
							'       language : \''.$_SESSION['loggedin']['userlang'].'\','."\n".
							'       baseHref : \''.$this->config['homepage'].'/\','."\n".
							'       fullPage : false,'."\n".
							'       startupFocus : true,'."\n";
						if($this->cke_cssclasses == 1) {
							$this->adminpage.= '       justifyClasses : [ \'alignleft\', \'aligncenter\', \'alignright\', \'alignjustify\' ],'."\n".
								'       indentClasses : [ \'indent1\', \'indent2\', \'indent3\', \'indent4\', \'indent5\' ],'."\n";
						}
						$this->adminpage.= '       extraPlugins : \''.$this->plugins_contenteditor.'\','."\n".
							'       removePlugins : \'maximize'.($this->config['ckeembed'] == '' ? ',embed' : '').'\','."\n".
							'       toolbar : \'EditContent\','."\n";
						$this->adminpage.= $this->config['ckeembed'] != '' ? '       embed_provider : \''.$this->config['ckeembed'].'\','."\n" : '';
						$this->adminpage.= '       font_names : \''.$this->editorfonts().'\','."\n".
							'		colorButton_colors : \''.$this->editorcicolors().'\' + CKEDITOR.config.colorButton_colors,'."\n".
							'       autoGrow_minHeight : 30,'."\n".
							'       autoGrow_bottomSpace : 10,'."\n".
							'		autoGrow_onStartup : true,'."\n".
							'       sharedSpaces :'."\n".
							'		{'."\n".
							'			top : \'WBeditor_toolbar\''."\n".
							'		},'."\n".
							'       contentsCss : [\''.$this->editorstyles().'\'],'."\n".
							'       filebrowserWindowWidth : \''.$this->config['mediabrowser_wh'][0].'\','."\n".
							'       filebrowserWindowHeight : \''.$this->config['mediabrowser_wh'][1].'\','."\n".
							'   });'."\n".
							'	WBcontvar_PageInstances.push(\'content_'.$nextid.'\') ;'."\n".
							'/* ]]> */'."\n".
							'</script>'."\n";
					}
				}
			
        	}
    	}
    	else
    	{
    		$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
    	}
    }
	
	function protectforms($htmlsource) {
		if(preg_match('#<form #i', $htmlsource)) {
			$htmlsource = str_replace(array('<form ', '</form>'), array('<source-form ', '</source-form>'), $htmlsource);
		}
		return $htmlsource;
	}
	
	function unprotectforms($htmlsource) {
		if(preg_match('#<source-form #i', $htmlsource)) {
			$htmlsource = str_replace(array('<source-form ', '</source-form>'), array('<form ', '</form>'), $htmlsource);
		}
		return $htmlsource;
	}
    
    
    // Quellcode-Editor
    function adminsourceedit()
    {
        $template = '';
        
    	if(isset($_POST['editnewlayout']))
    	{
            $editlayoutfile = $this->checkfilenamesigns($_POST['editlayout'], 'tpl');
    		$templatefile = $this->config['server_path'].'/content/layouts/'.$editlayoutfile;
            $template = (file_exists($templatefile)) ? $templatefile : '';
    		$file = $editlayoutfile;
    		$mode = 'html';
    		$savename = 'layoutfile';
    	}
    	elseif(isset($_POST['editnewstyles']))
    	{
			if($_POST['editstyles'] == 'columns') {
				$columnscssfile = $this->config['server_path'].'/content/columns/source/csscolumns.php';
				$template = (file_exists($columnscssfile)) ? $columnscssfile : '';
				$file = 'columns.css';
				$mode = 'css';
				$savename = 'columnstyle';
			}
			else {
				$ext = substr($_POST['editstyles'], strrpos($_POST['editstyles'], '.') + 1);
				$filepath = explode('/', $_POST['editstyles']);
				$filekey = count($filepath)-1;
				$filename = $filepath[$filekey];
				unset($filepath[$filekey]);
				$editstylefile = $this->checkfilenamesigns($filename, $ext);
				$newfilepath = count($filepath) > 0 ? implode('/', $filepath).'/' : '';
				$templatefile = $this->config['server_path'].'/content/style/'.$newfilepath.$editstylefile;
				$template = (file_exists($templatefile)) ? $templatefile : '';
				$file = rawurlencode($newfilepath.$editstylefile);
				$mode = 'css';
				$savename = 'stylefile';
			}
    	}
    	elseif(isset($_POST['editnewscripts']))
    	{
				$ext = substr($_POST['editscripts'], strrpos($_POST['editscripts'], '.') + 1);
				$filepath = explode('/', $_POST['editscripts']);
				$filekey = count($filepath)-1;
				$filename = $filepath[$filekey];
				unset($filepath[$filekey]);
				$editscriptfile = $this->checkfilenamesigns($filename, $ext);
				$newfilepath = count($filepath) > 0 ? implode('/', $filepath).'/' : '';
				$templatefile = $this->config['server_path'].'/content/javascript/'.$newfilepath.$editscriptfile;
				$template = (file_exists($templatefile)) ? $templatefile : '';
				$file = rawurlencode($newfilepath.$editscriptfile);
				$mode = 'js';
				$savename = 'scriptfile';
    	}
        
        if($template != '')
        {
        	$editfile = file_get_contents($template);
        	$editfile = htmlspecialchars($editfile);
        	
        	$this->adminpage.= $this->htmlsource['page_header']."\n".
				'<title>WEBUTLER - Administration</title>'."\n".
				'<script src="admin/codemirror/editor/js/codemirror.js"></script>'."\n".
				'<script src="admin/codemirror/lang/'.$_SESSION['loggedin']['userlang'].'.js"></script>'."\n".
				'<style>'."\n".
				'/* <![CDATA[ */'."\n".
				'    body {'."\n".
				'        padding: 0px;'."\n".
				'        margin: 0px;'."\n".
				'        background-color: #FFFFFF;'."\n".
				'    }'."\n".
				'/* ]]> */'."\n".
				'</style>'."\n".
				'<link href="admin/codemirror/config/editor.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
        	$this->adminpage.= $this->htmlsource['close_page_header'].
				'<form action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&file='.$file.'&admintoken='.$_SESSION['admintoken'].'" method="post" name="codemirror_form" style="margin: 0px; padding: 0px">'."\n".
				'<div id="codemirror_editormenu"><div id="buttons"></div></div>'."\n".
				'<textarea name="codemirror_editorsource" id="codemirror_editorsource" cols="120" rows="30">'."\n";
        	$this->adminpage.= $editfile;
        	$this->adminpage.= '</textarea>'."\n".
				'<input type="hidden" name="'.$savename.'" />'."\n".
				'</form>'."\n".
				'<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'   var codemirror_syntaxmode = \''.$mode.'\';'."\n".
				'   var codemirror_lastpage = \'index.php?wbpagefile='.$this->getpage.'\';'."\n".
				'/* ]]> */'."\n".
				'</script>'."\n".
				'<script src="admin/codemirror/codemirror_config.js"></script>'."\n";
        	$this->adminpage.= $this->htmlsource['page_footer'];
        }
        else
        {
    		$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
        }
    }
    
	
    // Minify CSS & JS
    function get_compressed_file($type)
    {
		$compressed = $this->config['server_path'].'/content/compress';
		
		$result = '';
		$handle = opendir($compressed);
		while(false !== ($file = readdir($handle)))
		{
			$ext = substr($file, strrpos($file, '.') + 1);
			if($ext == $type) {
				$result = $file;
				break;
			}
		}
		
		return $result;
    }
    
    
    // Minify onload
    function compressonload()
    {
		if((isset($_SESSION['loggedin']['userismaster']) && $_SESSION['loggedin']['userismaster'] == '1') || (isset($_SESSION['loggedin']['userisadmin']) && $_SESSION['loggedin']['userisadmin'] == '1')) {
			if($this->config['compressor_onload_css'] == 1)
				$this->compress_css();
			
			if($this->config['compressor_onload_js'] == 1)
				$this->compress_js();
		}
    }
    
    
    // Minify CSS
    function compress_css()
    {
		$css_files = $this->compress['css'];
		
		if(count($css_files) > 0) {
			$compress = '';
			foreach($css_files as $css_file) {
				$file = $this->config['server_path'].'/'.$css_file;
				if(file_exists($file)) {
					$source = file_get_contents($file);
					$result = $this->minifycss($source)."\n";
					unset($source);
					$compress = $compress.$result;
					unset($result);
				}
			}
			
			$compressedfile = $this->config['server_path'].'/content/compress/styles.css';
			
			file_put_contents($compressedfile, $compress);
			unset($compress);
			$this->setchmodaftersave($compressedfile);
		}
    }
    
    function minifycss($source)
    {
		$source = preg_replace('!/\*[^*]*\*+([^/][^*]*\*+)*/!', '', $source);
    	$source = str_replace(array("\t", "\r", "\n"), '', $source);
		$source = preg_replace('/\s+/', ' ', $source);
		$source = str_replace(array(': ', '; ', ', ', '{ ', '} '), array(':', ';', ',', '{', '}'), $source);
		$source = str_replace(array(' :', ' ;', ' ,', ' {', ' }'), array(':', ';', ',', '{', '}'), $source);
    		
        return $source;
    }
    
    
    // Minify JS
    function compress_js()
    {
		$js_files = $this->compress['js'];
		
		if(count($js_files) > 0) {
			$compress = '';
			//require_once $this->config['server_path'].'/admin/system/jsminplus.php';
			require_once $this->config['server_path'].'/admin/system/minifier.php';
			foreach($js_files as $js_file) {
				$file = $this->config['server_path'].'/'.$js_file;
				if(file_exists($file)) {
					$source = file_get_contents($file);
					//$result = JSMinPlus::minify($source);
					$result = \JShrink\Minifier::minify($source);
					unset($source);
					if(mb_substr($result, -1) != ';') $result = $result.';';
					$compress = $compress.$result."\n";
					unset($result);
				}
			}
			
			$compressedfile = $this->config['server_path'].'/content/compress/scripts.js';
			
			file_put_contents($compressedfile, $compress);
			unset($compress);
			$this->setchmodaftersave($compressedfile);
		}
    }
    
    
    // Editor Vorlagen
    function admineditpattern()
    {
		$patterneditfile = $this->checkfilenamesigns($_POST['patternedit'], 'tpl');
		$templatefile = $this->config['server_path'].'/content/pattern/files/'.$patterneditfile;
		$template = (file_exists($templatefile)) ? $templatefile : '';
		$patterninfos = $this->config['server_path'].'/content/pattern/patterninfos.php';
        
        if($template != '')
        {
        	$editfile = file_get_contents($template);
        	$editfile = htmlspecialchars($editfile);
			
			$patterntitle = '';
			$patternimage = '';
			$patterndesc = '';
			
			require_once $patterninfos;
			foreach($infos as $info)
			{
				if($info['file'] == $patterneditfile)
				{
					$patterntitle = $info['title'];
					$patternimage = $info['image'];
					$patterndesc = $info['description'];
				}
			}
        	
        	$this->adminpage.= $this->htmlsource['page_header']."\n".
				'<title>WEBUTLER - Administration</title>'."\n".
				'<script src="admin/codemirror/editor/js/codemirror.js"></script>'."\n".
				'<script src="admin/codemirror/lang/'.$_SESSION['loggedin']['userlang'].'.js"></script>'."\n".
				'<style>'."\n".
				'/* <![CDATA[ */'."\n".
				'    body {'."\n".
				'        padding: 0px;'."\n".
				'        margin: 0px;'."\n".
				'        background-color: #FFFFFF;'."\n".
				'    }'."\n".
				'/* ]]> */'."\n".
				'</style>'."\n".
				'<link href="admin/codemirror/config/editor.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n".
				'<link href="admin/system/css/editbox.css" defer="defer" media="screen" rel="stylesheet" type="text/css" />'."\n";
        	$this->adminpage.= $this->htmlsource['close_page_header'].
				'<form action="'.$this->config['homepage'].'/admin/system/save.php?wbpagefile='.$this->getpage.'&admintoken='.$_SESSION['admintoken'].'" method="post" name="codemirror_form" style="margin: 0px; padding: 0px">'."\n".
				'<div id="webutler_patterninfos">'."\n".
				'<table width="100%" border="0" cellspacing="0" cellpadding="5">'."\n".
				'<tr>'."\n".
				'<td colspan="2"><strong class="webutler_headline">'._WBLANGADMIN_WIN_PATTERN_EDITTEMP_.'</strong></td>'."\n".
				'</tr>'."\n".
				'<tr>'."\n".
				'<td style="width: 120px"><strong>'._WBLANGADMIN_WIN_PATTERN_EDITTITLE_.':</strong></td>'."\n".
				'<td><input type="text" name="title" value="'.$patterntitle.'" class="webutler_input" /></td>'."\n".
				'</tr>'."\n".
				'<tr>'."\n".
				'<td><strong>'._WBLANGADMIN_WIN_PATTERN_EDITIMAGE_.':</strong></td>'."\n".
				'<td><input type="text" name="image" value="'.$patternimage.'" id="webutler_tplicon" class="webutler_input" /><input type="button" value="'._WBLANGADMIN_WIN_BUTTONS_MEDIA_.'" onclick="codemirror_searchicon()" class="webutler_button webutler_searchicon" /></td>'."\n".
				'</tr>'."\n".
				'<tr>'."\n".
				'<td><strong>'._WBLANGADMIN_WIN_PATTERN_EDITDESC_.':</strong></td>'."\n".
				'<td><input type="text" name="description" value="'.$patterndesc.'" class="webutler_input webutler_patterndesc" /></td>'."\n".
				'</tr>'."\n".
				'<tr>'."\n".
				'<td colspan="2" style="height: 20px; padding-bottom: 0px"><strong>'._WBLANGADMIN_WIN_PATTERN_EDITSOURCE_.':</strong></td>'."\n".
				'</tr>'."\n".
				'</table>'."\n".
				'</div>'."\n".
				'<div id="codemirror_editormenu"><div id="buttons"></div></div>'."\n".
				'<textarea name="source" id="codemirror_patternsource" cols="120" rows="30">'."\n";
        	$this->adminpage.= $editfile;
        	$this->adminpage.= '</textarea>'."\n".
				'<div id="webutler_patternsave">'."\n".
				'	<input type="submit" name="savepattern" value="'._WBLANGADMIN_WIN_BUTTONS_SAVE_.'" class="webutler_button webutler_mainbutton" />'."\n".
				'	<input type="button" value="'._WBLANGADMIN_WIN_BUTTONS_CANCEL_.'" onclick="window.location=window.location;" class="webutler_button webutler_mainbutton" />'."\n".
				'	<input type="hidden" name="patternfile" value="'.$patterneditfile.'" />'."\n".
				'</div>'."\n".
				'</form>'."\n".
				'<script>'."\n".
				'/* <![CDATA[ */'."\n".
				'	function codemirror_searchicon() {'."\n".
				'		var iWidth = \''.$this->config['mediabrowser_wh'][0].'\';'."\n".
				'		if ( typeof iWidth == \'string\' && iWidth.length > 1 && iWidth.substr( iWidth.length - 1, 1 ) == \'%\' )'."\n".
				'			iWidth = parseInt( window.screen.width * parseInt( iWidth, 10 ) / 100, 10 );'."\n\n".
				'	    var iHeight = \''.$this->config['mediabrowser_wh'][1].'\';'."\n".
				'		if ( typeof iHeight == \'string\' && iHeight.length > 1 && iHeight.substr( iHeight.length - 1, 1 ) == \'%\' )'."\n".
				'			iHeight = parseInt( window.screen.height * parseInt( iHeight, 10 ) / 100, 10 );'."\n\n".
				'		if(iWidth < 640) iWidth = 640;'."\n".
				'		if(iHeight < 420) iHeight = 420;'."\n\n".
				'		var iTop = parseInt( ( window.screen.height - iHeight ) / 2, 10 );'."\n".
				'		var iLeft = parseInt( ( window.screen.width  - iWidth ) / 2, 10 );'."\n\n".
				'		var WindowFeatures = \'width=\' + iWidth + \',height=\' + iHeight + \',left=\' + iLeft + \',top=\' + iTop + \',directories=no,location=no,menubar=no,status=no,toolbar=no,resizable=yes,scrollbars=yes\';'."\n".
				'		var BrowseUrl = \'admin/browser/index.php?types=image&currentfolder=%2Ftpl_icons%2F&admintoken='.$_SESSION['admintoken'].'\';'."\n\n".
				'		var popupWindow = window.open( \'\', \'CKBrowseTplIcons\', WindowFeatures, true );'."\n\n".
				'		if ( !popupWindow )'."\n".
				'			return false;'."\n\n".
				'		try {'."\n".
				'			popupWindow.moveTo( iLeft, iTop );'."\n".
				'			popupWindow.resizeTo( iWidth, iHeight );'."\n".
				'			popupWindow.focus();'."\n".
				'			popupWindow.location.href = BrowseUrl;'."\n".
				'		}'."\n".
				'		catch ( e ) {'."\n".
				'			popupWindow = window.open( BrowseUrl, \'CKBrowseTplIcons\', WindowFeatures, true );'."\n".
				'		}'."\n".
				'	}'."\n\n".
				'   var codemirror_syntaxmode = \'html\';'."\n".
				'/* ]]> */'."\n".
				'</script>'."\n".
				'<script src="admin/codemirror/codemirror_config.js"></script>'."\n";
        	$this->adminpage.= $this->htmlsource['page_footer'];
        }
        else
        {
    		$this->adminpage.= _WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_;
        }
    }
    
    // Editorfehler bereinigen
    function deletelastpfromsource($content)
    {
        $start = strrpos($content, '<p>');
        $hasbody = strrpos($content, '</body>');
        $length = ($hasbody === false) ? strlen($content)-$start : $hasbody-$start;
        $substring = substr($content, $start, $length);
        if(preg_replace('#(\s)+#', '', $substring) == '<p>&nbsp;</p>')
        {
            $content = substr_replace($content, '', $start, strlen($substring));
        }
        
        return $content;
    }
    
    
    // Editorfunktionen
    function checkeditelements()
    {
		$content = $this->loadcontentpage;
		
		$result = array();
		$result['editors'] = substr_count($content, '<!-- begin_content -->');
		$result['columns'] = substr_count($content, 'wb_baseelement') + substr_count($content, 'wb_frameelement') + substr_count($content, 'wb_columnselement') + substr_count($content, 'wb_menuelement') + substr_count($content, 'wb_blockelement');
		
        return $result;
    }
    
    function testblockfiles($folder)
    {
        $result = 'false';
        
    	$directory = $this->config['server_path'].'/content/'.$folder;
    	$handle = opendir($directory);
    	while(false !== ($file = readdir ($handle))) {
        	if(!is_dir($directory.'/'.$file.'/') && $file != '.' && $file != '..' && $file != '.htaccess') {
                $result = 'true';
                break;
        	}
        }
    	closedir($handle);
    	
        return $result;
    }
    
    function showallparts()
    {
        $this->loadcontentpage = preg_replace('#(in_array\()([\'"])([0-9]+)([\'"])(\,(?:[\s])?\$showpartfor\))#Usi', '${1}${2}-1$4$5', $this->loadcontentpage);
    }
    
    function imgeditfonts()
    {
    	$fontnames = array();
    	$directory = $this->config['server_path'].'/includes/fonts/truetype';
    	$handle = opendir ($directory);
    	while(false !== ($file = readdir($handle)))
    	{
    		if($file != '.' && $file != '..')
    		{
                $name = substr($file, 0, strrpos($file, '.'));
				$name = str_replace(array('-', '_', '.'), array(' ', ' ', ' '), $name);
				$name = ucwords($name);
				
                $ext = substr($file, (strrpos($file, '.')+1));
				$type = $ext == 'otf' ? 'opentype' : 'truetype';
				
                $fontnames[] = array(
					'name' => $name,
					'type' => $type,
					'file' => $file
				);
    		}
    	}
    	closedir($handle);
    	
    	if(count($fontnames) >= 1) {
            return $fontnames;
        }
        return false;
    }
    
    function getcsscontents()
    {
		$stylefile = $this->get_compressed_file('css');
		
		if($stylefile != '') {
			$stylesource = file_get_contents($this->config['server_path'].'/content/compress/'.$stylefile);
		}
		else {
			$directory = $this->config['server_path'].'/content/style';
			$handle = opendir($directory);
			$stylesource = '';
			while(false !== ($file = readdir($handle)))
			{
				if($file != '.' && $file != '..' && !is_dir($directory.'/'.$file.'/'))
				{
					$ext = strtolower(substr($file, (strrpos($file, '.') + 1)));
					if($ext == 'css') {
						$stylesource.= file_get_contents($directory.'/'.$file)."\n";
					}
				}
			}
			closedir($handle);
		}
		
		return $stylesource;
    }
    
    function webfonts()
    {
		$stylesource = $this->getcsscontents();
		
		preg_match_all('/@font-face(?:(\s*))?{\K[^}]*(?=})/', $stylesource, $matches, PREG_SET_ORDER);

		if($matches) {
			$fontfaces = array();

			foreach($matches as $k => $ff) {
				$css = $ff[0];
				$attrs = explode(';', $css);

				foreach($attrs as $attr) {
				   if(strlen(trim($attr)) > 0) {
					  $kv = explode(':', trim($attr));
					  $fontfaces[$k][trim($kv[0])] = trim($kv[1]);
				   }
				}
				unset($attrs);            
			}
		}
		
    	$fontnames = array();
		foreach($fontfaces as $fontface) {
			$fontfamily = $fontface['font-family'];
			if(!in_array($fontfamily, $fontnames))
				$fontnames[] = $fontfamily;
		}
    	
    	if(count($fontnames) >= 1) {
            return $fontnames;
        }
        return false;
    }
    
    function editorfonts()
    {
        $allfonts = $this->basefonts;
        $webfonts = $this->webfonts();
    	if($webfonts && is_array($webfonts)) {
            foreach($webfonts as $webfont) {
				$webfont = str_replace(array('"', '\''), array('', ''), $webfont);
				$fontname = str_replace(array('-', '_', '.'), array(' ', ' ', ' '), $webfont);
				$fontname = ucwords($fontname);
                $allfonts[] = $fontname.'/'.$webfont;
			}
        }
        natcasesort($allfonts);
        
        return implode(';', $allfonts);
    }
    
    function editorcicolors()
    {
		$result = '';
		if($this->config['editorcicolors'] != '')
		{
			$editorcicolors = str_replace('#', '', $this->config['editorcicolors']);
			$cicolors = explode(',', $editorcicolors);
			
			$colors = array();
			for($i = 0; $i < 8; $i++) {
				$color = 'fff';
				if(isset($cicolors[$i])) {
					$color = trim($cicolors[$i]);
					if(strlen($color) > 6) $color = substr($color, 0, 6);
				}
				$colors[$i] = $color;
			}
			
			$result = implode(',', $colors).',';
		}
		
		return $result;
    }
    
    function editorstyles()
    {
		$stylefile = $this->get_compressed_file('css');
		
		if($stylefile != '') {
			$stylesheet = $this->config['homepage'].'/content/compress/'.$stylefile.'?v='.filemtime($this->config['server_path'].'/content/compress/'.$stylefile);
		}
		else {
			$directory = $this->config['server_path'].'/content/style';
			$handle = opendir($directory);
			$stylefiles = array();
			while(false !== ($file = readdir($handle)))
			{
				if($file != '.' && $file != '..' && !is_dir($directory.'/'.$file.'/'))
				{
					$ext = strtolower(substr($file, (strrpos($file, '.') + 1)));
					if($ext == 'css') {
						$stylefiles[] = $this->config['homepage'].'/'.$dir.'/'.$file.'?v='.filemtime($directory.'/'.$file);
					}
				}
			}
			closedir($handle);
			
			$stylefiles[] = $this->config['homepage'].'/content/columns/columns.css?v='.filemtime($this->config['server_path'].'/content/columns/columns.css');
			$stylesheet = implode("', '", $stylefiles);
		}
		
        return $stylesheet;
    }
    
    
    // Selects
    function buildstyleselect()
    {
    	$directory = $this->config['server_path'].'/content/style';
    	$handle = opendir($directory);
    	$pagestyles = array();
    	while(false !== ($file = readdir($handle))) {
    		if($file != '.' && $file != '..' && !is_dir($directory.'/'.$file.'/')) {
				$ext = strtolower(substr($file, (strrpos($file, '.') + 1)));
				if($ext == 'css') {
					$pagestyles[] = '<option value="'.$file.'">'.$file.'</option>';
				}
			}
    	}
    	closedir($handle);
        
        return $pagestyles;
    }
    
    function buildscriptselect($subfolder = '')
    {
    	$directory = $this->config['server_path'].'/content/javascript'.($subfolder != '' ? '/'.$subfolder : '');
    	$handle = opendir($directory);
    	$javascripts = array();
    	while(false !== ($file = readdir($handle))) {
    		if($file != '.' && $file != '..') {
				if(!is_dir($directory.'/'.$file.'/')) {
					$ext = strtolower(substr($file, strrpos($file, '.')));
					if($ext == '.js') {
						$subdir = $subfolder != '' ? $subfolder.'/'.$file : $file;
						$javascripts[] = '<option value="'.$subdir.'">'.$subdir.'</option>';
					}
				}
				else {
					$subdir = $subfolder != '' ? $subfolder.'/'.$file : $file;
					$subscripts = $this->buildscriptselect($subdir);
					$javascripts = array_merge($javascripts, $subscripts);
				}
			}
    	}
    	closedir($handle);
        
        return $javascripts;
    }
    
    function dirsselect($page = '')
    {
        $options = array();
        if(array_key_exists('dirs', $this->directories) && count($this->directories['dirs']) > 0) {
            $directories = $this->directories['dirs'];
            if($this->config['languages'] == '1' && array_key_exists('lang', $this->langconf) && count($this->langconf['lang']) > 0) {
                foreach($directories as $lang => $dirs) {
                    if(array_key_exists($lang, $this->langconf['lang'])) {
                        $optgroup = '<optgroup label="'.$this->langconf['lang'][$lang].'">'."\n";
                        foreach($dirs as $dir) {
                            $selected = '';
                            if($page != '' && array_key_exists($dir, $this->directories['pages'])) {
                                if(in_array($page, $this->directories['pages'][$dir]))
                                    $selected = ' selected="selected"';
                            }
                            $optgroup.= '<option value="'.$dir.'"'.$selected.'>'.rawurldecode($dir).'</option>'."\n";
                        }
                        $optgroup.= '</optgroup>';
                        
                        $options[] = $optgroup;
                    }
                }
            }
            else {
                if(isset($directories[$this->config['defaultlang']]) && is_array($directories[$this->config['defaultlang']])) {
					$directories = $directories[$this->config['defaultlang']];
				}
                foreach($directories as $dir) {
                    $selected = '';
                    if($page != '' && array_key_exists($dir, $this->directories['pages'])) {
                        if(in_array($page, $this->directories['pages'][$dir]))
                            $selected = ' selected="selected"';
                    }
                    $options[] = '<option value="'.$dir.'"'.$selected.'>'.rawurldecode($dir).'</option>';
                }
            }
        }
        
        return $options;
    }
    
    function langselect($default = '')
    {
    	$options = array();
        if(array_key_exists('lang', $this->langconf)) {
    		foreach($this->langconf['lang'] as $lang => $value) {
                $selected = ($lang == $default) ? ' selected="selected"' : '';
                $options[] = '<option value="'.$lang.'"'.$selected.'>'.$lang.': '.$value.'</option>';
            }
        }
        if(count($options) == 0) {
            $options[] = '<option value="">'._WBLANGADMIN_WIN_PAGELANG_NOLANGUAGE_.'</option>';
        }
        else {
            array_unshift($options, '<option value=""></option>');
        }
        return $options;
    }
    
    function buildselect($folder, $selopt, $noerror = false)
    {
    	$options = array();
    	$lang_pages = false;
        $allpages = array();
		$optgroup = array();
        $optclose = '';
        if($folder == 'pages' && $this->config['languages'] == '1' && array_key_exists('pages', $this->langconf)) {
    		$lang_pages = true;
    		$codes = $this->langconf['code'];
    		$langs = $this->langconf['lang'];
            
            foreach($codes as $code) {
                $allpages = array_merge($allpages, $this->langconf['pages'][$code]);
            }
            
    		foreach($langs as $lang => $value) {
                $optgroup[$lang] = '<optgroup label="'.$value.'">'."\n";
            }
            $optclose = '</optgroup>'."\n";
        }
        
    	$directory = $this->config['server_path'].'/content/'.$folder;
    	$handle = opendir($directory);
    	while(false !== ($file = readdir ($handle))) {
        	if(!is_dir($directory.'/'.$file.'/')) {
            	$extension = '';
            	$selected = '';
                if($folder == 'pages' || $folder == 'menus' || $folder == 'blocks') {
        			$extension = substr($file, strrpos($file, '.'));
        			$extension = strtolower($extension);
        		}
                $errorpage = $noerror ? $this->config['errorpage'] : '';
                
                if(!array_key_exists('nolang', $options))
                    $options['nolang'] = array();
                
        		if($file != '.' && $file != '..' && $file != '.htaccess' && $file != $errorpage && $extension != '.bak' && $extension != '.tmp') {
        			$selected = ($selopt != '' && $file == $selopt) ? ' selected="selected"' : '';
					$filedisplay = $folder == 'pages' ? rawurldecode($file) : $file;
                    
        			if($lang_pages !== false && in_array($file, $allpages)) {
                        foreach($codes as $code) {
                            if(!array_key_exists($code, $options))
                                $options[$code] = array();
                            
                            if(array_key_exists('pages', $this->langconf) && in_array($file, $this->langconf['pages'][$code])) {
                                $options[$code][] = '<option value="'.$file.'"'.$selected.'>'.$filedisplay.'</option>'."\n";
                			}
            			}
        			}
        			else {
                        $options['nolang'][] = '<option value="'.$file.'"'.$selected.'>'.$filedisplay.'</option>'."\n";
        			}
        		}
    		}
    	}
    	closedir($handle);
    	
    	$result = '';
        $notfound = '<option value="" disabled="disabled" style="color: #A0A0A0 !important; font-style: italic">'._WBLANGADMIN_WIN_LANGUAGE_EMPTY_.'</option>'."\n";
        if($lang_pages !== false) {
            foreach($codes as $code) {
                if(array_key_exists($code, $optgroup)) {
                    $result.= $optgroup[$code];
					if(count($options[$code]) == 0) {
                        $result.= $notfound;
                    }
                    else {
                        sort($options[$code]);
                        foreach($options[$code] as $opt) {
                            $result.= $opt;
                        }
                    }
                    $result.= $optclose;
                }
            }
            $result.= '<optgroup label="'._WBLANGADMIN_WIN_LANGUAGE_NOTINLANG_.'">'."\n";
        }
        
        if(count($options['nolang']) == 0) {
            $result.= $notfound;
        }
        else {
            sort($options['nolang']);
            foreach($options['nolang'] as $nolang) {
                $result.= $nolang;
            }
        }
        
        $result.= (!$lang_pages) ? '' : $optclose;
    
    	return $result;
    }
    
    function imgdirlisting($select = '', $folder = '', $indent = '')
    {
    	$directory = $this->config['server_path'].'/content/media/image/'.$folder;
    	static $options = array();
    	
    	$handle = opendir($directory);
    	while(false !== ($file = readdir($handle))) {
            $selected = '';
    		if(is_dir($directory.'/'.$file.'/')) {
        		if($file != '.' && $file != '..' && $file != '.box') {
            		if($file != 'watermarks' && $file != 'tpl_icons') {
                        $sub = ($folder != '') ? $folder.'/' : '';
                        if($select != '' &&  $select == $sub.$file) {
                            $selected = ' selected="selected"';
                        }
            			$options[] = '<option value="'.$sub.$file.'"'.$selected.'>'.$indent.$file.'</option>';
            
            			$this->imgdirlisting($select, $sub.$file, $indent.'&nbsp;&nbsp;&nbsp;');
            		}
                }
            }
    	} 
        closedir($handle);
    
    	return $options;
    }
    
    
    // Baseelement
    function createbaseelementtemplate($classes = '')
    {
		$template = '<div class="wb_baseelement'.($classes != '' ? ' '.$classes : '').'">';
		$template.= "\n\t".'<div class="wb_contentelement">';
		$template.= "\n\t\t".'<!-- begin_content -->'."\n\t\t\t".'<p>&nbsp;</p>'."\n\t\t".'<!-- end_content -->';
		$template.= "\n\t".'</div>'."\n";
		$template.= '</div>'."\n";
		
		return $template;
	}
    
    // Spalten
    function createcolumnstemplate($colconfig, $rowclasses = '', $colclasses = array(), $coleditors = array(), $colsources = array())
    {
		if(array_key_exists('single', $colconfig) && $colconfig['single'] == 'true') {
			$template = '<div class="wb_frameelement'.($rowclasses != '' ? ' '.$rowclasses : '').'">'."\n\t".'<div class="wb_framecontent wb_contentelement">';
			if(is_array($colsources) && count($colsources) > 0 && isset($colsources['source']) && $colsources['source'] != '')
				$template.= $colsources['source'];
			else
				$template.= "\n\t\t".'<!-- begin_content -->'."\n\t\t\t".'<p>&nbsp;</p>'."\n\t\t".'<!-- end_content -->'."\n\t";
			$template.= '</div>'."\n".'</div>'."\n";
		}
		else {
			$template = '<div class="wb_columnselement'.($rowclasses != '' ? ' '.$rowclasses : '').'">'."\n\t".'<div class="wb_colgroup">'."\n\t\t".'<div class="wb_colrow">'."\n";
			for($i = 1; $i < count($colconfig)+1; $i++) {
				$orders = array();
				$align = '';
				$classes = array();
				foreach($colconfig['col'.$i] as $key => $value) {
					if($key == 'order') {
						foreach($value as $k => $v) {
							if($v != '')
								$orders[] = 'wb_colorder_'.$k.$v;
						}
					}
					else {
						if($key == 'align') {
							$align = 'wb_colalign_'.$value;
						}
						else {
							if($value != '')
								$classes[] = 'wb_col'.$key.'_'.$value;
						}
					}
				}
				
				$colclass = '';
				if(count($colclasses) > 0 && isset($colclasses['col'.$i]) && $colclasses['col'.$i] != '')
					$colclass = ' '.$colclasses['col'.$i];
				
				$colcontent = '';
				if(count($coleditors) > 0 && isset($coleditors['editor'.$i]) && $coleditors['editor'.$i] == 'set') {
					$colcontent.= "\t\t\t".'<div class="'.$align.' wb_colalign wb_contentelement">';
					if(is_array($colsources) && count($colsources) > 0 && isset($colsources['source'.$i]) && $colsources['source'.$i] != '') {
						if(!preg_match('#<!-- begin_content -->#i', $colsources['source'.$i]))
							$colsources['source'.$i] = "\n\t\t\t\t\t".'<!-- begin_content -->'."\n\t\t\t\t\t\t".$colsources['source'.$i];
						if(!preg_match('#<!-- end_content -->#i', $colsources['source'.$i]))
							$colsources['source'.$i] = $colsources['source'.$i]."\n\t\t\t\t\t".'<!-- end_content -->'."\n\t\t\t\t";
						
						$colcontent.= $colsources['source'.$i];
					}
					else {
						$colcontent.= "\n\t\t\t\t\t".'<!-- begin_content -->'."\n\t\t\t\t\t\t".'<p>&nbsp;</p>'."\n\t\t\t\t\t".'<!-- end_content -->'."\n\t\t\t\t";
					}
					$colcontent.= '</div>'."\n\t\t\t";
				}
				else {
					$colcontent.= "\t\t\t".'<div class="'.$align.' wb_colalign">';
					if(is_array($colsources) && count($colsources) > 0 && isset($colsources['source'.$i]) && $colsources['source'.$i] != '')
						$colcontent.= str_replace(array('<!-- begin_content -->', '<!-- end_content -->'), array('', ''), $colsources['source'.$i]);
					$colcontent.= '</div>'."\n\t\t\t";
				}
				
				$bind = count($classes) > 0 && count($orders) > 0 ? ' ' : '';
				$template.= "\t\t\t".'<div class="'.implode(' ', $classes).$bind.implode(' ', $orders).$colclass.' wb_column">'."\n\t".$colcontent.'</div>'."\n";
			}
			$template.= "\t\t".'</div>'."\n\t".'</div>'."\n".'</div>'."\n";
		}
		
		return $template;
	}
    
    function savecolumnstopage($content, $columns, $index, $pos = false)
    {
		$content = str_replace('&nbsp;', '&amp;nbsp;', $content);
		$content = $this->escapescripts($content);
		$dom = new DomDocument();
		$dom->preserveWhiteSpace = true;
		$dom->formatOutput = false;
		libxml_use_internal_errors(true);
		$dom->loadHTML('<?xml encoding="UTF-8">'.$content);
		libxml_use_internal_errors(false);
		libxml_clear_errors();
		$dom->encoding = 'UTF-8';
		$xpath = new DomXPath($dom);
		$query = "contains(@class, 'wb_baseelement') or contains(@class, 'wb_frameelement') or contains(@class, 'wb_columnselement')";
		if($this->config['insertpoints'] == '1')
			$query.= " or contains(@class, 'wb_menuelement') or contains(@class, 'wb_blockelement')";
		$nodes = $xpath->query("//div[".$query."]");
		
		$columns = str_replace('&nbsp;', '&amp;nbsp;', $columns);
		$columns = $this->escapescripts($columns);
		$temp = new DOMDocument();
		$temp->preserveWhiteSpace = true;
		libxml_use_internal_errors(true);
		$temp->loadHTML('<?xml encoding="UTF-8">'.$columns);
		libxml_use_internal_errors(false);
		libxml_clear_errors();
		$temp->encoding = 'UTF-8';
		$body = $temp->getElementsByTagName('body')->item(0);
		foreach($body->childNodes as $childs) {
			$newnode = $dom->importNode($childs, true);
			break;
		}
		
		if($pos) {
			if($pos == 'before')
				$nodes->item($index)->parentNode->insertBefore($newnode, $nodes->item($index));
			
			if($pos == 'after')
				$nodes->item($index)->parentNode->insertBefore($newnode, $nodes->item($index)->nextSibling);
		}
		else {
			$nodes->item($index)->parentNode->replaceChild($newnode, $nodes->item($index));
		}
		
		$savedbody = $xpath->query('/html/body');
		$result = $dom->saveHTML($savedbody->item(0));
		$result = $this->unescapescripts($result);
		$result = str_replace('&amp;nbsp;', '&nbsp;', $result);
		
        return $result;
    }
    
    function deletecolumnsfrompage($content, $index)
    {
		$content = str_replace('&nbsp;', '&amp;nbsp;', $content);
		$content = $this->escapescripts($content);
		$dom = new DomDocument();
		$dom->preserveWhiteSpace = true;
		$dom->formatOutput = false;
		libxml_use_internal_errors(true);
		$dom->loadHTML('<?xml encoding="UTF-8">'.$content);
		libxml_use_internal_errors(false);
		libxml_clear_errors();
		$dom->encoding = 'UTF-8';
		$xpath = new DomXPath($dom);
		$query = "contains(@class, 'wb_baseelement') or contains(@class, 'wb_frameelement') or contains(@class, 'wb_columnselement')";
		$nodes = $xpath->query("//div[".$query."]");
		
		$nodes->item($index)->parentNode->removeChild($nodes->item($index));
		
		$savedbody = $xpath->query('/html/body');
		$result = $dom->saveHTML($savedbody->item(0));
		$result = $this->unescapescripts($result);
		$result = str_replace('&amp;nbsp;', '&nbsp;', $result);
		
        return $result;
    }
    
    
    // Vorschauen
    function adminpreviewtpl()
    {
        $tplfile = $this->checkfilenamesigns($_GET['tplfile'], 'tpl');
        $incfile = $this->config['server_path'].'/content/layouts/'.$tplfile;
    	if($tplfile != '' && file_exists($incfile))
    	{
            $this->loadcontentpage = file_get_contents($incfile);
            $this->loadcontainer('menu');
            $this->loadcontainer('block');
            
            ob_start();
            $webutlercouple = $this;
    		echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
            
            $this->loadcontentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '${1}'._WBLANGADMIN_ADMINPAGE_LAYOUTPREVIEW_.'$3', $this->loadcontentpage);
            $this->basetohead();
			$this->loadcompressed();
    		$this->rewriting();
            $this->autoheaderdata();
            $this->autofooterdata();
    	}
    	else
    	{
    		$this->errorpage(_WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_);
    	}
    }
    
    function adminpreviewpage()
    {
        $pagefile = $this->pagenamesigns($_GET['pagefile']);
		$incfile = $this->check_temp_fileexists($this->config['server_path'].'/content/pages/'.$pagefile);
		
    	if($pagefile != '' && file_exists($incfile))
    	{
            $this->loadcontentpage = file_get_contents($incfile);
            $this->loadcontainer('menu');
            $this->loadcontainer('block');
            $this->showallparts();
            
            ob_start();
            $webutlercouple = $this;
            $webutlercouple->errorpagetext = _WBLANGADMIN_ADMINPAGE_PREVIEWERRORTEXT_;
    		$showpartfor = array('-1');
    		echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
    		
            if(isset($this->setnewtitlefrommod) && $this->setnewtitlefrommod != '') {
                $this->loadcontentpage = preg_replace('#(<title>)(.*?)(</title>)#Usi', '${1}'.$this->setnewtitlefrommod.'$3', $this->loadcontentpage);
            }
            $this->basetohead();
			$this->loadcompressed();
    		$this->rewriting();
            $this->autoheaderdata();
            $this->autofooterdata();
    	}
    	else
    	{
    		$this->errorpage(_WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_);
    	}
    }
    
    function adminpreviewblock()
    {
        $blockfile = strpos($_GET['blockfile'], '.') ? substr($_GET['blockfile'], 0, strpos($_GET['blockfile'], '.')) : $_GET['blockfile'];
        $ext = strpos($_GET['blockfile'], '.') ? substr($_GET['blockfile'], strpos($_GET['blockfile'], '.')+1) : '';
        $blockfile = $this->filenamesigns($blockfile);
        $ext = $ext != '' ? '.'.$this->filenamesigns($ext) : '';
        $incfile = $this->config['server_path'].'/content/blocks/'.$blockfile.$ext;
		
    	if($blockfile != '' && file_exists($incfile))
    	{
    		$site = $this->htmlsource['page_header'];
        	$site.= '<title>'._WBLANGADMIN_ADMINPAGE_BLOCKPREVIEW_.'</title>'."\n";
			if(isset($this->config['ckeblockbg']) && $this->config['ckeblockbg'] != '' && strlen($this->config['ckeblockbg']) > 2 && strlen($this->config['ckeblockbg']) < 7)
				$site.= '<style tyte="text/css">body{background-color:#'.$this->config['ckeblockbg'].' !important;background-image:url(\'admin/system/images/blank.gif\') !important;}</style>'."\n";
        	$site.= $this->htmlsource['close_page_header'];
            $site.= file_get_contents($incfile);
        	$site.= $this->htmlsource['page_footer'];
    		
            $this->loadcontentpage = $site;
            $this->showallparts();
            
            ob_start();
            $webutlercouple = $this;
    		$showpartfor = array('-1');
            echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
            
            $this->basetohead();
			$this->loadcompressed();
    		$this->rewriting();
            $this->autoheaderdata();
            $this->autofooterdata();
    	}
    	else
    	{
    		$this->errorpage(_WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_);
    	}
    }
    
    function adminpreviewmenu()
    {
        $menufile = strpos($_GET['menufile'], '.') ? substr($_GET['menufile'], 0, strpos($_GET['menufile'], '.')) : $_GET['menufile'];
        $ext = strpos($_GET['menufile'], '.') ? substr($_GET['menufile'], strpos($_GET['menufile'], '.')+1) : '';
        $menufile = $this->filenamesigns($menufile);
        $ext = $ext != '' ? '.'.$this->filenamesigns($ext) : '';
        $incfile = $this->config['server_path'].'/content/menus/'.$menufile.$ext;
		
    	if($menufile != '' && file_exists($incfile))
    	{
    		$site = $this->htmlsource['page_header'];
        	$site.= '<title>'._WBLANGADMIN_ADMINPAGE_MENUPREVIEW_.'</title>'."\n";
			if(isset($this->config['ckemenubg']) && $this->config['ckemenubg'] != '' && strlen($this->config['ckemenubg']) > 2 && strlen($this->config['ckemenubg']) < 7)
				$site.= '<style tyte="text/css">body{background-color:#'.$this->config['ckemenubg'].' !important;background-image:url(\'admin/system/images/blank.gif\') !important;}</style>'."\n";
        	$site.= $this->htmlsource['close_page_header'];
            $site.= file_get_contents($incfile);
        	$site.= $this->htmlsource['page_footer'];
            
            $this->loadcontentpage = $site;
            $this->showallparts();
            
            ob_start();
            $webutlercouple = $this;
    		$showpartfor = array('-1');
            echo eval("?".">".$this->loadcontentpage);
    		$this->loadcontentpage = ob_get_contents();
    		ob_end_clean();
    		
            $this->basetohead();
			$this->loadcompressed();
    		$this->rewriting();
            $this->autoheaderdata();
            $this->autofooterdata();
    		
    	}
    	else
    	{
    		$this->errorpage(_WBLANGADMIN_ADMINPAGE_FILENOTEXISTS_);
    	}
    }
    
    
    // Save
    function iswriteable($path, $ajax = '')
    {
        $abbruch = '';
        $absolutepath = $this->config['server_path'].$path;
        
        if(!is_dir($absolutepath.'/') && !is_writeable($absolutepath))
        {
            $abbruch = ($ajax == '') ? $this->confirmerror(sprintf(_WBLANGADMIN_POPUPWIN_WRITEABLE_FILE_, $path)) : '<span class="red">'.sprintf(_WBLANGADMIN_POPUPWIN_WRITEABLE_FILE_, $path).'</span>';
        }
        elseif(is_dir($absolutepath.'/') && !is_writeable($absolutepath.'/'))
        {
            $abbruch = ($ajax == '') ? $this->confirmerror(sprintf(_WBLANGADMIN_POPUPWIN_WRITEABLE_FOLDER_, $path)) : '<span class="red">'.sprintf(_WBLANGADMIN_POPUPWIN_WRITEABLE_FOLDER_, $path).'</span>';
        }
        
        clearstatcache();
        
        return $abbruch;
    }
    
    function confirmerror($text, $win = '')
    {
        if($win != '')
            $_SESSION['loggedin']['editwinonload'] = $win;
        
    	$error = '<script>'."\n".
            '/* <![CDATA[ */'."\n".
    		'function webutler_error() {'."\n".
    		'	check = confirm(\''.$text.'\');'."\n".
    		'	if(check == false) {'."\n".
    		'		window.location = "'.$this->config['homepage'].'/index.php?wbpagefile='.$this->getpage.'&admintoken='.$_SESSION['admintoken'].'";'."\n".
    		'	} else {'."\n".
    		'		window.location = "'.$this->config['homepage'].'/index.php?wbpagefile='.$this->getpage.'&admintoken='.$_SESSION['admintoken'].'";'."\n".
    		'	}'."\n".
    		'}'."\n".
    		'webutler_error();'."\n".
            '/* ]]> */'."\n".
    		'</script>'."\n";
    	
    	return $error;
    }
    
    function makebakfiles($filename)
    {
        $steps = $this->config['stepsback'];
        if($steps >= 1) {
            $unbak = '';
        	for($i = 0; $i < $steps; $i++) {
            	$unbak.= '.bak';
        	}
        	if(file_exists($filename.$unbak)) {
        		unlink($filename.$unbak);
        	}
            $baks = '';
        	while($steps >= 1) {
                $baks = '';
                for($i = 0; $i < $steps; $i++) {
                    $baks.= '.bak';
                }
            	if(file_exists($filename.$baks)) {
                    copy($filename.$baks, $filename.$baks.".bak");
                    @touch($filename.$baks.".bak", filemtime($filename.$baks));
                    $this->setchmodaftersave($filename.$baks.".bak");
            	}
                $steps--;
        	}
            copy($filename, $filename.".bak");
            @touch($filename.".bak", filemtime($filename));
            $this->setchmodaftersave($filename.".bak");
    	}
    }
    
    function checkbeforebak($str1, $str2)
    {
    	$arr1 = explode("\n", $str1);
    	$arr2 = explode("\n", $str2);
    	
    	$res1 = array();
    	$res2 = array();
    	
    	foreach($arr1 as $arr_1) {
    		$res = trim($arr_1);
    		if(!empty($res))
    			$res1[] = $res;
    	}
    	
    	foreach($arr2 as $arr_2) {
    		$res = trim($arr_2);
    		if(!empty($res))
    			$res2[] = $res;
    	}
    	
    	$imp1 = implode('', $res1);
    	$imp2 = implode('', $res2);
    	
    	return ($imp1 == $imp2) ? '0' : '1';
    }
    
    function savetemp2real($file)
    {
		$this->makebakfiles($file);
        rename($file.'.tmp', $file);
		
		$this->deletetempfiles($file.'.tmp');
    }
    
    function deletetempfiles($filename)
    {
    	$steps = $this->config['stepsback'];
        $bakext = '';
        $i = 0;
    	while($i <= $steps)
    	{
            $bakext.= '.bak';
        	if(file_exists($filename.$bakext)) 
        	{
                unlink($filename.$bakext);
        	}
        	else
        	{
                break;
        	}
            $i++;
    	}
    }
    
    function checkfilenamesigns($filename, $type)
    {
        $result = '';
        
        $extlen = strlen($type);
		if($type != '' && substr($filename, $extlen*(-1), $extlen) == $type) {
            $ext = '.'.$type;
    		$name = substr($filename, 0, strlen($filename)-($extlen+1));
            $name = $this->filenamesigns($name);
            $result = $name.$ext;
        }
        
        return $result;
    }
    
    function getsavelocationurl($file)
    {
        $resurl = '';
        if($this->config['modrewrite'] == '1') {
        	$language = $this->config['languages'] == '1' ? $this->getlangfrompage($file) : false;
			
			$lang = '';
			$startfile = $this->config['startpage'];

			if($language && $language != '' && isset($this->langconf['homes'][$language]) && $this->config['langfolder'] == '1') {
				$startfile = $this->langconf['homes'][$language];
				$lang = $language.'/';
			}
			
            if($file == $startfile) {
                //$resurl = $lang.'index'.$this->config['urlext'];
                $resurl = $lang;
			}
            else {
				$filelang = '';
				if($language && $language != '' && substr($file, 2, 1) == '_' && count($this->langconf) > 0) {
					$fileprefix = substr($file, 0, 2);
					$fileprefix = preg_replace("~[^a-z]~", "", $fileprefix);
					if(strlen($fileprefix) == 2 && in_array($fileprefix, $this->langconf['code'])) {
						$filelang = $fileprefix;
					}
				}
				
				$filename = ($filelang != '') ? substr($file, 3) : $file;
                $resurl = $lang.$this->getdirectoryforpage($file).$filename.$this->config['urlext'];
			}
        }
        else {
            if($file == $this->config['startpage'])
                $resurl = 'index.php';
            else
                $resurl = 'index.php?wbpagefile='.$file;
        }
        
        return $this->config['homepage'].'/'.$resurl;
    }
    
    function validatemail($mail = '')
    {
		if($mail == '') {
			return 'false';
		}
		else {
			$checkedmail = strtolower(trim($mail));
			
			if(!filter_var($checkedmail, FILTER_VALIDATE_EMAIL)) {
				if(function_exists('idn_to_ascii')) {
					$string = explode('@', $checkedmail);
					$checked = $string[0].'@'.idn_to_ascii($string[1]);
					if(!filter_var($checked, FILTER_VALIDATE_EMAIL)) {
						return 'false';
					}
					else {
						return $checked;
					}
				}
				else {
					return 'false';
				}
			}
			else {
				return $checkedmail;
			}
		}
    }
    
    
    // Boxlayer
    
    // Verzeichnisse
    function checknewdirname($dirname)
    {
		$dirs = explode('/', $dirname);
		
		$dirnames = array();
		foreach($dirs as $dir) {
			if(trim($dir) != '')
				$dirnames[] = $this->pagenamesigns($dir);
		}
        
        return implode('/', $dirnames);
    }
    
    function savepagetodir($page, $newdir = '', $olddir = '', $change = false)
    {
        if($newdir == $olddir || ($newdir == '' && $olddir == ''))
            return false;
        
        $values = array();
        foreach($this->directories['pages'] as $dir => $pages) {
            if($dir == $newdir) {
                $pages[] = $page;
            }
            if($olddir != '' && $dir == $olddir) {
                $newpages = array();
                foreach($pages as $p) {
                    if($p != $page)
                        $newpages[] = $p;
                }
                $pages = $newpages;
            }
            $newvals = (count($pages) > 0) ? "'".implode("','", $pages)."'" : '';
        	$values[] = "  '".$dir."' => array(".$newvals.")";
        }
		
		if($olddir != '') {
			if(($key = array_search($page, $this->directories['pages'][$olddir])) !== false) {
				unset($this->directories['pages'][$olddir][$key]);
			}
		}
		
        if($newdir != '') {
			if(!array_key_exists($newdir, $this->directories['pages'])) {
				$values[] = "	'".$newdir."' => array('".$page."')";
				$this->directories['pages'][$newdir] = array($page);
			}
			else {
				$this->directories['pages'][$newdir][] = $page;
			}
		}
		
        $content = "\n".implode(",\n", $values)."\n";
        
        $directoriesfile =  $this->config['server_path'].'/content/access/directories.php';
        
		$file = file_get_contents($directoriesfile);
		$file = preg_replace('#(\$webutler_directories\[\'pages\'\] = array\()([^;]*)(\);)#Usi', '${1}'.$content.'${3}', $file);
        
        file_put_contents($directoriesfile, $file);
		
        $this->setchmodaftersave($directoriesfile);
        
        return $change ? '<span class="green">'._WBLANGADMIN_POPUPWIN_DIRECTORIES_ISSAVED_.'</span>' : '<span class="red">'._WBLANGADMIN_POPUPWIN_DIRECTORIES_NOTSAVED_.'</span>';
    }
    
    // loeschen und umbenennen
    function renamefileinmenus($oldname, $newname = '')
    {
    	$directory = $this->config['server_path'].'/content/menus';
    	$handle = opendir($directory);
    	while(false !== ($file = readdir ($handle))) {
        	if(!is_dir($directory.'/'.$file.'/')) {
        		if($file != '.' && $file != '..' && $file != '.htaccess') {
        			$extension = substr($file, strrpos($file, '.'));
        			$extension = strtolower($extension);
            		if($extension != '.bak') {
        				$menufile = $directory.'/'.$file;
        				$content = file_get_contents($menufile);
                        
                        if(!preg_match('#index\.php\?wbpagefile='.$oldname.'[\"|&|\#]#Usi', $content))
                        {
                            unset($content);
                        }
                        else
                        {
                            $this->makebakfiles($menufile);
                            
                            if($newname != '') {
                                $content = preg_replace('#(href=\"index\.php\?wbpagefile=)('.$oldname.')([\"|&|\#])#Usi', '${1}'.$newname.'${3}', $content);
                            }
                            else {
                                $content = $this->deletelistitem($content, $oldname);
                            }
                            
                            file_put_contents($menufile, $content);
                        	
                            $this->setchmodaftersave($menufile);
                        }
                    }
                }
    		}
    	}
    	closedir($handle);
    }
    
    function changenameinconfigfile($oldname, $newname = '')
    {
        if($oldname == $this->config['startpage'] || $oldname == $this->config['errorpage'])
        {
            $baseconfig = $this->config['server_path'].'/settings/baseconfig.php';
    		$buf = file_get_contents($baseconfig);
            if($newname != '' && $oldname == $this->config['startpage']) {
        		$buf = preg_replace('#(\$webutler_config\[\'startpage\'\] = ")([^"]*)(";)#Usi', '${1}'.$newname.'$3', $buf);
				$this->config['startpage'] = $newname;
			}
            if($oldname == $this->config['errorpage']) {
        		$buf = preg_replace('#(\$webutler_config\[\'errorpage\'\] = ")([^"]*)(";)#Usi', '${1}'.$newname.'$3', $buf);
				$this->config['errorpage'] = $newname;
			}
            
            file_put_contents($baseconfig, $buf);
            $this->setchmodaftersave($baseconfig);
        }
    }
    
    function changenameinofflinefile($oldname, $newname = '')
    {
        $offlinefile = $this->config['server_path'].'/content/access/offline.php';
        if(file_exists($offlinefile) && in_array($oldname, $this->offlinepages))
        {
            $offlines = file_get_contents($offlinefile);
            $newpages = array();
            foreach($this->offlinepages as $page) {
                if($page != $oldname)
                    $newpages[] = $page;
                if($newname != '' && $page == $oldname)
                    $newpages[] = $newname;
            }
            $newvals = (count($newpages) > 0) ? "'".implode("','", $newpages)."'" : '';
            
    		$offlines = preg_replace('#(\$webutler_offlinepages = array\()([^;]*)(\);)#Usi', '${1}'.$newvals.'${3}', $offlines);
			$this->offlinepages = $newpages;
            
            file_put_contents($offlinefile, $offlines);
            $this->setchmodaftersave($offlinefile);
        }
        
        if(file_exists($this->config['server_path'].'/content/access/users.db') && class_exists('SQLite3')) {
            $userdb = new SQLite3($this->config['server_path'].'/content/access/users.db');
            
            $blocks = $userdb->query("SELECT id, pages FROM blocks WHERE blocks.id = '1' LIMIT 1");
        	if($block = $blocks->fetchArray()) {
                $blockedpages = explode(',', $block['pages']);
                if(in_array($oldname, $blockedpages)) {
                    $newpages = array();
                    foreach($blockedpages as $page) {
                        if($page != $oldname)
                            $newpages[] = $page;
                        if($newname != '' && $page == $oldname)
                            $newpages[] = $newname;
                    }
                    $userdb->query("UPDATE blocks SET pages = '".$userdb->escapeString(implode(',', $newpages))."' WHERE blocks.id = '1'");
                    
                    $groups = $userdb->query("SELECT id, pages FROM groups");
                    while($group = $groups->fetchArray()) {
                        $groupid = $group['id'];
                        $grouppages = explode(',', $group['pages']);
                        if(in_array($oldname, $grouppages)) {
                            $newpages = array();
                            foreach($grouppages as $page) {
                                if($page != $oldname)
                                    $newpages[] = $page;
                                if($newname != '' && $page == $oldname)
                                    $newpages[] = $newname;
                            }
                            $userdb->query("UPDATE groups SET pages = '".$userdb->escapeString(implode(',', $newpages))."' WHERE groups.id = '".$userdb->escapeString($groupid)."'");
                        }
                    }
                }
            }
            $userdb->close();
        }
    }
    
    function changenameindirectoriesfile($oldname, $newname = '')
    {
        if($this->config['directories'] == '1' && array_key_exists('pages', $this->directories) && count($this->directories['pages']) > 0)
        {
            $content = '';
            $values = array();
            $newdirs = array();
            foreach($this->directories['pages'] as $dir => $pages) {
                if(in_array($oldname, $pages)) {
                    $newpages = array();
                    foreach($pages as $page) {
                        if($page != $oldname)
                            $newpages[] = $page;
                        if($newname != '' && $page == $oldname)
                            $newpages[] = $newname;
                    }
                    $pages = $newpages;
                }
            	$newdirs[$dir] = $pages;
                $newvals = (count($pages) > 0) ? "'".implode("','", $pages)."'" : '';
            	$values[] = "  '".$dir."' => array(".$newvals.")";
            }
            $content.= "\n".implode(",\n", $values)."\n";
            
            $directoriesfile =  $this->config['server_path'].'/content/access/directories.php';
            
    		$file = file_get_contents($directoriesfile);
    		$file = preg_replace('#(\$webutler_directories\[\'pages\'\] = array\()([^;]*)(\);)#Usi', '${1}'.$content.'${3}', $file);
			$this->directories['pages'] = $newdirs;
            
            file_put_contents($directoriesfile, $file);
            $this->setchmodaftersave($directoriesfile);
        }
    }
    
    function changenameinlanguagefile($oldname, $newname = '')
    {
        if($this->config['languages'] == '1' && array_key_exists('pages', $this->langconf) && count($this->langconf['code']) > 0)
        {
            $langfile = $this->config['server_path'].'/content/access/languages.php';
            $langconfig = file_get_contents($langfile);
            
			if(in_array($oldname, $this->langconf['homes'])) {
				$newhomes = array();
				foreach($this->langconf['homes'] as $lang => $file) {
					if(($file == $oldname && $newname != '') || $file != $oldname) {
						$newhome = $file == $oldname ? $newname : $file;
						$this->langconf['homes'][$lang] = $newhome;
						$newhomes[] = "'".$lang."' => '".$newhome."'";
					}
				}
                $langconfig = preg_replace('#(\$webutler_langconf\[\'homes\'\] = array\()([^\)]*)(\);\n)#Usi', '${1}'.implode(', ', $newhomes).'$3', $langconfig);
			}
			
            foreach($this->langconf['pages'] as $lang => $files) {
                if(in_array($oldname, $files)) {
                    $newpages = array();
                    foreach($files as $file) {
                        if($file != $oldname)
                            $newpages[] = $file;
                        if($newname != '' && $file == $oldname)
                            $newpages[] = $newname;
                    }
                    
                    $pages = "'".implode("','", $newpages)."'";
                    $langconfig = preg_replace('#(\$webutler_langconf\[\'pages\'\]\[\''.$lang.'\'\] = array\()([^\)]*)(\);\n)#Usi', '${1}'.$pages.'$3', $langconfig);
					$this->langconf['pages'][$lang] = $newpages;
                }
            }
			
			if(array_key_exists('relations', $this->langconf)) {
				$relations = array();
				$rels = array();
				foreach($this->langconf['relations'] as $key => $relation)
				{
					$isin = in_array($oldname, $relation) ? true : false;
					$relarr = array();
					$newrel = array();
					foreach($relation as $lang => $page)
					{
						if(!$isin) {
							$relarr[$lang] = $page;
							$newrel[] = addslashes("'".$lang."' => '".$page."'");
						}
						else {
							if($newname != '') {
								$relpage = $page == $oldname ? $newname : $page;
								$relarr[$lang] = $relpage;
								$newrel[] = addslashes("'".$lang."' => '".$relpage."'");
							}
						}
					}
					if(count($relarr) > 0 && count($newrel) > 0) {
						$relations[] = $relarr;
						$rels[] = "\t".'array('.stripslashes(implode(', ', $newrel)).')';
					}
				}
				
				$langconfig = preg_replace('#(\$webutler_langconf\[\'relations\'\] = array\()(.*)(\);)#Usi', '${1}'."\n".implode(",\n", $rels)."\n".'$3', $langconfig);
				$this->langconf['relations'] = $relations;
			}
            
            file_put_contents($langfile, $langconfig);
            $this->setchmodaftersave($langfile);
        }
    }
    
    // Link Highlite
    function savehighlitelinks()
    {
        $i = 0;
        $hlfiles = array();
        foreach($this->linkhighlite['files'] as $key => $hlfile) {
			$hlfile[2] = isset($hlfile[2]) ? $hlfile[2] : 'no';
    		$hlfiles[] = "   ".$i." => array('".$hlfile[0]."','".$hlfile[1]."','".$hlfile[2]."')";
            $i++;
        }
        
        $k = 0;
        $hlfolders = array();
        foreach($this->linkhighlite['folders'] as $key => $hlfolder) {
			$hlfolder[3] = isset($hlfolder[3]) ? $hlfolder[3] : 'no';
    		$hlfolders[] = "   ".$k." => array('".$hlfolder[0]."','".$hlfolder[1]."','".$hlfolder[2]."','".$hlfolder[3]."')";
            $k++;
        }
        
		$config = "<?PHP\n\n";
		$config.= "\$webutler_linkhighlite['files'] = array(\n";
        $config.= implode(",\n", $hlfiles)."\n";
		$config.= ");\n\n";
		$config.= "\$webutler_linkhighlite['folders'] = array(\n";
        $config.= implode(",\n", $hlfolders)."\n";
		$config.= ");\n\n";
        
        $file = $this->config['server_path'].'/content/access/linkhighlite.php';
        
        file_put_contents($file, $config);
		
        $this->setchmodaftersave($file);
    }
    
    // Languages
    function setpagetolang($page, $lang)
    {
        if($this->config['languages'] == '1' && array_key_exists('pages', $this->langconf))
        {
            $this->langconf['pages'][$lang][] = $page;
            $newvals = $this->langconf['pages'][$lang];
            $pages = (count($newvals) > 0) ? "'".implode("','", $newvals)."'" : '';
            $langfile = $this->config['server_path'].'/content/access/languages.php';
            $langconfig = file_get_contents($langfile);
            $langconfig = preg_replace('#(\$webutler_langconf\[\'pages\'\]\[\''.$lang.'\'\] = array\()([^\)]*)(\);\n)#Usi', '${1}'.$pages.'$3', $langconfig);
            
            file_put_contents($langfile, $langconfig);
    		
            $this->setchmodaftersave($langfile);
        }
    }
    
    function delpagefromlang($page)
    {
        if($this->config['languages'] == '1' && array_key_exists('pages', $this->langconf))
        {
            $langfile = $this->config['server_path'].'/content/access/languages.php';
            $langconfig = file_get_contents($langfile);
            $save = false;
            
			if(in_array($page, $this->langconf['homes'])) {
				$save = true;
				
				$newhomes = array();
				foreach($this->langconf['homes'] as $code => $file) {
					if($file != $page)
						$newhomes[] = addslashes("'".$code."' => '".$file."'");
				}
				$homes = stripslashes(implode(',', $newhomes));
				
				$langconfig = preg_replace('#(\$webutler_langconf\[\'homes\'\] = array\()([^\)]*)(\);)#Usi', '${1}'.$homes.'$3', $langconfig);
			}
			
            foreach($this->langconf['code'] as $code) {
                if(in_array($page, $this->langconf['pages'][$code])) {
                    $num = array_search($page, $this->langconf['pages'][$code]);
                    unset($this->langconf['pages'][$code][$num]);
                    $newvals = $this->langconf['pages'][$code];
                    $pages = (count($newvals) > 0) ? "'".implode("','", $newvals)."'" : '';
                    $langconfig = preg_replace('#(\$webutler_langconf\[\'pages\'\]\[\''.$code.'\'\] = array\()([^\)]*)(\);\n)#Usi', '${1}'.$pages.'$3', $langconfig);
                    
                    $save = true;
                    break;
                }
            }
			
			if(array_key_exists('relations', $this->langconf)) {
				$rels = array();
				foreach($this->langconf['relations'] as $key => $relation)
				{
					if(in_array($page, $relation)) {
						$save = true;
					}
					else {
						$oldrel = array();
						foreach($relation as $code => $page)
						{
							$oldrel[] = addslashes("'".$code."' => '".$page."'");
						}
						$rels[] = "\t".'array('.stripslashes(implode(', ', $oldrel)).')';
					}
				}
				
				$langconfig = preg_replace('#(\$webutler_langconf\[\'relations\'\] = array\()(.*)(\);)#Usi', '${1}'."\n".implode(",\n", $rels)."\n".'$3', $langconfig);
			}
            
            if(!$save) {
                unset($langconfig);
            }
			else {
				file_put_contents($langfile, $langconfig);
				$this->setchmodaftersave($langfile);
			}
        }
    }
    
    // Offlinepages
    function setpageto_offlinearray($page)
    {
        if(!in_array($page, $this->offlinepages))
        {
            $this->offlinepages[] = $page;
            $this->savepagesto_offlinearray($this->offlinepages);
        }
    }
    
    function delpagefrom_offlinearray($page)
    {
        if(in_array($page, $this->offlinepages))
        {
        	foreach ($this->offlinepages as $offlinepage)
        	{
                if($offlinepage != $page) {
                    $newofflinepages[] = $offlinepage;
                }
        	}
            $this->savepagesto_offlinearray($newofflinepages);
        }
    }
    
    function savepagesto_offlinearray($array)
    {
        $iswriteable = $this->iswriteable('/content/access/offline.php');
        if($iswriteable != '')
        {
            echo $iswriteable;
            exit;
        }
        
        $offlinefile = $this->config['server_path']."/content/access/offline.php";
        $arraywerte = array();
        
        for($i = 0; $i < count($array); $i++)
        {
            $arraywerte[] = '\''.$array[$i].'\'';
        }
        
    	$config = "<?PHP\n\n";
    	$config.= "\$webutler_offlinepages = array(".(count($arraywerte) > 0 ? implode(',', $arraywerte) : '').");\n\n";
        
        file_put_contents($offlinefile, $config);
    }
    
    // Formulare
    function getformfieldname($input)
    {
        if($input == 'empfaenger')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_RECEIVER_;
        elseif($input == 'empfaengermail')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_MAILADDRESS_;
        elseif($input == 'empfaengername')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_SHIPPER_;
        elseif($input == 'empfaengerbetreff')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_SUBJECT_;
        elseif($input == 'bestaetigung')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_CONFIRM_;
        elseif($input == 'bestaetigungsbetreff')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_CONFIRMSUB_;
        elseif($input == 'sentalert')
            $output = _WBLANGADMIN_WIN_FORMS_INPUT_SENTALERT_;
        
        return $output;
    }
    
    function saveaddresses()
    {
        $langs = ($this->config['languages'] == '1' && array_key_exists('code', $this->langconf) && count($this->langconf['code']) > 0) ? $this->langconf['code'] : '';
        $addressesfile = $this->config['server_path'].'/content/access/mailaddresses.php';
        ksort($this->mailaddresses, SORT_REGULAR);
        
    	$config = "<?PHP\n\n";
		$config.= "\$webutler_mailaddresses = array(";
		
		$addresses = array();
        foreach($this->mailaddresses as $element => $sendto)
        {
			$address = "\t'".$element."' => array(\n";
			$name_values = array();
            foreach($sendto as $name => $value)
            {
            	if(($name == 'bestaetigungsbetreff' || $name == 'sentalert') && is_array($langs)) {
					$langval = "\t\t'".$name."' => array(\n";
					$lang_values = array();
                    foreach($langs as $lang) {
                        $_value = (!is_array($value)) ? $value : $value[$lang];
						$lang_values[] = "\t\t\t'".$lang."' => '".$_value."'";
                    }
					$langval.= implode(",\n", $lang_values)."\n";
					$langval.= "\t\t)";
					
					$name_values[] = $langval;
            	}
            	else {
                    if(($name == 'bestaetigungsbetreff' || $name == 'sentalert') && is_array($value)) $value = $value[$this->config['defaultlang']];
					$name_values[] = "\t\t'".$name."' => '".$value."'";
                }
        	}
			$address.= implode(",\n", $name_values)."\n";
			$address.= "\t)";
			
			$addresses[] = $address;
    	}
		
    	$config.= count($addresses) > 0 ? "\n".implode(",\n", $addresses)."\n" : '';
        $config.= ");\n";
        
        file_put_contents($addressesfile, $config);
    }
    
    
    // Module
    function getmodulesloginlang($modname, $adminlang)
    {
    	$langvars = array();
		if(count($this->config['enabled_adminlangs']) > 1) {
			foreach($this->config['enabled_adminlangs'] as $lang)
			{
				$langvar = '<div class="editorlangs" title="'.$this->langconf['lang'][$lang].'">'."\n";
				$langvar.= '<input type="radio" name="'.$modname.'lang" id="'.$lang.'" value="'.$lang.'"';
				if($lang == $adminlang)
					$langvar.= ' checked="checked"';
				$langvar.= ' onclick="submit()" />'."\n";
				$langvar.= '<label for="'.$lang.'">';
				if(file_exists($this->config['server_path'].'/includes/language/icons/'.$lang.'.png'))
					$langvar.= '<img src="'.$this->config['homepage'].'/includes/language/icons/'.$lang.'.png" />';
				else
					$langvar.= '<div class="editorlangflag">'.$lang.'</div>';
				$langvar.= '</label>'."\n";
				$langvar.= '</div>'."\n";
				$langvars[$lang] = $langvar;
			}
		}
		else {
			$lang = $this->config['enabled_adminlangs'][0];
			$langvars[$lang] = '<input type="hidden" name="'.$modname.'lang" value="'.$lang.'" />';
		}
		/*
        if(count($this->langconf) > 0 && array_key_exists('code', $this->langconf)) {
            foreach($this->langconf['code'] as $lang) {
    	        $langvar = '<div class="editorlangs" title="'.$this->langconf['lang'][$lang].'">'."\n";
    			$langvar.= '<input type="radio" name="'.$modname.'lang" id="'.$lang.'" value="'.$lang.'"';
    			if($lang == $adminlang)
    				$langvar.= ' checked="checked"';
    			$langvar.= ' onclick="submit()" />'."\n";
    	        $langvar.= '<label for="'.$lang.'">';
    	        if(file_exists($this->config['server_path'].'/includes/language/icons/'.$lang.'.png'))
    	            $langvar.= '<img src="'.$this->config['homepage'].'/includes/language/icons/'.$lang.'.png" />';
    	        else
    	            $langvar.= '<div class="editorlangflag">'.$lang.'</div>';
    	        $langvar.= '</label>'."\n";
    	        $langvar.= '</div>'."\n";
    	        $langvars[$lang] = $langvar;
            }
        }
		*/
        
        return $langvars;
    }
    
    function getmodulesheadermenu($modname, $adminlang)
    {
        $result = '';
        $modlines = '';
	    if(count($this->moduleslist) >= 2)
		{
		    $menu = array();
			foreach($this->moduleslist as $module) {
				if((isset($module[2]) && $module[2] != '-') || $this->checkadmin()) {
                    if(!preg_match('#\/'.(strtolower($modname)).'\/?#Usi', $module[1])) {
						$modpath = $module[1];
						if(substr($modpath, 0, 1) != '/') $modpath = '/'.$modpath;
    		    		$menu[] = '<li>'."\n".
    		    		'	<a href="'.$this->config['homepage'].'/modules'.$modpath.'?admintoken='.$_SESSION['admintoken'].'">'.$module[0].'</a> &raquo;'."\n".
    		    		'</li>';
                    }
	    		}
			}
			if(count($menu) >= 1) {
				$modlines.= '<ul>'."\n";
				$modlines.= implode("\n", $menu);
				$modlines.= '</ul>'."\n";
			}
		}
    	
    	$langvars = $this->getmodulesloginlang($modname, $adminlang);
    	
    	if(count($langvars) >= 2 || $modlines != '') {
    		$result.= '<table width="100%" border="0" cellspacing="0" cellpadding="0">'."\n";
    		$result.= '<tr>'."\n";
    		if(count($langvars) > 1) {
    			$result.= '<td id="changelang">'."\n";
    			$result.= '<form action="admin.php'.($_SERVER['QUERY_STRING'] ? '?'.$_SERVER['QUERY_STRING'] : '').'" method="post">'."\n";
    			foreach($langvars as $langvar) {
    				$result.= $langvar;
    			}
    			$result.= '</form>'."\n";
    			$result.= '</td>'."\n";
    		}
    		if($modlines != '') {
    			$result.= '<td id="moduleslinks">'."\n";
    			$result.= $modlines;
    			$result.= '</td>'."\n";
    		}
    		$result.= '</tr>'."\n";
    		$result.= '</table>'."\n";
    	}
    	
    	return $result;
    }
}





